BeginPackage["LieAnalysis`Ultilities`"];



	Begin["`Private`"];

		
		Options[LieAnalysis] = {
			"DynamicUpdates"->False,
			"UseCUDA"->False
		};
		
		LieAnalysis["Version"] := $LieAnalysisVersion;
		
		

		(* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *)
		(* $LieAnalysisVersion - - - - - - - - - - - - - - - - - - - *)
		(* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *)



		$LieAnalysisVersion := First["Version" /. PacletManager`PacletInformation[PacletManager`PacletFind["LieAnalysis"]]];
		


		(* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *)
		(* EmbedLieAnalysisPackage - - - - - - - - - - - - - - - - - *)
		(* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *)



		(*DONOTINCLUDEINEMBEDDEDVERSION*)
		EmbedLieAnalysisPackage[]:= Module[

			{prevDir,path,packageFiles,order,txtFiles,txt},

			(* Store the previous folder *)
			prevDir = Directory[];

			(* Get The M file-names of the package *)
			path = FileNameTake[FindFile["LieAnalysis`"], {1, -3}];
			SetDirectory[path];
			packageFiles = FileNameJoin[{path, #}] & /@ Join[FileNames["*.m", "*", Infinity],FileNames["*.m"]];

			(* Remove the init file as it is no longer required *)
			packageFiles = DeleteCases[packageFiles, _?(StringMatchQ[#, "*init.m"] &)];

			(* Order the files *)
 	 		order = Reverse[Flatten[StringCases[$ContextPath,"LieAnalysis`"~~___]]];
 	 		order = PrependTo[order, "Classes`"];
  			order = StringRiffle[#,"\\"]&/@StringSplit[order,"`"];
      		packageFiles = Flatten[StringCases[packageFiles,___~~# <> ".m"]&/@order];

			(* Copy the m-files into the temporary folder as txt files *)
			SetDirectory[$TemporaryDirectory];
			txtFiles = CopyFile[#,StringJoin @@ (FileNameSplit[#][[2;;-2]])<>FileBaseName[FileNameTake[#]]<>".txt", OverwriteTarget->True]&/@packageFiles;

			(* Create Chapter cell to bring the package under *)
			CellPrint[TextCell["LieAnalysis Package","Chapter"]];

			(* Include the references *)
			SetDirectory[path];
      		CellPrint@NotebookImport[FindFile["LiteratureList.nb"], _ -> "Cell"];

			(* Import the .m files *)
			txt = Import[#]&/@txtFiles;

			(* Remove Functions that need to be excluded *)
			txt = StringReplace[#, "StringReplace[#, \"(*"~~Shortest[___]~~"*)\" ~~ Shortest[___] ~~ \"(*"~~Shortest[___]~~"*)\"(* embed-fix *) -> \"\"]&/@txt"->"txt (* embed-fix *)"]&/@txt;
			txt = StringReplace[#, "(*DONOTINCLUDEINEMBEDDEDVERSION*)" ~~ Shortest[___] ~~ "(*ENDEXCLUSIONFROMEMBEDDEDVERSION*)"(* embed-fix *) -> ""]&/@txt;

			(* Print them to the notebook *)
			PrintCellTemplate[#[[1]],FileNameTake[#[[2]]]]&/@Transpose[{txt,packageFiles}];

			(* Restore previous dir *)
			SetDirectory[prevDir];
		];
		PrintCellTemplate[txt_,filename_]:=Module[{},
			CellPrint[TextCell[filename, "Subchapter"]];
			CellPrint[Cell[BoxData[txt], "Code"]];
		];
		(*ENDEXCLUSIONFROMEMBEDDEDVERSION*)
	
	
	End[];
	
	

EndPackage[];

  