(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     19268,        551]
NotebookOptionsPosition[     13281,        435]
NotebookOutlinePosition[     15049,        477]
CellTagsIndexPosition[     15006,        474]
WindowTitle->LieAnalysis Package
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["LIE ANALYSIS GUIDE", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Functions",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"Functions", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"CakeWaveletStack\"\>":>
       Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/CakeWaveletStack"], \
"\<\"CakeWaveletStack3D\"\>":>Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/CakeWaveletStack3D"], "\<\"GaborWaveletStack\"\
\>":>Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/GaborWaveletStack"], "\<\"GlyphPlot\"\>":>
       Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/GlyphPlot"], \
"\<\"InverseOrientationScoreTransform\"\>":>Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/InverseOrientationScoreTransform"], \
"\<\"InverseOrientationScoreTransform3D\"\>":>Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/InverseOrientationScoreTransform3D"], \
"\<\"LeftInvariantDerivatives\"\>":>Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/LeftInvariantDerivatives"], \
"\<\"LeftInvariantDerivatives3D\"\>":>Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/LeftInvariantDerivatives3D"], \
"\<\"MultiScaleCakeWaveletStack\"\>":>Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/MultiScaleCakeWaveletStack"], \
"\<\"OrientationScoreGaugeFrames\"\>":>Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/OrientationScoreGaugeFrames"], \
"\<\"OrientationScoreGaugeFrames3D\"\>":>Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/OrientationScoreGaugeFrames3D"], \
"\<\"OrientationScoreTensor\"\>":>Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/OrientationScoreTensor"], \
"\<\"OrientationScoreTransform\"\>":>Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/OrientationScoreTransform"], \
"\<\"OrientationScoreTransform3D\"\>":>Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/OrientationScoreTransform3D"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"GuideFunction"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->
         False], {"\<\"LieAnalysis/guide/Working with the LieAnalysis Package\
\"\>":>None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["LieAnalysis/guide/Working with the LieAnalysis Package"]}, 
            Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/LieAnalysis/guide/\
Working with the LieAnalysis Package.html"], StandardForm]], "Input", 
              TextClipboardType -> "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$8032], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "LieAnalysis/guide/Working with the LieAnalysis Package", 
             ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["LieAnalysis Package", "GuideTitle",
 CellID->942062912],

Cell["\<\
The Lie Analysis package contains functions to compute Orientation Scores \
from 2D and 3D images. \
\>", "GuideAbstract",
 CellID->2001916300]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]]],
 "Reference"
}], "GuideReferenceSection",
 WholeCellGroupOpener->True],

Cell["", "SectionHeaderSpacer"],

Cell[CellGroupData[{

Cell["Orientation Scores from 2D images", "GuideFunctionsSubsection",
 CellID->802025934],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["CakeWaveletStack"]],"paclet:LieAnalysis/ref/CakeWaveletStack"},
   
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " Creates a Cake Wavelets stack for 2D images"
}], "GuideText",
 CellID->203374175],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["GaborWaveletStack"]],
    "paclet:LieAnalysis/ref/GaborWaveletStack"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " Creates a Gabor Wavelet stack for 2D images"
}], "GuideText",
 CellID->1463276848],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MultiScaleCakeWaveletStack"]],
    "paclet:LieAnalysis/ref/MultiScaleCakeWaveletStack"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " Creates a Multi-scale Cake Wavelet stack"
}], "GuideText",
 CellID->18488258],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreTransform"]],
    "paclet:LieAnalysis/ref/OrientationScoreTransform"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " Computes Orientation Scores from a 2D image"
}], "GuideText",
 CellID->92745025],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["LeftInvariantDerivatives"]],
    "paclet:LieAnalysis/ref/LeftInvariantDerivatives"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 "  Computes Left Invariant Derivatives from orientation score"
}], "GuideText",
 CellID->1449487],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreTensor"]],
    "paclet:LieAnalysis/ref/OrientationScoreTensor"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " Computes the derivative tensor from Orientation Score"
}], "GuideText",
 CellID->414042775],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["InverseOrientationScoreTransform"]],
    "paclet:LieAnalysis/ref/InverseOrientationScoreTransform"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " Applies reconstruction to the Orientation Score "
}], "GuideText",
 CellID->157118716],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreGaugeFrames"]],
    "paclet:LieAnalysis/ref/OrientationScoreGaugeFrames"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " Computes the data-adaptive frame from an Orientation Score "
}], "GuideText",
 CellID->493758165]
}, Open  ]],

Cell["\t", "GuideDelimiterSubsection",
 CellID->842317753],

Cell[CellGroupData[{

Cell["Orientation Scores from 3D images", "GuideFunctionsSubsection",
 CellID->276469],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["CakeWaveletStack3D"]],
    "paclet:LieAnalysis/ref/CakeWaveletStack3D"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " Creates a Cake Wavelet stack for 3D images"
}], "GuideText",
 CellID->266022647],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreTransform3D"]],
    "paclet:LieAnalysis/ref/OrientationScoreTransform3D"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " Computes Orientation Scores from a 3D image"
}], "GuideText",
 CellID->596325382],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["LeftInvariantDerivatives3D"]],
    "paclet:LieAnalysis/ref/LeftInvariantDerivatives3D"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " Computes Left-Invariant Derivatives from orientation scores"
}], "GuideText",
 CellID->797532082],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreTensor"]],
    "paclet:LieAnalysis/ref/OrientationScoreTensor"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " Computes the derivative tensor from Orientation Score"
}], "GuideText",
 CellID->9007136],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["InverseOrientationScoreTransform3D"]],
    "paclet:LieAnalysis/ref/InverseOrientationScoreTransform3D"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " Applies reconstruction to the Orientation Score"
}], "GuideText",
 CellID->325057412],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreGaugeFrames3D"]],
    "paclet:LieAnalysis/ref/OrientationScoreGaugeFrames3D"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " Computes the data-adaptive frame from an Orientation Score "
}], "GuideText",
 CellID->599229985],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["GlyphPlot"]],"paclet:LieAnalysis/ref/GlyphPlot"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " Glyph visualization for position orientation data"
}], "GuideText",
 CellID->235450979]
}, Open  ]],

Cell[CellGroupData[{

Cell["Other", "GuideFunctionsSubsection",
 CellID->592271877],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreData"]],
    "paclet:LieAnalysis/ref/OrientationScoreData"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " Provides example data used to test / examine the Lie Package"
}], "GuideText",
 CellID->901662589],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["$LieAnalysisVersion"]],
    "paclet:LieAnalysis/ref/$LieAnalysisVersion"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " Symbol that stores the current version of the package"
}], "GuideText",
 CellID->239425687]
}, Open  ]],

Cell["", "SectionFooterSpacer"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]]],
 "Tutorials"
}], "GuideTutorialsSection",
 WholeCellGroupOpener->True,
 CellID->415694126],

Cell["", "SectionHeaderSpacer"],

Cell[TextData[ButtonBox["Basic Usage",
 BaseStyle->"Link",
 ButtonData->"paclet:LieAnalysis/tutorial/BasicUsage"]], "GuideText",
 CellID->101588035],

Cell["", "SectionFooterSpacer"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]]],
 "Related Links"
}], "GuideRelatedLinksSection",
 WholeCellGroupOpener->True,
 CellID->415694148],

Cell["", "SectionHeaderSpacer"],

Cell["http://ww.lieanalysis.nl", "GuideRelatedLinks",
 CellID->178780435]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"LieAnalysis Package",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "GuideColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Wolfram Language", ButtonData -> "paclet:guide/WolframRoot", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "ExampleCounter" -> 1, "NeedPlatMsgIn" -> None, "RootCaptions" -> 
  "", "Metadata" -> {
   "built" -> "{2017, 10, 26, 15, 6, 44.2549510}", 
    "history" -> {"0.2", "", "", ""}, "context" -> "LieAnalysis`", 
    "keywords" -> {
     "Lie Analysis", "Overview", "Cake Wavelets", "Gabor Wavelets", 
      "Orientation Scores", "Orientation Score Derivatives"}, 
    "specialkeywords" -> {}, "tutorialcollectionlinks" -> {}, "index" -> True,
     "label" -> "Lie Analysis Guide", "language" -> "en", "paclet" -> 
    "LieAnalysis", "status" -> "None", "summary" -> 
    "The Lie Analysis package contains functions to compute Orientation \
Scores from 2D and 3D images. ", "synonyms" -> {}, "tabletags" -> 
    DocumentationBuild`Make`Private`tabletaggingrules$7948, "title" -> 
    "LieAnalysis Package", "titlemodifier" -> "", "windowtitle" -> 
    "LieAnalysis Package", "type" -> "Guide", "uri" -> 
    "LieAnalysis/guide/Working with the LieAnalysis Package"}},
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->FrontEnd`FileName[{"Wolfram"}, "Reference.nb", 
  CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[591, 21, 4814, 104, 70, "AnchorBarGrid",ExpressionUUID->"f1be4597-96b6-4d64-89e1-673612d550b4",
 CellID->1],
Cell[CellGroupData[{
Cell[5430, 129, 61, 1, 70, "GuideTitle",ExpressionUUID->"f2053bc5-6806-4854-90df-b2d0fef51cd6",
 CellID->942062912],
Cell[5494, 132, 153, 4, 70, "GuideAbstract",ExpressionUUID->"4156137b-f559-4313-803c-d95c140c02e5",
 CellID->2001916300]
}, Open  ]],
Cell[CellGroupData[{
Cell[5684, 141, 137, 6, 70, "GuideReferenceSection",ExpressionUUID->"e2a9574c-f063-4b9b-bb6f-d736b61f2417"],
Cell[5824, 149, 31, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"72a39c3e-a239-4c58-be73-a8ac43f4fe39"],
Cell[CellGroupData[{
Cell[5880, 153, 89, 1, 70, "GuideFunctionsSubsection",ExpressionUUID->"2360d84e-ea8a-4d43-b81c-57cdfb970c92",
 CellID->802025934],
Cell[5972, 156, 341, 11, 70, "GuideText",ExpressionUUID->"77804e9a-65ed-4a58-87ef-8cb418fb1171",
 CellID->203374175],
Cell[6316, 169, 345, 11, 70, "GuideText",ExpressionUUID->"133f2408-f366-4130-92af-daa28c905b7b",
 CellID->1463276848],
Cell[6664, 182, 358, 11, 70, "GuideText",ExpressionUUID->"3b889223-795e-4dbf-8259-61cae06b7663",
 CellID->18488258],
Cell[7025, 195, 359, 11, 70, "GuideText",ExpressionUUID->"1d4ef82a-a84b-445d-889d-9e86e62113a2",
 CellID->92745025],
Cell[7387, 208, 372, 11, 70, "GuideText",ExpressionUUID->"64e9b993-48c7-4757-b82a-3fcf5e875c49",
 CellID->1449487],
Cell[7762, 221, 364, 11, 70, "GuideText",ExpressionUUID->"8b00dbe5-02e9-4468-bd95-cbba94cd3647",
 CellID->414042775],
Cell[8129, 234, 379, 11, 70, "GuideText",ExpressionUUID->"1c14952f-3565-4cf4-8e9f-21366695aa4b",
 CellID->157118716],
Cell[8511, 247, 380, 11, 70, "GuideText",ExpressionUUID->"d8e3112e-95fe-4599-afe3-fe71ad557aa7",
 CellID->493758165]
}, Open  ]],
Cell[8906, 261, 58, 1, 70, "GuideDelimiterSubsection",ExpressionUUID->"db40ad9d-eba7-43d5-8a39-dc2d76c5b34e",
 CellID->842317753],
Cell[CellGroupData[{
Cell[8989, 266, 86, 1, 70, "GuideFunctionsSubsection",ExpressionUUID->"5e5fa83b-56f4-4b5a-bb36-5d3267a91309",
 CellID->276469],
Cell[9078, 269, 345, 11, 70, "GuideText",ExpressionUUID->"6162ded5-2644-461b-9dd9-1835fd33b7b6",
 CellID->266022647],
Cell[9426, 282, 364, 11, 70, "GuideText",ExpressionUUID->"d898e337-233a-4523-b82e-9f6cae78c480",
 CellID->596325382],
Cell[9793, 295, 378, 11, 70, "GuideText",ExpressionUUID->"b5490a8d-4124-4740-a619-347bda38e734",
 CellID->797532082],
Cell[10174, 308, 362, 11, 70, "GuideText",ExpressionUUID->"9449e158-4a5b-41be-ba3f-0fa610fa73ba",
 CellID->9007136],
Cell[10539, 321, 382, 11, 70, "GuideText",ExpressionUUID->"78c98a48-28dd-46e5-90e4-6d39db44c911",
 CellID->325057412],
Cell[10924, 334, 384, 11, 70, "GuideText",ExpressionUUID->"8a508b5c-21c3-4624-9d51-8e4895985bc1",
 CellID->599229985],
Cell[11311, 347, 329, 10, 70, "GuideText",ExpressionUUID->"0371017c-35a6-4505-b2c4-fab0b3b851be",
 CellID->235450979]
}, Open  ]],
Cell[CellGroupData[{
Cell[11677, 362, 61, 1, 70, "GuideFunctionsSubsection",ExpressionUUID->"b66704c8-86f0-47f0-acbf-ff563e9076a6",
 CellID->592271877],
Cell[11741, 365, 367, 11, 70, "GuideText",ExpressionUUID->"eec386ee-2a40-4b24-bab8-9fe4aefd3552",
 CellID->901662589],
Cell[12111, 378, 358, 11, 70, "GuideText",ExpressionUUID->"c8d9caea-f918-4a91-9b88-62801236e3aa",
 CellID->239425687]
}, Open  ]],
Cell[12484, 392, 31, 0, 70, "SectionFooterSpacer",ExpressionUUID->"e518f320-bf79-42b2-97ba-3d452af8c762"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12552, 397, 157, 7, 70, "GuideTutorialsSection",ExpressionUUID->"a66f5537-d552-42bc-a94b-bed955883e03",
 CellID->415694126],
Cell[12712, 406, 31, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"1365e882-c22a-4dfc-a778-ced0ba188565"],
Cell[12746, 408, 148, 3, 70, "GuideText",ExpressionUUID->"f2c7df7f-0c42-4591-bf37-ca2c99885f60",
 CellID->101588035],
Cell[12897, 413, 31, 0, 70, "SectionFooterSpacer",ExpressionUUID->"506445b8-9731-4fd9-a6c6-9abd73e44a75"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12965, 418, 164, 7, 70, "GuideRelatedLinksSection",ExpressionUUID->"033163e8-d770-4007-8131-cdd66aabbdff",
 CellID->415694148],
Cell[13132, 427, 31, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"1e985c06-67bd-4d07-9403-50475f0e71ce"],
Cell[13166, 429, 73, 1, 70, "GuideRelatedLinks",ExpressionUUID->"85427e5a-f275-4684-bd7d-8efe4c2078eb",
 CellID->178780435]
}, Open  ]],
Cell[13254, 433, 23, 0, 70, "FooterCell",ExpressionUUID->"9d31d4f1-a0f1-4caf-b2d6-12b1340bf7e7"]
}
]
*)

(* End of internal cache information *)
