(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     16598,        439]
NotebookOptionsPosition[     11358,        322]
NotebookOutlinePosition[     13610,        380]
CellTagsIndexPosition[     13525,        375]
WindowTitle->$LieAnalysisVersion
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["LIE ANALYSIS SYMBOL", "PacletNameCell",ExpressionUUID->
     "21206ac3-316f-465e-a937-f09f03af38bd"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"2a950dd3-d112-4196-8c99-dc58689c6142"],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"LieAnalysis\"\>":>
       Documentation`HelpLookup["paclet:LieAnalysis/ref/LieAnalysis"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "ff8304e8-479c-4efa-a886-7400be90eb16"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Related Guides",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"2ab651ac-b990-4846-9aa9-9cb29b680da0"],
         TextCell[
          Row[{"Related Guides", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"LieAnalysis Package\"\>":>
       Documentation`HelpLookup["paclet:LieAnalysis/guide/LieAnalysis"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAbout"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "55c6b070-75d1-4d86-bba2-bceeec10694a"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"d03348c7-1598-4208-865a-1f9856782605"],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"LieAnalysis/ref/$LieAnalysisVersion\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["LieAnalysis/ref/$LieAnalysisVersion"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/LieAnalysis/ref/$\
LieAnalysisVersion.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$19290], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "LieAnalysis/ref/$LieAnalysisVersion", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "7b9b89fa-35eb-4c17-8f62-0bad79d3860c"]
    }], "AnchorBar",ExpressionUUID->"504f53a9-acdf-42f7-9ecc-843b376f7198"]}
  }]], "AnchorBarGrid",
 CellID->1,ExpressionUUID->"ded2ca48-ec8b-4e46-8898-69192cf9ae66"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell["$LieAnalysisVersion", "ObjectName",ExpressionUUID->
  "597fea52-b748-4a3d-beba-8f1c5897d8c0"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]],ExpressionUUID->"47b18704-1116-4005-b622-893afabbd1e8"],
 Cell[BoxData[
 ""], "ObjectNameTranslation",ExpressionUUID->
  "3cfc09b6-8352-4833-a01f-0350d1487519"]
}], "ObjectNameGrid",ExpressionUUID->"722850df-0578-4f41-93b6-77dd3e705582"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
     "$LieAnalysisVersion"], "InlineFormula",ExpressionUUID->
      "766696f5-654d-412f-89eb-da5fda6fccac"],
     " \[LineSeparator]returns the version of the installed package"
    }],ExpressionUUID->"6e704cf6-cc2e-4d1e-ae76-534dd5b0bb48"]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436,ExpressionUUID->"b5291dfd-c763-4fe5-90ba-1b7d351ba1f7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    TemplateBox[{6},
     "Spacer1"]],ExpressionUUID->"ce08c867-12d2-40fe-9775-03009aaa347b"],
   "Details"
  }], "NotesFrameText",ExpressionUUID->"df051863-a80f-496c-9071-632f1fa284a9"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->
   "Preemptive"]],ExpressionUUID->"23432f8f-cf3b-4a62-870a-ed9d8a09312e"]], \
"NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->183500547,ExpressionUUID->"31e60eac-7e1b-4af3-8eda-9d8426e754d8"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"13b66287-d276-4af9-820a-0f3062c946d6"],

Cell["\<\
The version number is the number included in the paclet-info.\
\>", "Notes",
 CellID->1067943069,ExpressionUUID->"01fbba5e-49f0-4c99-b39b-a764629d69a8"],

Cell[TextData[{
 "This symbol has become obsolete. The version number can now be requested \
through ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["LieAnalysis"]],"paclet:LieAnalysis/ref/LieAnalysis"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "81833ebb-b2a2-4b97-badb-7ed8d5e6a5c7"],
 "[\"Version\"]"
}], "Notes",
 CellID->80213648,ExpressionUUID->"72860496-8624-4951-858b-9c2a8b00cc5d"],

Cell["", "SectionFooterSpacer",ExpressionUUID->"70b5b8b9-ab90-4bbf-9227-bfe77f518311"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"1291f8b1-6afe-487c-a873-9ac52df00790"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(2)", "ExampleCount",ExpressionUUID->
  "cd088279-01f4-4450-a805-1aa36ca7ba18"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->504544002,ExpressionUUID->"1e7a81d4-577f-4faf-b51d-3ca4b34a55b1"],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(2)", "ExampleCount",ExpressionUUID->
  "c3d003d1-6915-4e36-8f52-4358fca0ccee"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->458499844,ExpressionUUID->"38e28aed-7d45-4c8f-9a29-25751142eda2"],

Cell["Request the current version of the package.", "ExampleText",
 CellID->832493645,ExpressionUUID->"69168cad-94ff-4b4f-8195-5c40f8ced87a"],

Cell[CellGroupData[{

Cell[BoxData["$LieAnalysisVersion"], "Input",
 CellLabel->"In[1]:=",
 CellID->47472248,ExpressionUUID->"8b9b2287-a093-410a-9b6b-3fe2a901c590"],

Cell[BoxData["\<\"0.5.1\"\>"], "Output",
 ImageSize->{39, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->188018378,ExpressionUUID->"2ba6ed55-54f1-47b3-aea3-ba29806f6077"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[
  "\t", "ExampleDelimiter",ExpressionUUID->
   "8f65895a-c881-4f44-8611-9db345b15964"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->1837924848,ExpressionUUID->"b7524a8b-85c9-4fde-8860-2d0607b94e09"],

Cell[TextData[{
 "A better way to request the current version number is through the ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["LieAnalysis"]],"paclet:LieAnalysis/ref/LieAnalysis"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "cfee1b14-8ed5-4462-8ee8-d93bf945f361"],
 " symbol"
}], "ExampleText",
 CellID->952147235,ExpressionUUID->"8ec51d4b-50d3-4163-8630-e632839ff629"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LieAnalysis", "[", "\"\<Version\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->477378770,ExpressionUUID->"bd718469-c677-4f71-85ca-a3f97fab1a17"],

Cell[BoxData["\<\"0.5.1\"\>"], "Output",
 ImageSize->{39, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->23618135,ExpressionUUID->"f9fcd417-5a9c-4f6c-a4c2-293036c95125"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell["", "SectionFooterSpacer",ExpressionUUID->"ec3b8b63-c314-4d72-819d-e95b905064ee"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"3942afeb-efe6-41a8-82c6-a7377036da3a"],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704,ExpressionUUID->"d55c7fa0-7ed4-4e14-bd08-09ca2b016ea8"],

Cell[TextData[Cell[BoxData[
 TemplateBox[{Cell[
    TextData["LieAnalysis"]],"paclet:LieAnalysis/ref/LieAnalysis"},
  "RefLink",
  BaseStyle->{
   "InlineFormula", FontFamily -> 
    "Verdana"}]], \
"InlineFormula",ExpressionUUID->"f71ba80c-20b1-475c-a941-f49111d51b46"]], \
"SeeAlso",
 CellID->929782353,ExpressionUUID->"a5b2b026-ae1e-48de-b0d1-f6b3bf8168ce"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"5591fee0-59f1-4258-b06c-2f756a2659aa"],
 "Related Guides"
}], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248,ExpressionUUID->"45b8dee1-c31b-4437-9734-b3f99b52eb55"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"e3b4da25-d3b1-4ea6-ab46-28fa5ddecf01"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["LieAnalysis Package"]],"paclet:LieAnalysis/guide/LieAnalysis"},
  "RefLink",
  BaseStyle->"MoreAbout"]], "MoreAbout",
 CellID->26257459,ExpressionUUID->"e98511ef-0dd0-4977-944c-db809980e841"]
}, Open  ]],

Cell[" ", "FooterCell",ExpressionUUID->"d7305eed-2bda-4aa8-a5d0-8757913893db"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"$LieAnalysisVersion",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "LieAnalysis Package", ButtonData -> 
         "paclet:LieAnalysis/guide/LieAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2017, 10, 26, 15, 7, 8.7492072}", 
    "history" -> {"0.3", "0.4", "0.4", ""}, "context" -> "LieAnalysis`", 
    "keywords" -> {"Version", "LieAnalysis", "Orientation Scores"}, 
    "specialkeywords" -> {}, "tutorialcollectionlinks" -> {}, "index" -> True,
     "label" -> "Lie Analysis Symbol", "language" -> "en", "paclet" -> 
    "LieAnalysis", "status" -> "None", "summary" -> 
    "$LieAnalysisVersion returns the version of the installed package", 
    "synonyms" -> {}, "tabletags" -> {}, "title" -> "$LieAnalysisVersion", 
    "titlemodifier" -> "", "windowtitle" -> "$LieAnalysisVersion", "type" -> 
    "Symbol", "uri" -> "LieAnalysis/ref/$LieAnalysisVersion"}, 
  "SearchTextTranslated" -> "", "NewStyles" -> False},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[7403, 194, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"1e7a81d4-577f-4faf-b51d-3ca4b34a55b1",
   CellTags->"PrimaryExamplesSection",
   CellID->504544002]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 13327, 368}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[591, 21, 4133, 93, 53, "AnchorBarGrid",ExpressionUUID->"ded2ca48-ec8b-4e46-8898-69192cf9ae66",
 CellID->1],
Cell[CellGroupData[{
Cell[4749, 118, 404, 9, 52, "ObjectNameGrid",ExpressionUUID->"722850df-0578-4f41-93b6-77dd3e705582"],
Cell[5156, 129, 535, 12, 110, "Usage",ExpressionUUID->"b5291dfd-c763-4fe5-90ba-1b7d351ba1f7",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[5728, 146, 855, 21, 37, "NotesSection",ExpressionUUID->"31e60eac-7e1b-4af3-8eda-9d8426e754d8",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->183500547],
Cell[6586, 169, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"13b66287-d276-4af9-820a-0f3062c946d6"],
Cell[6675, 171, 162, 3, 70, "Notes",ExpressionUUID->"01fbba5e-49f0-4c99-b39b-a764629d69a8",
 CellID->1067943069],
Cell[6840, 176, 437, 11, 70, "Notes",ExpressionUUID->"72860496-8624-4951-858b-9c2a8b00cc5d",
 CellID->80213648],
Cell[7280, 189, 86, 0, 70, "SectionFooterSpacer",ExpressionUUID->"70b5b8b9-ab90-4bbf-9227-bfe77f518311"]
}, Closed]],
Cell[CellGroupData[{
Cell[7403, 194, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"1e7a81d4-577f-4faf-b51d-3ca4b34a55b1",
 CellTags->"PrimaryExamplesSection",
 CellID->504544002],
Cell[CellGroupData[{
Cell[7863, 209, 308, 7, 29, "ExampleSection",ExpressionUUID->"38e28aed-7d45-4c8f-9a29-25751142eda2",
 CellID->458499844],
Cell[8174, 218, 141, 1, 38, "ExampleText",ExpressionUUID->"69168cad-94ff-4b4f-8195-5c40f8ced87a",
 CellID->832493645],
Cell[CellGroupData[{
Cell[8340, 223, 142, 2, 26, "Input",ExpressionUUID->"8b9b2287-a093-410a-9b6b-3fe2a901c590",
 CellID->47472248],
Cell[8485, 227, 225, 5, 35, "Output",ExpressionUUID->"2ba6ed55-54f1-47b3-aea3-ba29806f6077",
 CellID->188018378]
}, Open  ]],
Cell[CellGroupData[{
Cell[8747, 237, 243, 5, 8, "ExampleDelimiter",ExpressionUUID->"b7524a8b-85c9-4fde-8860-2d0607b94e09",
 CellID->1837924848],
Cell[8993, 244, 421, 10, 39, "ExampleText",ExpressionUUID->"8ec51d4b-50d3-4163-8630-e632839ff629",
 CellID->952147235],
Cell[CellGroupData[{
Cell[9439, 258, 176, 3, 26, "Input",ExpressionUUID->"bd718469-c677-4f71-85ca-a3f97fab1a17",
 CellID->477378770],
Cell[9618, 263, 224, 5, 35, "Output",ExpressionUUID->"f9fcd417-5a9c-4f6c-a4c2-293036c95125",
 CellID->23618135]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[9881, 273, 86, 0, 29, "SectionFooterSpacer",ExpressionUUID->"ec3b8b63-c314-4d72-819d-e95b905064ee"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10004, 278, 260, 7, 72, "SeeAlsoSection",ExpressionUUID->"d55c7fa0-7ed4-4e14-bd08-09ca2b016ea8",
 CellID->1255426704],
Cell[10267, 287, 360, 9, 24, "SeeAlso",ExpressionUUID->"a5b2b026-ae1e-48de-b0d1-f6b3bf8168ce",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[10664, 301, 266, 7, 72, "MoreAboutSection",ExpressionUUID->"45b8dee1-c31b-4437-9734-b3f99b52eb55",
 CellID->38303248],
Cell[10933, 310, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"e3b4da25-d3b1-4ea6-ab46-28fa5ddecf01"],
Cell[11022, 312, 239, 5, 70, "MoreAbout",ExpressionUUID->"e98511ef-0dd0-4977-944c-db809980e841",
 CellID->26257459]
}, Open  ]],
Cell[11276, 320, 78, 0, 70, "FooterCell",ExpressionUUID->"d7305eed-2bda-4aa8-a5d0-8757913893db"]
}
]
*)

(* End of internal cache information *)

