(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     37884,       1155]
NotebookOptionsPosition[     26240,        915]
NotebookOutlinePosition[     28946,        980]
CellTagsIndexPosition[     28861,        975]
WindowTitle->CakeWaveletStack3D
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["LIE ANALYSIS SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"CakeWaveletStack\"\>":>
       Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/CakeWaveletStack"], \
"\<\"OrientationScoreTransform3D\"\>":>Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/OrientationScoreTransform3D"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Related Guides",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"Related Guides", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"LieAnalysis Package\"\>":>
       Documentation`HelpLookup["paclet:LieAnalysis/guide/LieAnalysis"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAbout"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"LieAnalysis/ref/CakeWaveletStack3D\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["LieAnalysis/ref/CakeWaveletStack3D"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/LieAnalysis/ref/\
CakeWaveletStack3D.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$9335], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "LieAnalysis/ref/CakeWaveletStack3D", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[TextData[{
 Cell["CakeWaveletStack3D", "ObjectName"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]]],
 Cell[BoxData[""], "ObjectNameTranslation"]
}], "ObjectNameGrid"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"CakeWaveletStack3D", "[", 
       RowBox[{
        StyleBox["n", "TI"], ",", 
        StyleBox["size", "TI"]}], "]"}]], "InlineFormula"],
     " \[LineSeparator]construct a Cake Wavelet stack having ",
     StyleBox["n", "TI"],
     " orientations and dimensions ",
     StyleBox["size", "TI"],
     " x ",
     StyleBox["size", "TI"],
     " x ",
     StyleBox["size ", "TI"],
     "using the default parameters."
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"CakeWaveletStack3D", "[", 
       RowBox[{
        StyleBox["n", "TI"], ",", 
        StyleBox["size", "TI"], ",", 
        StyleBox["options", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]construct a Cake Wavelet stack having ",
     StyleBox["n", "TI"],
     " orientations and dimensions ",
     StyleBox["size", "TI"],
     " x ",
     StyleBox["size", "TI"],
     " x ",
     StyleBox["size ", "TI"],
     "using the specified ",
     StyleBox["options", "TI"],
     "."
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"CakeWaveletStack3D", "[", 
       RowBox[{
        StyleBox["orientationList", "TI"], ",", " ", 
        StyleBox["size", "TI"], ",", " ", 
        StyleBox["options", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]Constructs a Cake Wavelet stack using the supplied ",
     StyleBox["orientationList", "TI"],
     " which is a position vector, dimensions ",
     StyleBox["size", "TI"],
     " x ",
     StyleBox["size", "TI"],
     " x ",
     StyleBox["size", "TI"],
     " and using the specified ",
     StyleBox["options", "TI"],
     "."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, {None}}, "RowsIndexed" -> {}}},
 CellID->982511436],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    TemplateBox[{6},
     "Spacer1"]]],
   "Details"
  }], "NotesFrameText"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1],

Cell["", "SectionHeaderSpacer"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["CakeWaveletStack3D"]],
    "paclet:LieAnalysis/ref/CakeWaveletStack3D"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 " creates a set of (complex) orientation sensitive wavelets in 3D that can \
be used to create an Orientation Score (See ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreTransform3D"]],
    "paclet:LieAnalysis/ref/OrientationScoreTransform3D"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 ")."
}], "Notes",
 CellID->1067943069],

Cell[TextData[{
 "Applying ",
 ButtonBox["Normal",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Normal"],
 " to the output of ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["CakeWaveletStack3D"]],
    "paclet:LieAnalysis/ref/CakeWaveletStack3D"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 " returns a ",
 ButtonBox["Association",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Association"],
 "."
}], "Notes",
 CellID->166643282],

Cell[TextData[{
 "The Output of ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["CakeWaveletStack3D"]],
    "paclet:LieAnalysis/ref/CakeWaveletStack3D"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 " is ObjCakeWavelet3D which is a child of ObjOrientationWavelet3D."
}], "Notes",
 CellID->77640291],

Cell["The following options can be given:", "Notes",
 CellID->425286266],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon"], "\"\<Epsilon\>\"", "0.00001", Cell["\<\
Indirectly determines up to which order spherical harminics should be taken \
into account.\
\>", "TableText"]},
   {Cell["      ", "TableRowIcon"], "\"\<SigmaAngle\>\"", 
    ButtonBox["Automatic",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/Automatic"], Cell[
    "Width of the diffusion kernel.", "TableText"]},
   {Cell["      ", "TableRowIcon"], "\"\<Gamma\>\"", "0.8", Cell["\<\
(1-Gamma) is the distance between inflection point of the error function with \
the Nyquist frequency.\
\>", "TableText"]},
   {Cell["      ", "TableRowIcon"], "\"\<DcStandardDeviation\>\"", "8", Cell[
    "Scale of the low-pass filter in the spatial domain.", "TableText"]}
  }]], "3ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, None, {None}}, "RowsIndexed" -> {}},
 GridBoxDividers->{"Rows" -> {{True, True, True, True, True}}}},
 CellID->204350838],

Cell[TextData[{
 "The sampling on the sphere is initialized by random seeding the sphere, \
therefor the used orientations differ each time you run CakeWaveletStack3D. \
However if you specify a ",
 StyleBox["orientationList", "TI"],
 " you can enter your own orientations."
}], "Notes",
 CellID->400670919],

Cell["", "SectionFooterSpacer"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]]],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(15)", "ExampleCount"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->1],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(3)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1],

Cell["Create cake wavelets using the default settings.", "ExampleText",
 CellID->392687733],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<LieAnalysis`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->108926047],

Cell[BoxData[
 RowBox[{"cwsObj3d", "=", 
  RowBox[{"CakeWaveletStack3D", "[", 
   RowBox[{"12", ",", "11"}], "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->107987150],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->1277227256],

Cell["The shape of the wavelet can be controlled using options", "ExampleText",
 CellID->111956180],

Cell[BoxData[
 RowBox[{"cws3d", " ", "=", " ", 
  RowBox[{"CakeWaveletStack3D", "[", 
   RowBox[{"12", ",", "11", ",", 
    RowBox[{"\"\<DcStandardDeviation\>\"", "\[Rule]", "5"}]}], 
   "]"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1356499949]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->248369508],

Cell["\<\
To avoid using the electrostatic model to compute the orientations the \
orientationList can be provided instead of the number of orientations. \
\>", "ExampleText",
 CellID->188925011],

Cell[BoxData[
 RowBox[{"cws3d", " ", "=", " ", 
  RowBox[{"CakeWaveletStack3D", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], "}"}], ",", "11"}], 
   "]"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->391607065]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "Scope",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(3)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1293636265],

Cell["\<\
CakeWaveletStack returns a ObjCakeWavelet3D which is the child of \
ObjOrientationWavelet3D\
\>", "ExampleText",
 CellID->352911582],

Cell[BoxData[
 RowBox[{"ValidQ", "[", 
  RowBox[{
   RowBox[{"CakeWaveletStack3D", "[", 
    RowBox[{"12", ",", "11"}], "]"}], ",", 
   "LieAnalysis`Objects`ObjOrientationWavelet3D`ObjOrientationWavelet3D"}], 
  "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->653246],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->56672310],

Cell[TextData[{
 "The ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreTransform3D"]],
    "paclet:LieAnalysis/ref/OrientationScoreTransform3D"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 " also returns the Cake Wavelets that are used in a part."
}], "ExampleText",
 CellID->27068431],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ost", " ", "=", " ", 
   RowBox[{"OrientationScoreTransform3D", "[", 
    RowBox[{"CenterArray", "[", 
     RowBox[{"1", ",", 
      RowBox[{"{", 
       RowBox[{"11", ",", "11", ",", "11"}], "}"}]}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"ost", "\[LeftDoubleBracket]", "\"\<Wavelets\>\"", 
  "\[RightDoubleBracket]"}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->350437070]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->388015612],

Cell[TextData[{
 "Tessellations can be used as input for the ",
 StyleBox["orientationList", "TI"],
 " "
}], "ExampleText",
 CellID->387772515],

Cell[BoxData[{
 RowBox[{
  RowBox[{"orientations", " ", "=", "  ", 
   RowBox[{"N", "@", 
    RowBox[{
     RowBox[{"PolyhedronOperations`Geodesate", "[", 
      RowBox[{
       RowBox[{"PolyhedronData", "[", "\"\<Icosahedron\>\"", "]"}], ",", 
       "1"}], "]"}], "\[LeftDoubleBracket]", 
     RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"CakeWaveletStack3D", "[", 
  RowBox[{"orientations", ",", "11"}], "]"}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->200256564]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Generalizations & Extensions",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(3)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1020263627],

Cell[TextData[{
 "To create an ",
 ButtonBox["Association",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Association"],
 " from the output the ",
 ButtonBox["Normal",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Normal"],
 " function can be used"
}], "ExampleText",
 CellID->29343259],

Cell[BoxData[
 RowBox[{"Framed", "/@", 
  RowBox[{"Keys", "@", 
   RowBox[{"Normal", "[", 
    RowBox[{"CakeWaveletStack3D", "[", 
     RowBox[{"12", ",", "11"}], "]"}], "]"}]}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->24412492],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->16449688],

Cell["The elements can be modified by the function Affix.", "ExampleText",
 CellID->44361201],

Cell[BoxData[{
 RowBox[{
  RowBox[{"obj", " ", "=", " ", 
   RowBox[{"ObjCakeWavelet3D", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"obj", " ", "=", " ", 
  RowBox[{"Affix", "[", 
   RowBox[{"obj", ",", " ", 
    RowBox[{"\"\<Data\>\"", "\[Rule]", 
     RowBox[{"CenterArray", "[", 
      RowBox[{"1", ",", 
       RowBox[{"{", 
        RowBox[{"6", ",", "11", ",", "11", ",", "11"}], "}"}]}], "]"}]}]}], 
   "]"}]}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->440628748]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->51596827],

Cell[TextData[{
 "The ObjCakeWavelet3D can be created from an ObjOrientationWavelet3D by \
modifying the class ",
 ButtonBox["Head",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Head"]
}], "ExampleText",
 CellID->281639034],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Create", " ", "Empty", " ", "Object"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"obj", " ", "=", " ", 
     RowBox[{"ObjOrientationWavelet3D", "[", 
      RowBox[{"\"\<Data\>\"", "\[Rule]", 
       RowBox[{"CenterArray", "[", 
        RowBox[{"1", ",", 
         RowBox[{"{", 
          RowBox[{"6", ",", "11", ",", "11", ",", "11"}], "}"}]}], "]"}]}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Convert", " ", "Class"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"obj", "\[LeftDoubleBracket]", "0", "\[RightDoubleBracket]"}], 
     " ", "=", 
     RowBox[{"ClassSet", "[", 
      RowBox[{
       RowBox[{"obj", "\[LeftDoubleBracket]", "0", "\[RightDoubleBracket]"}], 
       ",", "ObjCakeWavelet3D"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   "obj"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->51052485]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Options",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(4)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->2061341341],

Cell[CellGroupData[{

Cell[TextData[{
 "Epsilon",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CellID->1757724783],

Cell[TextData[{
 "The option Epsilon determines which order ",
 Cell[BoxData[
  SubscriptBox["L", "max"]], "InlineFormula"],
 " spherical harmonics is used"
}], "ExampleText",
 CellID->367986189],

Cell[BoxData[{
 RowBox[{
  RowBox[{"scale", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"sigmaAngle", "=", "0.6"}], ")"}], "^", "2"}], ")"}], "/", 
    "2"}]}], ";"}], "\n", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
   "LieAnalysis`OrientationScores3D`Filters`CakeWavelets`Private`\
DetermineMaxOrderL", "[", 
    RowBox[{"scale", ",", "\[Epsilon]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"\[Epsilon]", ",", "$MachineEpsilon", ",", "0.1"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "0.1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "18"}], "}"}]}], "}"}]}], ",", 
   RowBox[{"PlotLegends", "\[Rule]", "\"\<Expressions\>\""}], ",", 
   RowBox[{"AxesLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<\[Epsilon]\>\"", ",", "\"\<Lmax\>\""}], "}"}]}]}], 
  "]"}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->67861994]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "SigmaAngle",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CellID->1295379749],

Cell["\<\
The SigmaAngle determines the width of the diffusion kernel, or in different \
words, the angular width. The automatic setting uses the half of the width \
between two vertices on the sphere.\
\>", "ExampleText",
 CellID->60216185],

Cell[BoxData[
 RowBox[{"GraphicsRow", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"QuickVisualize", "[", 
      RowBox[{"CakeWaveletStack3D", "[", 
       RowBox[{"12", ",", "11", ",", 
        RowBox[{"\"\<SigmaAngle\>\"", "\[Rule]", "#"}]}], "]"}], "]"}], "&"}],
     "/@", 
    RowBox[{"{", 
     RowBox[{"Automatic", ",", " ", "0.9"}], "}"}]}], ",", " ", 
   RowBox[{"ImageSize", "\[Rule]", "Full"}]}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->477514341]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Gamma",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CellID->121572296],

Cell["\<\
The Gamma option (in CakeWaveletStack the similar option is InflectionPoint) \
specifies the distance, in the fourier domain, between the Nyquist frequency \
and the InflectionPoint of the error function.\
\>", "ExampleText",
 CellID->341028491],

Cell[BoxData[
 RowBox[{"GraphicsRow", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"QuickVisualize", "[", 
      RowBox[{"CakeWaveletStack3D", "[", 
       RowBox[{"12", ",", "17", ",", 
        RowBox[{"\"\<Gamma\>\"", "\[Rule]", "#"}]}], "]"}], "]"}], "&"}], "/@", 
    RowBox[{"{", 
     RowBox[{"0.5", ",", " ", "0.7"}], "}"}]}], ",", " ", 
   RowBox[{"ImageSize", "\[Rule]", "Full"}]}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->261272430]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "DcStandardDeviation",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CellID->65360782],

Cell["\<\
The DcStandardDeviation removes the low frequencies to create a smooth \
transition in the Fourier domain. The DcStandardDeviation is supplied in the \
spatial domain.\
\>", "ExampleText",
 CellID->40392333],

Cell[BoxData[{
 RowBox[{
  RowBox[{"cws1", " ", "=", " ", 
   RowBox[{"CakeWaveletStack3D", "[", 
    RowBox[{"12", ",", "11", ",", 
     RowBox[{"\"\<DcStandardDeviation\>\"", "\[Rule]", "1"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"cws2", " ", "=", " ", 
   RowBox[{"CakeWaveletStack3D", "[", 
    RowBox[{
     RowBox[{
     "cws1", "\[LeftDoubleBracket]", "\"\<OrientationList\>\"", 
      "\[RightDoubleBracket]"}], ",", "11", ",", 
     RowBox[{"\"\<DcStandardDeviation\>\"", "\[Rule]", "2"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"ListLinePlot", "[", 
  RowBox[{
   RowBox[{"Re", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
       "#", "\[LeftDoubleBracket]", "\"\<Data\>\"", "\[RightDoubleBracket]"}],
        "\[LeftDoubleBracket]", 
       RowBox[{"1", ",", "All", ",", "11", ",", "11"}], 
       "\[RightDoubleBracket]"}], "&"}], "/@", 
     RowBox[{"{", 
      RowBox[{"cws1", ",", "cws2"}], "}"}]}], "]"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->667419822]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Applications",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->258228157],

Cell["Cake wavelets can be used to construct an orientation score", \
"ExampleText",
 CellID->209086610],

Cell[BoxData[
 RowBox[{"OrientationScoreTransform3D", "[", 
  RowBox[{
   RowBox[{"LieAnalysisData", "[", 
    RowBox[{"{", 
     RowBox[{"\"\<image3d\>\"", ",", "\"\<random-lines-1\>\""}], "}"}], "]"}],
    ",", " ", 
   RowBox[{"CakeWaveletStack3D", "[", 
    RowBox[{"12", ",", "11"}], "]"}]}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->450440760]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Properties & Relations",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->2123667759],

Cell[TextData[{
 "To get all stored information from the ObjCakeWavelet3D object as an ",
 ButtonBox["Association",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Association"],
 " the ",
 ButtonBox["Normal",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Normal"],
 " function can be used."
}], "ExampleText",
 CellID->136697962],

Cell[BoxData[
 RowBox[{"Framed", "/@", 
  RowBox[{"Keys", "[", 
   RowBox[{"Normal", "[", "cwsObj3d", "]"}], "]"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->347038941],

Cell["\<\
However to maintain the object-structure the data can be extracted as parts \
(use the plus sign on the top left corner of the object to see which parts \
are available)\
\>", "ExampleText",
 CellID->766759663],

Cell[BoxData[
 RowBox[{
  RowBox[{
  "cwsObj3d", "\[LeftDoubleBracket]", "\"\<Data\>\"", 
   "\[RightDoubleBracket]"}], "//", "Dimensions"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->142037344],

Cell["\<\
Parts indicate that the property is stored within the memory. Keys, however, \
are computed from the parts. For example if we would like to have the \
orientations that are used in polar form (instead of the vector form which is \
stored in OrientationList) we can use the key PolarOrienationList.\
\>", "ExampleText",
 CellID->117610288],

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{"\[Beta]", ",", " ", "\[Gamma]"}], "}"}], " ", "=", 
  RowBox[{"cwsObj3d", "[", "\"\<PolarOrientationList\>\"", "]"}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->253663933]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "SectionFooterSpacer"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]]],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["CakeWaveletStack"]],"paclet:LieAnalysis/ref/CakeWaveletStack"},
   
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreTransform3D"]],
    "paclet:LieAnalysis/ref/OrientationScoreTransform3D"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]]],
 "Related Guides"
}], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell["", "SectionHeaderSpacer"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["LieAnalysis Package"]],"paclet:LieAnalysis/guide/LieAnalysis"},
  "RefLink",
  BaseStyle->"MoreAbout"]], "MoreAbout",
 CellID->1]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"CakeWaveletStack3D",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "LieAnalysis Package", ButtonData -> 
         "paclet:LieAnalysis/guide/LieAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2017, 10, 26, 15, 6, 45.9081150}", 
    "history" -> {"0.2", "", "", ""}, "context" -> "LieAnalysis`", 
    "keywords" -> {
     "Orientation Scores", "Cake Wavelets", "Orientation Wavelets", 
      "LieAnalysis", "OrientationScoreTransform"}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Lie Analysis Symbol", "language" -> "en", "paclet" -> "LieAnalysis", 
    "status" -> "None", "summary" -> 
    "CakeWaveletStack3D[n, size] construct a Cake Wavelet stack having n \
orientations and dimensions size x size x size using the default parameters. \
CakeWaveletStack3D[n, size, options] construct a Cake Wavelet stack having n \
orientations and dimensions size x size x size using the specified options. \
CakeWaveletStack3D[orientationList, size, options] Constructs a Cake Wavelet \
stack using the supplied orientationList which is a position vector, \
dimensions size x size x size and using the specified options.", 
    "synonyms" -> {}, "tabletags" -> {}, "title" -> "CakeWaveletStack3D", 
    "titlemodifier" -> "", "windowtitle" -> "CakeWaveletStack3D", "type" -> 
    "Symbol", "uri" -> "LieAnalysis/ref/CakeWaveletStack3D"}},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[9940, 302, 260, 10, 70, "PrimaryExamplesSection",ExpressionUUID->"6b0a20e7-d8a8-451f-8009-317f3157cc41",
   CellTags->"PrimaryExamplesSection",
   CellID->1]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 28671, 968}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[590, 21, 3753, 92, 70, "AnchorBarGrid",ExpressionUUID->"8ff58368-a324-4747-b164-de2e28e1eac2",
 CellID->1],
Cell[4346, 115, 175, 6, 70, "ObjectNameGrid",ExpressionUUID->"8a009456-3153-4141-bf8b-e306341a8a9c"],
Cell[4524, 123, 1867, 60, 70, "Usage",ExpressionUUID->"0972eb34-c0fb-4b19-822a-8c90cf564f32",
 CellID->982511436],
Cell[CellGroupData[{
Cell[6416, 187, 621, 19, 70, "NotesSection",ExpressionUUID->"f4cab571-7eda-49cc-95ea-d726532100d9",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1],
Cell[7040, 208, 31, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"d00b33e9-4004-47ac-9988-39bb248df298"],
Cell[7074, 210, 580, 17, 70, "Notes",ExpressionUUID->"70d65157-8845-4c7a-b63a-7659745d6921",
 CellID->1067943069],
Cell[7657, 229, 463, 18, 70, "Notes",ExpressionUUID->"161d3839-8486-4784-867c-00d12ba1a53f",
 CellID->166643282],
Cell[8123, 249, 326, 10, 70, "Notes",ExpressionUUID->"4d289600-d325-435a-aa54-dcf55bac59dc",
 CellID->77640291],
Cell[8452, 261, 72, 1, 70, "Notes",ExpressionUUID->"59050b5a-1325-4465-a78f-9700e374e70f",
 CellID->425286266],
Cell[8527, 264, 1032, 22, 70, "3ColumnTableMod",ExpressionUUID->"52e53ba6-b2a5-4dc8-a8ac-bc3808fc16d5",
 CellID->204350838],
Cell[9562, 288, 307, 7, 70, "Notes",ExpressionUUID->"e9673545-ba71-4c27-8784-f25e71bf46cd",
 CellID->400670919],
Cell[9872, 297, 31, 0, 70, "SectionFooterSpacer",ExpressionUUID->"5b1607c2-3f41-45f2-827c-892244ae340a"]
}, Closed]],
Cell[CellGroupData[{
Cell[9940, 302, 260, 10, 70, "PrimaryExamplesSection",ExpressionUUID->"6b0a20e7-d8a8-451f-8009-317f3157cc41",
 CellTags->"PrimaryExamplesSection",
 CellID->1],
Cell[CellGroupData[{
Cell[10225, 316, 187, 6, 70, "ExampleSection",ExpressionUUID->"34d1c768-5717-49a0-9c27-57652dc95362",
 CellID->1],
Cell[10415, 324, 91, 1, 70, "ExampleText",ExpressionUUID->"a988fb68-21ae-4a54-b10c-203aaf1e1a6a",
 CellID->392687733],
Cell[10509, 327, 120, 3, 70, "Input",ExpressionUUID->"08012e8a-7405-49c4-bdcb-63b634b440c2",
 CellID->108926047],
Cell[10632, 332, 170, 5, 70, "Input",ExpressionUUID->"9770307e-be74-4ab8-a1fe-a48e35d87cb0",
 CellID->107987150],
Cell[CellGroupData[{
Cell[10827, 341, 126, 3, 70, "ExampleDelimiter",ExpressionUUID->"ba4bc3e0-dde3-451d-b281-b8f9528a03da",
 CellID->1277227256],
Cell[10956, 346, 99, 1, 70, "ExampleText",ExpressionUUID->"c0606771-f52c-4602-8b19-94d76f7e379c",
 CellID->111956180],
Cell[11058, 349, 249, 7, 70, "Input",ExpressionUUID->"eca4a5ba-fe93-44df-9d3a-47ce6c65f728",
 CellID->1356499949]
}, Open  ]],
Cell[CellGroupData[{
Cell[11344, 361, 125, 3, 70, "ExampleDelimiter",ExpressionUUID->"4a59ba61-b51b-4de5-a2b0-c73ef28de70c",
 CellID->248369508],
Cell[11472, 366, 195, 4, 70, "ExampleText",ExpressionUUID->"951e3ac7-80d0-44fc-820e-bfc14e6316ac",
 CellID->188925011],
Cell[11670, 372, 436, 14, 70, "Input",ExpressionUUID->"2b55bf9a-6d3f-4e6d-8a27-de26d25e9500",
 CellID->391607065]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[12155, 392, 187, 6, 70, "ExampleSection",ExpressionUUID->"180e4d35-9704-4746-bdff-f3f353e4d00a",
 CellID->1293636265],
Cell[12345, 400, 142, 4, 70, "ExampleText",ExpressionUUID->"aa3eee2b-156b-4750-a1d2-dece681e2f61",
 CellID->352911582],
Cell[12490, 406, 268, 8, 70, "Input",ExpressionUUID->"47b871cf-29fe-446b-b30c-43d20d4c6655",
 CellID->653246],
Cell[CellGroupData[{
Cell[12783, 418, 124, 3, 70, "ExampleDelimiter",ExpressionUUID->"eaf6c6d3-836b-425a-9efa-0389b4ecad12",
 CellID->56672310],
Cell[12910, 423, 331, 10, 70, "ExampleText",ExpressionUUID->"be838410-b361-4ba2-9e93-2589ada8999a",
 CellID->27068431],
Cell[13244, 435, 430, 12, 70, "Input",ExpressionUUID->"421dd099-c49e-4836-a518-e4191284a528",
 CellID->350437070]
}, Open  ]],
Cell[CellGroupData[{
Cell[13711, 452, 125, 3, 70, "ExampleDelimiter",ExpressionUUID->"eb4bd7fd-f1d7-4e73-b1a3-9d93aa706fbf",
 CellID->388015612],
Cell[13839, 457, 143, 5, 70, "ExampleText",ExpressionUUID->"76725c0b-5e9c-4869-822d-9f87f24478f6",
 CellID->387772515],
Cell[13985, 464, 522, 14, 70, "Input",ExpressionUUID->"3345624f-e6e3-4c0e-a8a4-80623be585b0",
 CellID->200256564]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[14556, 484, 210, 6, 70, "ExampleSection",ExpressionUUID->"41f3f2ad-21c7-4867-891b-8dfc579a6624",
 CellID->1020263627],
Cell[14769, 492, 288, 11, 70, "ExampleText",ExpressionUUID->"6d61ad71-3777-4555-9f15-7d439dce0239",
 CellID->29343259],
Cell[15060, 505, 232, 7, 70, "Input",ExpressionUUID->"9a77bdda-7cae-4d29-a06e-c2c1756cb306",
 CellID->24412492],
Cell[CellGroupData[{
Cell[15317, 516, 124, 3, 70, "ExampleDelimiter",ExpressionUUID->"63988f56-4734-4c9c-bdb7-e8cfa2e386f8",
 CellID->16449688],
Cell[15444, 521, 93, 1, 70, "ExampleText",ExpressionUUID->"d3e84710-5952-42a7-88d6-27d7ca992bbb",
 CellID->44361201],
Cell[15540, 524, 482, 14, 70, "Input",ExpressionUUID->"32d9ab4e-b2b8-4bea-98af-000000a3af18",
 CellID->440628748]
}, Open  ]],
Cell[CellGroupData[{
Cell[16059, 543, 124, 3, 70, "ExampleDelimiter",ExpressionUUID->"7f43542b-65d4-40c1-a7c2-abc8f8f99dbf",
 CellID->51596827],
Cell[16186, 548, 225, 7, 70, "ExampleText",ExpressionUUID->"cf8d028c-41b5-416e-90bb-7971068caae0",
 CellID->281639034],
Cell[16414, 557, 974, 27, 70, "Input",ExpressionUUID->"e7c02795-54f4-4798-9591-deaa65212175",
 CellID->51052485]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[17437, 590, 189, 6, 70, "ExampleSection",ExpressionUUID->"3f32bc80-c262-45ce-9fde-4b17d0a9c27f",
 CellID->2061341341],
Cell[CellGroupData[{
Cell[17651, 600, 195, 6, 70, "ExampleSubsection",ExpressionUUID->"b4b8b95f-9c49-4ead-8248-c0a34ac98343",
 CellID->1757724783],
Cell[17849, 608, 195, 6, 70, "ExampleText",ExpressionUUID->"2ada914f-cef3-4f1c-b6c1-e2776c2f2d6e",
 CellID->367986189],
Cell[18047, 616, 970, 30, 70, "Input",ExpressionUUID->"d4b10edc-174d-4c6a-b8fa-17a312681cef",
 CellID->67861994]
}, Closed]],
Cell[CellGroupData[{
Cell[19054, 651, 198, 6, 70, "ExampleSubsection",ExpressionUUID->"4cb83c20-8244-44b0-b74b-d8edd37ca357",
 CellID->1295379749],
Cell[19255, 659, 241, 5, 70, "ExampleText",ExpressionUUID->"1ca4c37b-836c-4450-bb35-d68321b0757a",
 CellID->60216185],
Cell[19499, 666, 477, 14, 70, "Input",ExpressionUUID->"fe92fc86-897f-4888-83eb-3e6c202ebdf4",
 CellID->477514341]
}, Closed]],
Cell[CellGroupData[{
Cell[20013, 685, 192, 6, 70, "ExampleSubsection",ExpressionUUID->"cbcf4763-1593-4c68-b02a-c895d97878a9",
 CellID->121572296],
Cell[20208, 693, 255, 5, 70, "ExampleText",ExpressionUUID->"38a781cf-b571-4a27-b777-03a85638c537",
 CellID->341028491],
Cell[20466, 700, 461, 13, 70, "Input",ExpressionUUID->"25a2ee76-027e-4888-aef0-9c9130d6b699",
 CellID->261272430]
}, Closed]],
Cell[CellGroupData[{
Cell[20964, 718, 205, 6, 70, "ExampleSubsection",ExpressionUUID->"5c052594-e0a6-4613-970a-cd8009a2caf5",
 CellID->65360782],
Cell[21172, 726, 217, 5, 70, "ExampleText",ExpressionUUID->"19bc5326-8b08-44a4-b16a-9ff478dec159",
 CellID->40392333],
Cell[21392, 733, 1096, 31, 70, "Input",ExpressionUUID->"0227ecd3-fc1e-4e3c-a811-5847b0ee602a",
 CellID->667419822]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[22537, 770, 193, 6, 70, "ExampleSection",ExpressionUUID->"93abcccd-ac78-4e91-8cc6-2afc8b1af92f",
 CellID->258228157],
Cell[22733, 778, 104, 2, 70, "ExampleText",ExpressionUUID->"e784b934-9c82-4ab1-8c81-8f2641991946",
 CellID->209086610],
Cell[22840, 782, 357, 10, 70, "Input",ExpressionUUID->"ab986eb8-872d-44a2-978c-5c9e1692bcf9",
 CellID->450440760]
}, Closed]],
Cell[CellGroupData[{
Cell[23234, 797, 204, 6, 70, "ExampleSection",ExpressionUUID->"f2ffef8e-354f-48ba-b8d1-1a9a0f874413",
 CellID->2123667759],
Cell[23441, 805, 330, 11, 70, "ExampleText",ExpressionUUID->"ba836cfd-5c7b-4011-9f00-0bd7d4fe44a7",
 CellID->136697962],
Cell[23774, 818, 170, 5, 70, "Input",ExpressionUUID->"630506d0-8e81-440c-8b0f-6e729d756c56",
 CellID->347038941],
Cell[23947, 825, 220, 5, 70, "ExampleText",ExpressionUUID->"ae0cbcda-feb7-4aec-907f-2812a0cc1723",
 CellID->766759663],
Cell[24170, 832, 194, 6, 70, "Input",ExpressionUUID->"4d5f58b1-be8e-4d7b-b18b-c71e9424dfd0",
 CellID->142037344],
Cell[24367, 840, 348, 6, 70, "ExampleText",ExpressionUUID->"37a46b01-2881-4ee6-8590-7b3a5cc8ae7d",
 CellID->117610288],
Cell[24718, 848, 224, 6, 70, "Input",ExpressionUUID->"91b29dc9-5a67-4433-ac26-f969f66685e0",
 CellID->253663933]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[24991, 860, 31, 0, 70, "SectionFooterSpacer",ExpressionUUID->"9af75c2d-649e-404e-a2bd-ccfc4c802120"],
Cell[25025, 862, 150, 7, 70, "SeeAlsoSection",ExpressionUUID->"4258cf59-b4e1-408b-b8f7-0b367d444b91",
 CellID->1255426704],
Cell[25178, 871, 613, 18, 70, "SeeAlso",ExpressionUUID->"cffcb962-2686-44d4-bec6-d6ef0340685d",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[25828, 894, 156, 7, 70, "MoreAboutSection",ExpressionUUID->"fb808944-0cf2-4fad-b290-23e3f46ae187",
 CellID->38303248],
Cell[25987, 903, 31, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"1e045483-aec7-410b-bc38-787fb059b421"],
Cell[26021, 905, 177, 5, 70, "MoreAbout",ExpressionUUID->"4ff33bac-1a9d-42db-82ee-b63e421c8b3a",
 CellID->1]
}, Open  ]],
Cell[26213, 913, 23, 0, 70, "FooterCell",ExpressionUUID->"6d89739e-87cd-45ca-bbcf-6dadfbe89989"]
}
]
*)

(* End of internal cache information *)
