(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     27663,        837]
NotebookOptionsPosition[     18793,        649]
NotebookOutlinePosition[     21219,        710]
CellTagsIndexPosition[     21134,        705]
WindowTitle->GaborWaveletStack
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["LIE ANALYSIS SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"CakeWaveletStack\"\>":>
       Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/CakeWaveletStack"], \
"\<\"OrientationScoreTransform\"\>":>Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/OrientationScoreTransform"], \
"\<\"CakeWaveletStack3D\"\>":>Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/CakeWaveletStack3D"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Related Guides",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"Related Guides", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"LieAnalysis Package\"\>":>
       Documentation`HelpLookup["paclet:LieAnalysis/guide/LieAnalysis"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAbout"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"LieAnalysis/ref/GaborWaveletStack\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["LieAnalysis/ref/GaborWaveletStack"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/LieAnalysis/ref/\
GaborWaveletStack.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$10781], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "LieAnalysis/ref/GaborWaveletStack", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[TextData[{
 Cell["GaborWaveletStack", "ObjectName"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]]],
 Cell[BoxData[""], "ObjectNameTranslation"]
}], "ObjectNameGrid"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"GaborWaveletStack", "[", 
       RowBox[{
        StyleBox["n", "TI"], ",", " ", 
        StyleBox["scale", "TI"]}], "]"}]], "InlineFormula"],
     " \[LineSeparator]returns orientation sensitive Gabor wavelets having ",
     StyleBox["n", "TI"],
     " orientations at ",
     StyleBox["scale", "TI"]
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"GaborWaveletStack", "[", 
       RowBox[{
        StyleBox["n", "TI"], ",", 
        StyleBox["scale", "TI"], ",", 
        StyleBox["size", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]returns orientation sensitive Gabor wavelets having \
dimensions ",
     StyleBox["size", "TI"]
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    TemplateBox[{6},
     "Spacer1"]]],
   "Details"
  }], "NotesFrameText"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1],

Cell["", "SectionHeaderSpacer"],

Cell[TextData[{
 "GaborWaveletStack generates a stack of oriented Gabor filters that can be \
used by ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreTransform"]],
    "paclet:LieAnalysis/ref/OrientationScoreTransform"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 " to compute an Orientation Score."
}], "Notes",
 CellID->1067943069],

Cell["\<\
The following options can be given to control the shape of the wavelet:\
\>", "Notes",
 CellID->175077442],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon"], "\"\<Epsilon\>\"", "4", Cell[
    "Epsilon controls how anisotropic the wavelet is", "TableText"]},
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["K0",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/K0"], 
    RowBox[{"{", 
     RowBox[{"0", ",", " ", "3"}], "}"}], Cell[
    "Defines the spatial frequency of the complex exponential", 
     "TableText"]},
   {Cell["      ", "TableRowIcon"], "\"\<Directional\>\"", 
    ButtonBox["False",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/False"], Cell[
    "Whenever the spatial wavelets are single or double headed", 
     "TableText"]}
  }]], "3ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, {None}}, "RowsIndexed" -> {}},
 GridBoxDividers->{"Rows" -> {{True, True, True, True}}}},
 CellID->206802571],

Cell["", "SectionFooterSpacer"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]]],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(11)", "ExampleCount"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->1],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(3)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1],

Cell["Create a Gabor wavelet using the default settings.", "ExampleText",
 CellID->10662228],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Needs", "[", "\"\<LieAnalysis`\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"gwsObj", " ", "=", " ", 
  RowBox[{"GaborWaveletStack", "[", 
   RowBox[{"12", ",", "4"}], "]"}]}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->87347538],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->1864818157],

Cell["The size of the wavelet has an automatic setting.", "ExampleText",
 CellID->1622420381],

Cell[BoxData[
 RowBox[{"GaborWaveletStack", "[", 
  RowBox[{"12", ",", "1", ",", "Automatic"}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1153907965]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->785392555],

Cell["The shape of the Gabor wavelet can be controlled by options.", \
"ExampleText",
 CellID->1658177423],

Cell[BoxData[
 RowBox[{"GaborWaveletStack", "[", 
  RowBox[{"12", ",", "2", ",", "51", ",", 
   RowBox[{"\"\<Epsilon\>\"", "\[Rule]", "2"}]}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1335414351]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "Scope",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1293636265],

Cell["\<\
Directional cake wavelets are Cake Wavelets of which the tail is cut of (only \
the head is left). It is also good to note that by adding the wavelet at \
\[Theta] = 0 and \[Theta] = \[Pi], the original wavelet is reconstructed.\
\>", "ExampleText",
 CellID->464037698],

Cell[BoxData[{
 RowBox[{
  RowBox[{"gaborWavelets", " ", "=", " ", 
   RowBox[{"GaborWaveletStack", "[", 
    RowBox[{
     RowBox[{"n", "=", "24"}], ",", "3", ",", "21", ",", 
     RowBox[{"\"\<Directional\>\"", "\[Rule]", "True"}]}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{"GraphicsRow", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ImageAdjust", "@", 
      RowBox[{"Image", "[", 
       RowBox[{"Re", "[", "#", "]"}], "]"}]}], "&"}], "/@", 
    RowBox[{
    "gaborWavelets", "\[LeftDoubleBracket]", "\"\<Data\>\"", 
     "\[RightDoubleBracket]"}]}], ",", 
   RowBox[{"ImageSize", "\[Rule]", "Full"}]}], "]"}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->248412508]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Options",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(3)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->2061341341],

Cell[CellGroupData[{

Cell[TextData[{
 "Epsilon",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CellID->1295379749],

Cell["\<\
The Epsilon parameter determines how anisotropic the wavelets is.\
\>", "ExampleText",
 CellID->93279754],

Cell[BoxData[{
 RowBox[{
  RowBox[{"gwsObj1", "=", 
   RowBox[{"GaborWaveletStack", "[", 
    RowBox[{"12", ",", "1", ",", "45", ",", 
     RowBox[{"\"\<Epsilon\>\"", "\[Rule]", "1"}]}], "]"}]}], ";", 
  RowBox[{"gwsObj2", "=", 
   RowBox[{"GaborWaveletStack", "[", 
    RowBox[{"12", ",", "1", ",", "45", ",", 
     RowBox[{"\"\<Epsilon\>\"", "\[Rule]", "100"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{"GraphicsRow", "@", 
  RowBox[{"{", "\n", "\t", 
   RowBox[{
    RowBox[{"Image", "[", 
     RowBox[{"Re", "[", 
      RowBox[{
       RowBox[{"gwsObj1", "[", 
        RowBox[{"[", "\"\<Data\>\"", "]"}], "]"}], "\[LeftDoubleBracket]", 
       "1", "\[RightDoubleBracket]"}], "]"}], "]"}], ",", "\n", "\t", 
    RowBox[{"Image", "[", 
     RowBox[{"Re", "[", 
      RowBox[{
       RowBox[{"gwsObj2", "[", 
        RowBox[{"[", "\"\<Data\>\"", "]"}], "]"}], "\[LeftDoubleBracket]", 
       "1", "\[RightDoubleBracket]"}], "]"}], "]"}]}], "\n", 
   "}"}]}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->71245125]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "K0",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CellID->154963103],

Cell["\<\
K0 defines the spatial frequency of the complex exponential:  \
\>", "ExampleText",
 CellID->466631986],

Cell[BoxData[{
 RowBox[{
  RowBox[{"gwsObj1", "=", 
   RowBox[{"GaborWaveletStack", "[", 
    RowBox[{"12", ",", "3", ",", "21", ",", 
     RowBox[{"\"\<K0\>\"", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "100"}], "}"}]}]}], "]"}]}], ";", 
  RowBox[{"gwsObj2", "=", 
   RowBox[{"GaborWaveletStack", "[", 
    RowBox[{"12", ",", "3", ",", "21", ",", 
     RowBox[{"\"\<K0\>\"", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0"}], "}"}]}]}], "]"}]}], ";"}], "\n", 
 RowBox[{"GraphicsRow", "@", 
  RowBox[{"{", "\n", "\t", 
   RowBox[{
    RowBox[{"Image", "[", 
     RowBox[{"Re", "[", 
      RowBox[{
       RowBox[{"gwsObj1", "[", 
        RowBox[{"[", "\"\<Data\>\"", "]"}], "]"}], "\[LeftDoubleBracket]", 
       "1", "\[RightDoubleBracket]"}], "]"}], "]"}], ",", "\n", "\t", 
    RowBox[{"Image", "[", 
     RowBox[{"Re", "[", 
      RowBox[{
       RowBox[{"gwsObj2", "[", 
        RowBox[{"[", "\"\<Data\>\"", "]"}], "]"}], "\[LeftDoubleBracket]", 
       "1", "\[RightDoubleBracket]"}], "]"}], "]"}]}], "\n", 
   "}"}]}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->79419375]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Directional",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CellID->721708626],

Cell["\<\
The tails and head of the wavelet can be separated into two layers by setting \
this option to True. Note that is useful to set the periodicity to 2\[Pi] as \
then all directions are used.\
\>", "ExampleText",
 CellID->599489700],

Cell[BoxData[{
 RowBox[{
  RowBox[{"cws", " ", "=", " ", 
   RowBox[{"GaborWaveletStack", "[", 
    RowBox[{"6", ",", "5", ",", "101", ",", 
     RowBox[{"\"\<Directional\>\"", "\[Rule]", "True"}]}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{"GraphicsRow", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ImageAdjust", "@", 
      RowBox[{"Image", "[", 
       RowBox[{"Re", "[", "#", "]"}], "]"}]}], "&"}], "/@", 
    RowBox[{"cws", "[", "\"\<FullData\>\"", "]"}]}], ",", 
   RowBox[{"ImageSize", "\[Rule]", "Full"}]}], "]"}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->310715018]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Applications",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(2)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->258228157],

Cell["construct orientation score using Gabor wavelets.", "ExampleText",
 CellID->1083195361],

Cell[BoxData[
 RowBox[{"OrientationScoreTransform", "[", 
  RowBox[{
   RowBox[{"LieAnalysisData", "[", 
    RowBox[{"{", 
     RowBox[{"\"\<image\>\"", ",", "\"\<eindhoven-map\>\""}], "}"}], "]"}], 
   ",", 
   RowBox[{"\"\<Type\>\"", "\[Rule]", "\"\<Gabor\>\""}]}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1960391602],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->2130755712],

Cell["\<\
construct orientation score using pre-computed Gabor wavelets.\
\>", "ExampleText",
 CellID->173954212],

Cell[BoxData[
 RowBox[{"OrientationScoreTransform", "[", 
  RowBox[{
   RowBox[{"LieAnalysisData", "[", 
    RowBox[{"{", 
     RowBox[{"\"\<image\>\"", ",", "\"\<eindhoven-map\>\""}], "}"}], "]"}], 
   ",", 
   RowBox[{"GaborWaveletStack", "[", 
    RowBox[{"12", ",", "11"}], "]"}]}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->374941992]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Properties & Relations",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(2)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->2123667759],

Cell[TextData[{
 "To get all stored information as an ",
 ButtonBox["Association",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Association"],
 " the ",
 ButtonBox["Normal",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Normal"],
 " function can be used."
}], "ExampleText",
 CellID->196131064],

Cell[BoxData[
 RowBox[{"Framed", "/@", 
  RowBox[{"Keys", "[", 
   RowBox[{"Normal", "[", "gwsObj", "]"}], "]"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->396489419],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->1659724248],

Cell["\<\
the output contains properties which are computed if they are requested\
\>", "ExampleText",
 CellID->37857162],

Cell[BoxData[
 RowBox[{"gwsObj", "[", "\"\<AngularResolution\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->140482532]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "SectionFooterSpacer"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]]],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["CakeWaveletStack"]],"paclet:LieAnalysis/ref/CakeWaveletStack"},
   
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreTransform"]],
    "paclet:LieAnalysis/ref/OrientationScoreTransform"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["CakeWaveletStack3D"]],
    "paclet:LieAnalysis/ref/CakeWaveletStack3D"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]]],
 "Related Guides"
}], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell["", "SectionHeaderSpacer"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["LieAnalysis Package"]],"paclet:LieAnalysis/guide/LieAnalysis"},
  "RefLink",
  BaseStyle->"MoreAbout"]], "MoreAbout",
 CellID->1]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"GaborWaveletStack",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "LieAnalysis Package", ButtonData -> 
         "paclet:LieAnalysis/guide/LieAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2017, 10, 26, 15, 6, 49.0152944}", 
    "history" -> {"0.2", "0.4.1", "", ""}, "context" -> "LieAnalysis`", 
    "keywords" -> {
     "Orientation Scores", "Cake Wavelets", "Orientation Wavelets", 
      "Lie Analysis", "OrientationScoreTransform", "Gabor Wavelets", "Gabor"},
     "specialkeywords" -> {}, "tutorialcollectionlinks" -> {}, "index" -> 
    True, "label" -> "Lie Analysis Symbol", "language" -> "en", "paclet" -> 
    "LieAnalysis", "status" -> "None", "summary" -> 
    "GaborWaveletStack[n, scale] returns orientation sensitive Gabor wavelets \
having n orientations at scale GaborWaveletStack[n, scale, size] returns \
orientation sensitive Gabor wavelets having dimensions size", 
    "synonyms" -> {}, "tabletags" -> {}, "title" -> "GaborWaveletStack", 
    "titlemodifier" -> "", "windowtitle" -> "GaborWaveletStack", "type" -> 
    "Symbol", "uri" -> "LieAnalysis/ref/GaborWaveletStack"}},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[7729, 228, 260, 10, 70, "PrimaryExamplesSection",ExpressionUUID->"58b88855-db15-44c1-99a2-dc0573a4dd88",
   CellTags->"PrimaryExamplesSection",
   CellID->1]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 20944, 698}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[589, 21, 3857, 94, 70, "AnchorBarGrid",ExpressionUUID->"f56846a9-8412-4539-8fc5-c96e39694403",
 CellID->1],
Cell[4449, 117, 174, 6, 70, "ObjectNameGrid",ExpressionUUID->"744c947f-58cf-491c-a3bc-56d9ec6f82af"],
Cell[4626, 125, 932, 28, 70, "Usage",ExpressionUUID->"ae268680-c54d-4af4-a13d-70b3db718df0",
 CellID->982511436],
Cell[CellGroupData[{
Cell[5583, 157, 621, 19, 70, "NotesSection",ExpressionUUID->"006507fc-cf68-48bb-b7fb-2e9ce8ccc115",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1],
Cell[6207, 178, 31, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"0eb961f8-35cb-4481-8445-40ccd55afa52"],
Cell[6241, 180, 380, 11, 70, "Notes",ExpressionUUID->"3ba48c25-4c9c-47e8-ae88-241c1e8a8dc2",
 CellID->1067943069],
Cell[6624, 193, 116, 3, 70, "Notes",ExpressionUUID->"880ee6fc-95d9-4682-adcb-dd1f9abe0269",
 CellID->175077442],
Cell[6743, 198, 915, 23, 70, "3ColumnTableMod",ExpressionUUID->"24aeb864-7caa-4d37-be5a-39f2ed120564",
 CellID->206802571],
Cell[7661, 223, 31, 0, 70, "SectionFooterSpacer",ExpressionUUID->"c517e27f-5e7f-45a3-a282-ba1b08663811"]
}, Closed]],
Cell[CellGroupData[{
Cell[7729, 228, 260, 10, 70, "PrimaryExamplesSection",ExpressionUUID->"58b88855-db15-44c1-99a2-dc0573a4dd88",
 CellTags->"PrimaryExamplesSection",
 CellID->1],
Cell[CellGroupData[{
Cell[8014, 242, 187, 6, 70, "ExampleSection",ExpressionUUID->"b6e7f0fb-089e-47d7-928e-687befaa601b",
 CellID->1],
Cell[8204, 250, 92, 1, 70, "ExampleText",ExpressionUUID->"0fb2ad5b-0202-4c3c-af45-ffa466a9fef1",
 CellID->10662228],
Cell[8299, 253, 276, 8, 70, "Input",ExpressionUUID->"028d0601-ae0a-443a-938d-45512b96a0a4",
 CellID->87347538],
Cell[CellGroupData[{
Cell[8600, 265, 126, 3, 70, "ExampleDelimiter",ExpressionUUID->"3db178aa-8330-4f93-bd99-6fdcd6a908ab",
 CellID->1864818157],
Cell[8729, 270, 93, 1, 70, "ExampleText",ExpressionUUID->"c06147e1-6f05-4ab4-af41-29637757366e",
 CellID->1622420381],
Cell[8825, 273, 156, 4, 70, "Input",ExpressionUUID->"846748fb-e99b-4765-be3c-a9c61b8a4a8e",
 CellID->1153907965]
}, Open  ]],
Cell[CellGroupData[{
Cell[9018, 282, 125, 3, 70, "ExampleDelimiter",ExpressionUUID->"7f19b648-166e-43bc-9c61-431db690af43",
 CellID->785392555],
Cell[9146, 287, 106, 2, 70, "ExampleText",ExpressionUUID->"3141c00a-b40a-462e-8568-5724e7e5b9f8",
 CellID->1658177423],
Cell[9255, 291, 203, 5, 70, "Input",ExpressionUUID->"8d9452a0-9d22-4542-8705-309dacaaaf1a",
 CellID->1335414351]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[9507, 302, 187, 6, 70, "ExampleSection",ExpressionUUID->"9312cb7b-9a58-44e9-9968-3e9e18c148f1",
 CellID->1293636265],
Cell[9697, 310, 279, 5, 70, "ExampleText",ExpressionUUID->"e0403314-7a18-46dd-8ebc-54b94c3e802f",
 CellID->464037698],
Cell[9979, 317, 674, 20, 70, "Input",ExpressionUUID->"cd6eaf09-7f82-444c-bb1e-25401e6e5872",
 CellID->248412508]
}, Closed]],
Cell[CellGroupData[{
Cell[10690, 342, 189, 6, 70, "ExampleSection",ExpressionUUID->"7ae538e3-a3c1-47f6-aea6-1ca5b643d100",
 CellID->2061341341],
Cell[CellGroupData[{
Cell[10904, 352, 195, 6, 70, "ExampleSubsection",ExpressionUUID->"39cf4407-119e-4747-9573-883b06a6fab4",
 CellID->1295379749],
Cell[11102, 360, 115, 3, 70, "ExampleText",ExpressionUUID->"bbe21d8b-c327-4104-ae30-729ab07dff2b",
 CellID->93279754],
Cell[11220, 365, 1006, 27, 70, "Input",ExpressionUUID->"26944b21-60f3-4de6-9408-c4fa1456dd01",
 CellID->71245125]
}, Closed]],
Cell[CellGroupData[{
Cell[12263, 397, 189, 6, 70, "ExampleSubsection",ExpressionUUID->"ff94bc82-710e-4ed0-93f1-4b3b8d9b535e",
 CellID->154963103],
Cell[12455, 405, 113, 3, 70, "ExampleText",ExpressionUUID->"08f1ef99-7e9b-4f88-a317-5fd4b5071032",
 CellID->466631986],
Cell[12571, 410, 1106, 31, 70, "Input",ExpressionUUID->"80c50521-8823-4aad-a5dd-ced4ec4ac0d0",
 CellID->79419375]
}, Closed]],
Cell[CellGroupData[{
Cell[13714, 446, 198, 6, 70, "ExampleSubsection",ExpressionUUID->"0336ee6b-002b-450d-ad6a-e02b81ce5ba9",
 CellID->721708626],
Cell[13915, 454, 239, 5, 70, "ExampleText",ExpressionUUID->"0822bde7-e6fe-453f-9101-1d00da32eca5",
 CellID->599489700],
Cell[14157, 461, 582, 17, 70, "Input",ExpressionUUID->"27e395fb-9eef-47ed-b01c-06a623ecb0d3",
 CellID->310715018]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[14788, 484, 193, 6, 70, "ExampleSection",ExpressionUUID->"371e8a2b-347e-4579-aee8-3eb9cf340dba",
 CellID->258228157],
Cell[14984, 492, 93, 1, 70, "ExampleText",ExpressionUUID->"1ed6f081-1f68-46f5-99b0-9c3f235933af",
 CellID->1083195361],
Cell[15080, 495, 328, 9, 70, "Input",ExpressionUUID->"a243e0f2-57b2-4821-aa45-59a25ef259cb",
 CellID->1960391602],
Cell[CellGroupData[{
Cell[15433, 508, 126, 3, 70, "ExampleDelimiter",ExpressionUUID->"ce9e982a-3ad6-4aa7-8366-a04c9b7fa5fb",
 CellID->2130755712],
Cell[15562, 513, 113, 3, 70, "ExampleText",ExpressionUUID->"89c4f9f6-3e8a-4bea-b5b8-87fa5a6ef853",
 CellID->173954212],
Cell[15678, 518, 346, 10, 70, "Input",ExpressionUUID->"67c73aaf-84cb-4a21-b984-ea935c47a66c",
 CellID->374941992]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[16073, 534, 204, 6, 70, "ExampleSection",ExpressionUUID->"cf796fe1-fa12-46cd-8863-a521cf8124a9",
 CellID->2123667759],
Cell[16280, 542, 297, 11, 70, "ExampleText",ExpressionUUID->"b9bd7af6-ec0d-4ea0-92bb-1a944b6716b8",
 CellID->196131064],
Cell[16580, 555, 168, 5, 70, "Input",ExpressionUUID->"87bf4169-a22c-4f1b-9ab8-b591db96e9e4",
 CellID->396489419],
Cell[CellGroupData[{
Cell[16773, 564, 126, 3, 70, "ExampleDelimiter",ExpressionUUID->"d4ff9a4a-056d-4d3a-bc0a-032e603e9854",
 CellID->1659724248],
Cell[16902, 569, 121, 3, 70, "ExampleText",ExpressionUUID->"8b3a044f-acad-4608-9da9-053c9ed2eb64",
 CellID->37857162],
Cell[17026, 574, 126, 3, 70, "Input",ExpressionUUID->"95d9db3f-bb8a-4410-ada8-682034f09905",
 CellID->140482532]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[17213, 584, 31, 0, 70, "SectionFooterSpacer",ExpressionUUID->"ee2d3b68-b0aa-4673-b153-bff5faca7306"],
Cell[17247, 586, 150, 7, 70, "SeeAlsoSection",ExpressionUUID->"ba09f134-52ad-4886-89c2-aee600f34a36",
 CellID->1255426704],
Cell[17400, 595, 944, 28, 70, "SeeAlso",ExpressionUUID->"b038e19e-aaf2-469c-9ccb-b8dd884f094d",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[18381, 628, 156, 7, 70, "MoreAboutSection",ExpressionUUID->"b9ad1b40-e50f-4131-b181-94a65fe930bf",
 CellID->38303248],
Cell[18540, 637, 31, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"c364e57a-2313-40a3-b17f-58bde315ac28"],
Cell[18574, 639, 177, 5, 70, "MoreAbout",ExpressionUUID->"2152ac2e-e500-49df-a50c-308741cf45ee",
 CellID->1]
}, Open  ]],
Cell[18766, 647, 23, 0, 70, "FooterCell",ExpressionUUID->"4d700997-9922-4acd-8ec6-3cc6ff9f847c"]
}
]
*)

(* End of internal cache information *)
