(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     10900,        323]
NotebookOptionsPosition[      6936,        232]
NotebookOutlinePosition[      9065,        289]
CellTagsIndexPosition[      8981,        284]
WindowTitle->GlyphPlot
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["LIE ANALYSIS SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Related Guides",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"Related Guides", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"LieAnalysis Package\"\>":>
       Documentation`HelpLookup["paclet:LieAnalysis/guide/LieAnalysis"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAbout"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"LieAnalysis/ref/GlyphPlot\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["LieAnalysis/ref/GlyphPlot"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/LieAnalysis/ref/\
GlyphPlot.html"], StandardForm]], "Input", TextClipboardType -> "PlainText"]},
             Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$11329], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "LieAnalysis/ref/GlyphPlot", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[TextData[{
 Cell["GlyphPlot", "ObjectName"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]]],
 Cell[BoxData[""], "ObjectNameTranslation"]
}], "ObjectNameGrid"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"GlyphPlot", "[", 
       RowBox[{
        StyleBox["obj3DPositionOrientationData", "TI"], ",", " ", 
        StyleBox["options", "TI"]}], "]"}]], "InlineFormula"],
     " \[LineSeparator]Glyph visualization of ",
     StyleBox["Obj3DPostionOrientationData", "TI"]
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]]],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(2)", "ExampleCount"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->1],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(2)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1],

Cell["A glyph visualization from an orientation score", "ExampleText",
 CellID->712196086],

Cell[BoxData[{
 RowBox[{
  RowBox[{"os", " ", "=", " ", 
   RowBox[{"OrientationScoreTransform3D", "[", 
    RowBox[{"CenterArray", "[", 
     RowBox[{"1", ",", 
      RowBox[{"{", 
       RowBox[{"11", ",", "11", ",", "11"}], "}"}]}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"GlyphPlot", "[", "os", "]"}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->184605198],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->115438058],

Cell["\<\
If you have large datasets you can select a region by manipulating the \
Obj3DPositionOrientationData object\
\>", "ExampleText",
 CellID->110865646],

Cell[BoxData[
 RowBox[{"data", " ", "=", " ", 
  RowBox[{"LieAnalysisData", "[", 
   RowBox[{"{", 
    RowBox[{"\"\<image3d\>\"", ",", "\"\<random-lines-2\>\""}], "}"}], 
   "]"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->431814030],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ost", " ", "=", " ", 
   RowBox[{"OrientationScoreTransform3D", "[", "data", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"GlyphPlot", "[", 
  RowBox[{"ost", ",", 
   RowBox[{"RegionFunction", "\[Rule]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"#1", ">", "4"}], "&&", 
        RowBox[{"#1", " ", "<", " ", "10"}], "&&", 
        RowBox[{"#2", "<", "20"}], "&&", 
        RowBox[{"#3", "<", "20"}]}], ")"}], "&"}], ")"}]}]}], "]"}]}], "Input",\

 CellLabel->"In[2]:=",
 CellID->45611725]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "SectionFooterSpacer"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]]],
 "Related Guides"
}], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell["", "SectionHeaderSpacer"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["LieAnalysis Package"]],"paclet:LieAnalysis/guide/LieAnalysis"},
  "RefLink",
  BaseStyle->"MoreAbout"]], "MoreAbout",
 CellID->1]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"GlyphPlot",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "LieAnalysis Package", ButtonData -> 
         "paclet:LieAnalysis/guide/LieAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2017, 10, 26, 15, 6, 50.2721789}", 
    "history" -> {"0.5", "", "", ""}, "context" -> "LieAnalysis`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Lie Analysis Symbol", "language" -> "en", "paclet" -> "LieAnalysis", 
    "status" -> "None", "summary" -> 
    "GlyphPlot[obj3DPositionOrientationData, options] Glyph visualization of \
Obj3DPostionOrientationData", "synonyms" -> {}, "tabletags" -> {}, "title" -> 
    "GlyphPlot", "titlemodifier" -> "", "windowtitle" -> "GlyphPlot", "type" -> 
    "Symbol", "uri" -> "LieAnalysis/ref/GlyphPlot"}},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[4356, 124, 259, 10, 70, "PrimaryExamplesSection",ExpressionUUID->"bb87e44b-01f3-4c8d-9885-22fa3be58d70",
   CellTags->"PrimaryExamplesSection",
   CellID->1]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 8791, 277}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[581, 21, 3052, 74, 70, "AnchorBarGrid",ExpressionUUID->"45c8f1e4-a7e0-4623-acae-d9a81c5e6bb7",
 CellID->1],
Cell[3636, 97, 166, 6, 70, "ObjectNameGrid",ExpressionUUID->"655b3fa2-aaaa-4463-be8a-85a2f3425e6f"],
Cell[3805, 105, 526, 15, 70, "Usage",ExpressionUUID->"a458daac-fb89-4956-81a0-50b5889887fb",
 CellID->982511436],
Cell[CellGroupData[{
Cell[4356, 124, 259, 10, 70, "PrimaryExamplesSection",ExpressionUUID->"bb87e44b-01f3-4c8d-9885-22fa3be58d70",
 CellTags->"PrimaryExamplesSection",
 CellID->1],
Cell[CellGroupData[{
Cell[4640, 138, 187, 6, 70, "ExampleSection",ExpressionUUID->"0cd7630b-accc-4e5c-ad13-d0a53c583377",
 CellID->1],
Cell[4830, 146, 90, 1, 70, "ExampleText",ExpressionUUID->"0500abcc-40e1-4bd4-bc06-75723a54d484",
 CellID->712196086],
Cell[4923, 149, 379, 11, 70, "Input",ExpressionUUID->"c1e3eb6d-6a18-43ec-848f-50b0ad8e5e04",
 CellID->184605198],
Cell[CellGroupData[{
Cell[5327, 164, 125, 3, 70, "ExampleDelimiter",ExpressionUUID->"a4d6c455-bc04-4641-b828-a07460e11974",
 CellID->115438058],
Cell[5455, 169, 159, 4, 70, "ExampleText",ExpressionUUID->"20bc527e-f9f8-4f12-8ee8-1cf9f17fff1d",
 CellID->110865646],
Cell[5617, 175, 235, 7, 70, "Input",ExpressionUUID->"a19b0e78-1cc7-4e0f-ad16-647d69c54d9e",
 CellID->431814030],
Cell[5855, 184, 574, 18, 70, "Input",ExpressionUUID->"198bbbd3-a3db-4b96-9de4-bbebe40b30a2",
 CellID->45611725]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[6490, 209, 31, 0, 70, "SectionFooterSpacer",ExpressionUUID->"1c43b375-4367-44c9-87b8-93aa0ce83fe2"],
Cell[6524, 211, 156, 7, 70, "MoreAboutSection",ExpressionUUID->"c43ec049-4c67-458e-9d13-ddea18c8d057",
 CellID->38303248],
Cell[6683, 220, 31, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"a517cffd-8308-4595-93ff-c91278163c53"],
Cell[6717, 222, 177, 5, 70, "MoreAbout",ExpressionUUID->"ba4f3782-14fd-40d4-9814-2b241abe6e00",
 CellID->1]
}, Open  ]],
Cell[6909, 230, 23, 0, 70, "FooterCell",ExpressionUUID->"c1956ca7-035b-41dc-9e73-612d9feb726a"]
}
]
*)

(* End of internal cache information *)
