(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     22210,        650]
NotebookOptionsPosition[     15187,        502]
NotebookOutlinePosition[     17778,        565]
CellTagsIndexPosition[     17693,        560]
WindowTitle->InverseOrientationScoreTransform
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["LIE ANALYSIS SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"OrientationScoreTransform\"\>":>
       Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/OrientationScoreTransform"], \
"\<\"InverseOrientationScoreTransform3D\"\>":>Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/InverseOrientationScoreTransform3D"], \
"\<\"CakeWaveletStack\"\>":>Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/CakeWaveletStack"], \
"\<\"GaborWaveletStack\"\>":>Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/GaborWaveletStack"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Related Guides",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"Related Guides", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"LieAnalysis Package\"\>":>
       Documentation`HelpLookup["paclet:LieAnalysis/guide/LieAnalysis"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAbout"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->
         False], {"\<\"LieAnalysis/ref/InverseOrientationScoreTransform\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["LieAnalysis/ref/InverseOrientationScoreTransform"]}, 
            Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/LieAnalysis/ref/\
InverseOrientationScoreTransform.html"], StandardForm]], "Input", 
              TextClipboardType -> "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$12477], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "LieAnalysis/ref/InverseOrientationScoreTransform", ".html"]], 
           None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[TextData[{
 Cell["InverseOrientationScoreTransform", "ObjectName"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]]],
 Cell[BoxData[""], "ObjectNameTranslation"]
}], "ObjectNameGrid"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"InverseOrientationScoreTransform", "[", 
       StyleBox["ObjPositionOrientationData", "TI"], "]"}]], "InlineFormula"],
     
     " \[LineSeparator]applies reconstruction to the ",
     StyleBox["ObjPositionOrientationData", "TI"],
     " returning a matrix."
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"InverseOrientationScoreTransform", "[", 
       RowBox[{
        StyleBox["ObjPositionOrientationData", "TI"], ",", " ", 
        StyleBox["options", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]applies reconstruction defined by the ",
     StyleBox["options", "TI"],
     " to the ",
     StyleBox["ObjPositionOrientationData", "TI"],
     " returning a matrix."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    TemplateBox[{6},
     "Spacer1"]]],
   "Details"
  }], "NotesFrameText"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1],

Cell["", "SectionHeaderSpacer"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["InverseOrientationScoreTransform"]],
    "paclet:LieAnalysis/ref/InverseOrientationScoreTransform"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 " is the inverse of ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreTransform"]],
    "paclet:LieAnalysis/ref/OrientationScoreTransform"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 "."
}], "Notes",
 CellID->1067943069],

Cell["The following options can be provided:", "Notes",
 CellID->180584471],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon"], "\"\<Method\>\"", "\"\<Summation\>\"", 
    Cell["method of reconstruction", "TableText"]},
   {Cell["      ", "TableRowIcon"], "\"\<UseDcComponent\>\"", 
    ButtonBox["True",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/True"], Cell["\<\
specifies if the low frequencies are restored in the reconstruction\
\>", "TableText"]}
  }]], "3ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}},
 GridBoxDividers->{"Rows" -> {{True, True, True}}}},
 CellID->172835921],

Cell["\<\
Valid methods for reconstruction are \"Summation\", \"L2adjoint\" and \
\"RknAdjoint\".\
\>", "Notes",
 CellID->218028777],

Cell["", "SectionFooterSpacer"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]]],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(5)", "ExampleCount"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->1],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(2)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1],

Cell["Simple reconstruction using the default settings.", "ExampleText",
 CellID->262482831],

Cell[BoxData[{
 RowBox[{"Needs", "[", "\"\<LieAnalysis`\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"InverseOrientationScoreTransform", "[", 
  RowBox[{"OrientationScoreTransform", "[", 
   RowBox[{"LieAnalysisData", "[", 
    RowBox[{"{", 
     RowBox[{"\"\<image\>\"", ",", "\"\<turtle\>\""}], "}"}], "]"}], "]"}], 
  "]"}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->210610950],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->560298113],

Cell["Reconstruction works for all types of wavelets", "ExampleText",
 CellID->315405611],

Cell[BoxData[
 RowBox[{
  RowBox[{"InverseOrientationScoreTransform", "[", 
   RowBox[{"OrientationScoreTransform", "[", 
    RowBox[{
     RowBox[{"LieAnalysisData", "[", 
      RowBox[{"{", 
       RowBox[{"\"\<image\>\"", ",", "\"\<turtle\>\""}], "}"}], "]"}], ",", 
     RowBox[{"MultiScaleCakeWaveletStack", "[", 
      RowBox[{"12", ",", "101", ",", 
       RowBox[{"{", 
        RowBox[{"0.1", ",", "0.9", ",", "3"}], "}"}]}], "]"}]}], "]"}], "]"}],
   "\[IndentingNewLine]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->271819100]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "Scope",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1293636265],

Cell["Reconstruction without the low frequencies.", "ExampleText",
 CellID->307151509],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"InverseOrientationScoreTransform", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"ost", " ", "=", " ", 
       RowBox[{"OrientationScoreTransform", "[", 
        RowBox[{"LieAnalysisData", "[", 
         RowBox[{"{", 
          RowBox[{"\"\<image\>\"", ",", "\"\<turtle\>\""}], "}"}], "]"}], 
        "]"}]}], ",", " ", 
      RowBox[{"\"\<UseDcComponent\>\"", "\[Rule]", "#"}]}], 
     "\[IndentingNewLine]", "]"}], "&"}], "/@", 
   RowBox[{"{", 
    RowBox[{"True", ",", "False"}], "}"}]}], "\[IndentingNewLine]"}]], "Input",\

 CellLabel->"In[1]:=",
 CellID->890893146],

Cell["\<\
The low frequencies image can be get from the Orientation Score object.\
\>", "ExampleText",
 CellID->315194948],

Cell[BoxData[
 RowBox[{
  RowBox[{
  "ost", "\[LeftDoubleBracket]", "\"\<DcFilteredImage\>\"", 
   "\[RightDoubleBracket]"}], "//", "Image"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->340242733]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Options",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(2)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->556263886],

Cell[CellGroupData[{

Cell[TextData[{
 "\"Method\"",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CellID->339919962],

Cell["Valid methods are \"Summation\", \"L2adjoint\" and \"RknAdjoint\".", \
"ExampleText",
 CellID->303320183],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"InverseOrientationScoreTransform", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"ost", " ", "=", " ", 
      RowBox[{"OrientationScoreTransform", "[", 
       RowBox[{"LieAnalysisData", "[", 
        RowBox[{"{", 
         RowBox[{"\"\<image\>\"", ",", "\"\<turtle\>\""}], "}"}], "]"}], 
       "]"}]}], ",", " ", 
     RowBox[{"\"\<Method\>\"", "\[Rule]", "#"}]}], "\[IndentingNewLine]", 
    "]"}], "&"}], "/@", 
  RowBox[{"{", 
   RowBox[{
   "\"\<Summation\>\"", ",", "\"\<L2adjoint\>\"", ",", "\"\<RknAdjoint\>\""}],
    "}"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->534117043]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "\"UseDcComponent\"",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CellID->76023842],

Cell[TextData[{
 "Sometimes you want to apply a reconstruction of the Orientation Score \
without the DC component, this can be done by setting ",
 StyleBox["UseDcComponent ",
  FontSlant->"Plain"],
 "to false"
}], "ExampleText",
 CellID->7612736],

Cell[BoxData[
 RowBox[{"InverseOrientationScoreTransform", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"ost", " ", "=", " ", 
    RowBox[{"OrientationScoreTransform", "[", 
     RowBox[{"LieAnalysisData", "[", 
      RowBox[{"{", 
       RowBox[{"\"\<image\>\"", ",", "\"\<turtle\>\""}], "}"}], "]"}], 
     "]"}]}], ",", " ", 
   RowBox[{"\"\<UseDcComponent\>\"", "\[Rule]", "False"}]}], 
  "\[IndentingNewLine]", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->76768548]
}, Closed]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "SectionFooterSpacer"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]]],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreTransform"]],
    "paclet:LieAnalysis/ref/OrientationScoreTransform"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["InverseOrientationScoreTransform3D"]],
    "paclet:LieAnalysis/ref/InverseOrientationScoreTransform3D"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["CakeWaveletStack"]],"paclet:LieAnalysis/ref/CakeWaveletStack"},
   
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["GaborWaveletStack"]],
    "paclet:LieAnalysis/ref/GaborWaveletStack"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]]],
 "Related Guides"
}], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell["", "SectionHeaderSpacer"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["LieAnalysis Package"]],"paclet:LieAnalysis/guide/LieAnalysis"},
  "RefLink",
  BaseStyle->"MoreAbout"]], "MoreAbout",
 CellID->1]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"InverseOrientationScoreTransform",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "LieAnalysis Package", ButtonData -> 
         "paclet:LieAnalysis/guide/LieAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2017, 10, 26, 15, 6, 53.1382016}", 
    "history" -> {"0.2", "0.4", "", ""}, "context" -> "LieAnalysis`", 
    "keywords" -> {
     "Orientation Scores", "Inverse ", "Cake Wavelets", "LieAnalysis", 
      "Inverse Orientation Score Transform", "Orientation Score Transform"}, 
    "specialkeywords" -> {}, "tutorialcollectionlinks" -> {}, "index" -> True,
     "label" -> "Lie Analysis Symbol", "language" -> "en", "paclet" -> 
    "LieAnalysis", "status" -> "None", "summary" -> 
    "InverseOrientationScoreTransform[ObjPositionOrientationData] applies \
reconstruction to the ObjPositionOrientationData returning a matrix. \
InverseOrientationScoreTransform[ObjPositionOrientationData, options] applies \
reconstruction defined by the options to the ObjPositionOrientationData \
returning a matrix.", "synonyms" -> {}, "tabletags" -> {}, "title" -> 
    "InverseOrientationScoreTransform", "titlemodifier" -> "", "windowtitle" -> 
    "InverseOrientationScoreTransform", "type" -> "Symbol", "uri" -> 
    "LieAnalysis/ref/InverseOrientationScoreTransform"}},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[7972, 233, 259, 10, 70, "PrimaryExamplesSection",ExpressionUUID->"8e972384-c7a7-4711-9fe5-51a9ee3b6291",
   CellTags->"PrimaryExamplesSection",
   CellID->1]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 17503, 553}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[604, 21, 4093, 99, 70, "AnchorBarGrid",ExpressionUUID->"2a222d64-5def-433d-aaa9-508c63da8625",
 CellID->1],
Cell[4700, 122, 189, 6, 70, "ObjectNameGrid",ExpressionUUID->"00cc3091-3ddf-4859-a42f-4b82ce360594"],
Cell[4892, 130, 973, 27, 70, "Usage",ExpressionUUID->"175cc5c3-9304-4b33-b97f-85bdb1142a6b",
 CellID->982511436],
Cell[CellGroupData[{
Cell[5890, 161, 621, 19, 70, "NotesSection",ExpressionUUID->"6a70e7f9-1002-4a52-8c9c-1c3059f7d889",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1],
Cell[6514, 182, 31, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"ffd05387-d334-4b8c-904a-6d6c31caad5a"],
Cell[6548, 184, 502, 16, 70, "Notes",ExpressionUUID->"6430da03-42c8-4962-8261-d8a8cb93095c",
 CellID->1067943069],
Cell[7053, 202, 75, 1, 70, "Notes",ExpressionUUID->"96f3bba7-60af-40c3-8fa5-445abe3f6902",
 CellID->180584471],
Cell[7131, 205, 635, 15, 70, "3ColumnTableMod",ExpressionUUID->"6c7b9d04-4456-474e-81c5-2166c5f4cad1",
 CellID->172835921],
Cell[7769, 222, 132, 4, 70, "Notes",ExpressionUUID->"713deebb-0f76-47c4-a809-03973f3ae3f6",
 CellID->218028777],
Cell[7904, 228, 31, 0, 70, "SectionFooterSpacer",ExpressionUUID->"7b62596b-e9b5-434a-8068-cdaa048b7703"]
}, Closed]],
Cell[CellGroupData[{
Cell[7972, 233, 259, 10, 70, "PrimaryExamplesSection",ExpressionUUID->"8e972384-c7a7-4711-9fe5-51a9ee3b6291",
 CellTags->"PrimaryExamplesSection",
 CellID->1],
Cell[CellGroupData[{
Cell[8256, 247, 187, 6, 70, "ExampleSection",ExpressionUUID->"123d8169-1d6b-4637-ac36-40dbbdd08361",
 CellID->1],
Cell[8446, 255, 92, 1, 70, "ExampleText",ExpressionUUID->"f3b59a72-c950-4917-9975-bec9845f76a5",
 CellID->262482831],
Cell[8541, 258, 382, 9, 70, "Input",ExpressionUUID->"88c63479-9fdb-42cd-8c84-491435a46f26",
 CellID->210610950],
Cell[CellGroupData[{
Cell[8948, 271, 125, 3, 70, "ExampleDelimiter",ExpressionUUID->"4b4e054c-6ea8-41fc-93b3-dba16fce8115",
 CellID->560298113],
Cell[9076, 276, 89, 1, 70, "ExampleText",ExpressionUUID->"2951ebe5-5bb9-4365-befa-d3012d6788b1",
 CellID->315405611],
Cell[9168, 279, 537, 14, 70, "Input",ExpressionUUID->"04c5a6e7-5939-4d16-9819-cf517a532e10",
 CellID->271819100]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[9754, 299, 187, 6, 70, "ExampleSection",ExpressionUUID->"bc09795f-c119-4ac9-8098-e56541c2bd96",
 CellID->1293636265],
Cell[9944, 307, 86, 1, 70, "ExampleText",ExpressionUUID->"b4b9445c-fb49-4077-a2e6-43dd0c018603",
 CellID->307151509],
Cell[10033, 310, 643, 18, 70, "Input",ExpressionUUID->"f4c3b74c-4b0e-44ff-9caa-638ae7da0a4d",
 CellID->890893146],
Cell[10679, 330, 122, 3, 70, "ExampleText",ExpressionUUID->"dc5c68f3-9b9f-442b-8358-5882957ceb8a",
 CellID->315194948],
Cell[10804, 335, 195, 6, 70, "Input",ExpressionUUID->"a31e974b-d691-46be-9496-04bd2684ebd9",
 CellID->340242733]
}, Closed]],
Cell[CellGroupData[{
Cell[11036, 346, 188, 6, 70, "ExampleSection",ExpressionUUID->"4cb193da-90b3-443b-b366-83eac3ca0c36",
 CellID->556263886],
Cell[CellGroupData[{
Cell[11249, 356, 197, 6, 70, "ExampleSubsection",ExpressionUUID->"f7a24300-8a33-4626-b92a-fc6a6fb37e3c",
 CellID->339919962],
Cell[11449, 364, 111, 2, 70, "ExampleText",ExpressionUUID->"f51f5d1b-0034-44e8-b239-09770c1af59c",
 CellID->303320183],
Cell[11563, 368, 644, 18, 70, "Input",ExpressionUUID->"6083d447-79a8-47a7-90d8-faac2c84fa58",
 CellID->534117043]
}, Closed]],
Cell[CellGroupData[{
Cell[12244, 391, 204, 6, 70, "ExampleSubsection",ExpressionUUID->"6ea61974-422f-4770-aef8-0dc1ccff1c54",
 CellID->76023842],
Cell[12451, 399, 247, 7, 70, "ExampleText",ExpressionUUID->"afa372f4-74c2-4f53-a47c-e3b9d69879d9",
 CellID->7612736],
Cell[12701, 408, 480, 12, 70, "Input",ExpressionUUID->"e692ae33-bc95-4ac2-a4d7-c7aee3687210",
 CellID->76768548]
}, Closed]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[13242, 427, 31, 0, 70, "SectionFooterSpacer",ExpressionUUID->"1fa32b91-d23b-4bd2-b1e6-dcdf9e330742"],
Cell[13276, 429, 150, 7, 70, "SeeAlsoSection",ExpressionUUID->"c78b019a-5d98-4483-b1cc-50f8626038fb",
 CellID->1255426704],
Cell[13429, 438, 1309, 38, 70, "SeeAlso",ExpressionUUID->"feedf731-51a7-4d4a-803e-671783768dd4",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[14775, 481, 156, 7, 70, "MoreAboutSection",ExpressionUUID->"cce73996-0c88-4497-a6f8-7fc36b07280d",
 CellID->38303248],
Cell[14934, 490, 31, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"2c563b58-24b2-4aa0-9cec-85f0e13f2e8e"],
Cell[14968, 492, 177, 5, 70, "MoreAbout",ExpressionUUID->"440e3210-16cb-4da3-9354-9cc1ef7ffbaf",
 CellID->1]
}, Open  ]],
Cell[15160, 500, 23, 0, 70, "FooterCell",ExpressionUUID->"219034c1-462d-4be7-bc12-8e85371897fb"]
}
]
*)

(* End of internal cache information *)
