(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     20451,        600]
NotebookOptionsPosition[     13788,        459]
NotebookOutlinePosition[     16415,        523]
CellTagsIndexPosition[     16330,        518]
WindowTitle->InverseOrientationScoreTransform3D
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["LIE ANALYSIS SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"OrientationScoreTransform3D\"\>":>
       Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/OrientationScoreTransform3D"], \
"\<\"InverseOrientationScoreTransform\"\>":>Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/InverseOrientationScoreTransform"], \
"\<\"CakeWaveletStack3D\"\>":>Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/CakeWaveletStack3D"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Related Guides",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"Related Guides", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"LieAnalysis Package\"\>":>
       Documentation`HelpLookup["paclet:LieAnalysis/guide/LieAnalysis"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAbout"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->
         False], {"\<\"LieAnalysis/ref/InverseOrientationScoreTransform3D\"\>\
":>None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["LieAnalysis/ref/InverseOrientationScoreTransform3D"]}, 
            Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/LieAnalysis/ref/\
InverseOrientationScoreTransform3D.html"], StandardForm]], "Input", 
              TextClipboardType -> "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$11885], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "LieAnalysis/ref/InverseOrientationScoreTransform3D", ".html"]], 
           None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[TextData[{
 Cell["InverseOrientationScoreTransform3D", "ObjectName"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]]],
 Cell[BoxData[""], "ObjectNameTranslation"]
}], "ObjectNameGrid"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"InverseOrientationScoreTransform3D", "[", 
       StyleBox["Obj3DPositionOrientationData", "TI"], "]"}]], 
      "InlineFormula"],
     " \[LineSeparator]applies reconstruction to ",
     StyleBox["Obj3DPositionOrientationData", "TI"],
     " returning a volume."
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"InverseOrientationScoreTransform3D", "[", 
       RowBox[{
        StyleBox["Obj3DPostionOrientationData", "TI"], ",", " ", 
        StyleBox["options", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]applies reconstruction defined by ",
     StyleBox["options", "TI"],
     " to ",
     StyleBox["Obj3DPositionOrientationData", "TI"],
     " returning a volume"
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    TemplateBox[{6},
     "Spacer1"]]],
   "Details"
  }], "NotesFrameText"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1],

Cell["", "SectionHeaderSpacer"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["InverseOrientationScoreTransform3D"]],
    "paclet:LieAnalysis/ref/InverseOrientationScoreTransform3D"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 " is the inverse of ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreTransform3D"]],
    "paclet:LieAnalysis/ref/OrientationScoreTransform3D"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 "."
}], "Notes",
 CellID->7862011],

Cell["\<\
Only the real part of the orientation score transform is used for \
reconstruction.\
\>", "Notes",
 CellID->112212598],

Cell["The following options can be provided:", "Notes",
 CellID->300162034],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon"], "\"\<Method\>\"", "\"\<Summation\>\"", 
    Cell["type of reconstruction that is used", "TableText"]},
   {Cell["      ", "TableRowIcon"], "\"\<UseDcComponent\>\"", 
    ButtonBox["True",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/True"], Cell["\<\
specifies if the low-frequencies also should be used in the reconstruction\
\>", "TableText"]}
  }]], "3ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}},
 GridBoxDividers->{"Rows" -> {{True, True, True}}}},
 CellID->599638623],

Cell["\<\
Valid methods for reconstruction are \"Summation\", \"L2adjoint\" and \
\"RknAdjoint\".\
\>", "Notes",
 CellID->182340293],

Cell["", "SectionFooterSpacer"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]]],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(4)", "ExampleCount"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->1],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(2)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1],

Cell["Simple reconstruction using the default settings", "ExampleText",
 CellID->420556418],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Needs", "[", "\"\<LieAnalysis`\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"InverseOrientationScoreTransform3D", "[", 
  RowBox[{"OrientationScoreTransform3D", "[", 
   RowBox[{"LieAnalysisData", "[", 
    RowBox[{"{", 
     RowBox[{"\"\<image3d\>\"", ",", "\"\<spiral-with-varying-radius\>\""}], 
     "}"}], "]"}], "]"}], "]"}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->239305471],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->1799272639],

Cell["Different reconstruction methods can be used", "ExampleText",
 CellID->1658010266],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"InverseOrientationScoreTransform3D", "[", 
    RowBox[{
     RowBox[{"OrientationScoreTransform3D", "[", 
      RowBox[{"LieAnalysisData", "[", 
       RowBox[{"{", 
        RowBox[{
        "\"\<image3d\>\"", ",", "\"\<spiral-with-varying-radius\>\""}], "}"}],
        "]"}], "]"}], ",", 
     RowBox[{"\"\<Method\>\"", "\[Rule]", "#"}]}], "]"}], "&"}], "/@", 
  RowBox[{"{", 
   RowBox[{
   "\"\<Summation\>\"", ",", "\"\<L2adjoint\>\"", ",", "\"\<RknAdjoint\>\""}],
    "}"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->262314990]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "Options",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(2)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->121604869],

Cell[CellGroupData[{

Cell[TextData[{
 "\"Method\"",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CellID->447906787],

Cell["Valid methods are \"Summation\", \"L2adjoint\" and \"RknAdjoint\".", \
"ExampleText",
 CellID->48411346],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"InverseOrientationScoreTransform3D", "[", 
    RowBox[{
     RowBox[{"OrientationScoreTransform3D", "[", 
      RowBox[{"LieAnalysisData", "[", 
       RowBox[{"{", 
        RowBox[{"\"\<image3d\>\"", ",", "\"\<random-lines-1\>\""}], "}"}], 
       "]"}], "]"}], ",", " ", 
     RowBox[{"\"\<Method\>\"", "\[Rule]", "#"}]}], "]"}], "&"}], "/@", 
  RowBox[{"{", 
   RowBox[{
   "\"\<Summation\>\"", ",", "\"\<L2adjoint\>\"", ",", "\"\<RknAdjoint\>\""}],
    "}"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->263548734],

Cell[BoxData[""], "Input",
 CellLabel->"In[2]:=",
 CellID->211509383]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "\"UseDcComponent\"",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CellID->173642531],

Cell[TextData[{
 "Sometimes you want to apply a reconstruction of the Orientation Score \
without the DC component, this can be done by setting ",
 StyleBox["UseDcComponent ",
  FontSlant->"Plain"],
 "to false."
}], "ExampleText",
 CellID->227601117],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"InverseOrientationScoreTransform3D", "[", 
    RowBox[{
     RowBox[{"OrientationScoreTransform3D", "[", 
      RowBox[{"LieAnalysisData", "[", 
       RowBox[{"{", 
        RowBox[{"\"\<image3d\>\"", ",", "\"\<crossing-circles\>\""}], "}"}], 
       "]"}], "]"}], ",", " ", 
     RowBox[{"\"\<UseDcComponent\>\"", "\[Rule]", "#"}]}], 
    "\[IndentingNewLine]", "]"}], "&"}], "/@", 
  RowBox[{"{", 
   RowBox[{"True", ",", " ", "False"}], "}"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->338187751]
}, Closed]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "SectionFooterSpacer"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]]],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreTransform3D"]],
    "paclet:LieAnalysis/ref/OrientationScoreTransform3D"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["InverseOrientationScoreTransform"]],
    "paclet:LieAnalysis/ref/InverseOrientationScoreTransform"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["CakeWaveletStack3D"]],
    "paclet:LieAnalysis/ref/CakeWaveletStack3D"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]]],
 "Related Guides"
}], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell["", "SectionHeaderSpacer"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["LieAnalysis Package"]],"paclet:LieAnalysis/guide/LieAnalysis"},
  "RefLink",
  BaseStyle->"MoreAbout"]], "MoreAbout",
 CellID->1]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"InverseOrientationScoreTransform3D",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "LieAnalysis Package", ButtonData -> 
         "paclet:LieAnalysis/guide/LieAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2017, 10, 26, 15, 6, 51.6761865}", 
    "history" -> {"0.2", "1.0", "", ""}, "context" -> "LieAnalysis`", 
    "keywords" -> {
     "Orientation Scores", "Inverse", "Cake Wavelets", "LieAnalysis", 
      "Inverse Orientation Score Transform", "Orientation Score Transform", 
      "Wavelet Transform"}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Lie Analysis Symbol", "language" -> "en", "paclet" -> "LieAnalysis", 
    "status" -> "None", "summary" -> 
    "InverseOrientationScoreTransform3D[Obj3DPositionOrientationData] applies \
reconstruction to Obj3DPositionOrientationData returning a volume. \
InverseOrientationScoreTransform3D[Obj3DPostionOrientationData, \\ options] \
applies reconstruction defined by options to Obj3DPositionOrientationData \
returning a volume", "synonyms" -> {}, "tabletags" -> {}, "title" -> 
    "InverseOrientationScoreTransform3D", "titlemodifier" -> "", 
    "windowtitle" -> "InverseOrientationScoreTransform3D", "type" -> "Symbol",
     "uri" -> "LieAnalysis/ref/InverseOrientationScoreTransform3D"}},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[8026, 237, 259, 10, 70, "PrimaryExamplesSection",ExpressionUUID->"5fad0e63-91f0-4d74-bb85-c49d086a6051",
   CellTags->"PrimaryExamplesSection",
   CellID->1]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 16140, 511}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[606, 21, 3990, 97, 70, "AnchorBarGrid",ExpressionUUID->"142512c2-a7f2-412d-86ee-7f07cff00a87",
 CellID->1],
Cell[4599, 120, 191, 6, 70, "ObjectNameGrid",ExpressionUUID->"973b98b1-a531-4564-b7c6-5e49cd9802b5"],
Cell[4793, 128, 972, 27, 70, "Usage",ExpressionUUID->"ef0b97fd-b342-4a69-b3b2-d6462a8de2d1",
 CellID->982511436],
Cell[CellGroupData[{
Cell[5790, 159, 621, 19, 70, "NotesSection",ExpressionUUID->"ebce0a91-9a56-454a-b8fc-73f1fde47bfc",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1],
Cell[6414, 180, 31, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"d2b4611d-42e6-457b-a6ee-5921addfee6c"],
Cell[6448, 182, 507, 16, 70, "Notes",ExpressionUUID->"fd25e03a-d583-472d-9c45-17eef5d413f7",
 CellID->7862011],
Cell[6958, 200, 128, 4, 70, "Notes",ExpressionUUID->"71189444-29cd-4997-b0be-29074d4bc398",
 CellID->112212598],
Cell[7089, 206, 75, 1, 70, "Notes",ExpressionUUID->"32b02ca9-7d4b-47f6-8657-ef61f17706d3",
 CellID->300162034],
Cell[7167, 209, 653, 15, 70, "3ColumnTableMod",ExpressionUUID->"3a4ef5dc-3837-4985-82a0-3b829c959ae7",
 CellID->599638623],
Cell[7823, 226, 132, 4, 70, "Notes",ExpressionUUID->"b4e3bfae-ac6d-48ce-bfb3-a4e6ca4ae504",
 CellID->182340293],
Cell[7958, 232, 31, 0, 70, "SectionFooterSpacer",ExpressionUUID->"9316f69a-0f27-4582-9f62-af9459d8661f"]
}, Closed]],
Cell[CellGroupData[{
Cell[8026, 237, 259, 10, 70, "PrimaryExamplesSection",ExpressionUUID->"5fad0e63-91f0-4d74-bb85-c49d086a6051",
 CellTags->"PrimaryExamplesSection",
 CellID->1],
Cell[CellGroupData[{
Cell[8310, 251, 187, 6, 70, "ExampleSection",ExpressionUUID->"33975b1c-63e8-460e-a9ab-69b37170dc6a",
 CellID->1],
Cell[8500, 259, 91, 1, 70, "ExampleText",ExpressionUUID->"34c9ce46-d688-477c-9f5b-714e4ba2caf7",
 CellID->420556418],
Cell[8594, 262, 432, 11, 70, "Input",ExpressionUUID->"811923ed-5bc6-4495-a97a-596fe6f88872",
 CellID->239305471],
Cell[CellGroupData[{
Cell[9051, 277, 126, 3, 70, "ExampleDelimiter",ExpressionUUID->"4cee663e-fb3d-426a-9a37-f073d09d04e0",
 CellID->1799272639],
Cell[9180, 282, 88, 1, 70, "ExampleText",ExpressionUUID->"12815286-cd2e-4208-9038-03afc7cc2d34",
 CellID->1658010266],
Cell[9271, 285, 581, 17, 70, "Input",ExpressionUUID->"63667485-d727-439d-8f84-c0594e4669a4",
 CellID->262314990]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[9901, 308, 188, 6, 70, "ExampleSection",ExpressionUUID->"58204e3c-8046-4eda-a5e7-3b51977eac7a",
 CellID->121604869],
Cell[CellGroupData[{
Cell[10114, 318, 197, 6, 70, "ExampleSubsection",ExpressionUUID->"91f4e753-46d6-45fa-81b2-03ec7d96695f",
 CellID->447906787],
Cell[10314, 326, 110, 2, 70, "ExampleText",ExpressionUUID->"e0f8d78b-8891-4a0f-9e5f-a796158b924a",
 CellID->48411346],
Cell[10427, 330, 565, 16, 70, "Input",ExpressionUUID->"dbcd493a-3e26-4649-b651-2c0bfbf7d369",
 CellID->263548734],
Cell[10995, 348, 69, 2, 70, "Input",ExpressionUUID->"c701f401-0204-4ccb-9b1e-cad61f9c84db",
 CellID->211509383]
}, Closed]],
Cell[CellGroupData[{
Cell[11101, 355, 205, 6, 70, "ExampleSubsection",ExpressionUUID->"1b77408d-e4d0-41a6-aa22-faca67132095",
 CellID->173642531],
Cell[11309, 363, 250, 7, 70, "ExampleText",ExpressionUUID->"863a3147-e35c-49a4-81dd-56d183748569",
 CellID->227601117],
Cell[11562, 372, 548, 15, 70, "Input",ExpressionUUID->"5ab7d447-97e6-4888-b913-da635ab3902e",
 CellID->338187751]
}, Closed]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[12171, 394, 31, 0, 70, "SectionFooterSpacer",ExpressionUUID->"650bae5e-a260-4642-b904-2afa9ecb35cd"],
Cell[12205, 396, 150, 7, 70, "SeeAlsoSection",ExpressionUUID->"513fe095-0898-4a02-ad00-bcdd4944eeba",
 CellID->1255426704],
Cell[12358, 405, 981, 28, 70, "SeeAlso",ExpressionUUID->"f4a70bad-adb9-4600-bdcf-94e1cf0f623f",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[13376, 438, 156, 7, 70, "MoreAboutSection",ExpressionUUID->"7a6450d6-e7ba-446b-b651-3d9103836b17",
 CellID->38303248],
Cell[13535, 447, 31, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"418e9296-3e4e-4283-81d6-ff06a2ea52d7"],
Cell[13569, 449, 177, 5, 70, "MoreAbout",ExpressionUUID->"336f8e22-e889-43a4-a916-8296f749c488",
 CellID->1]
}, Open  ]],
Cell[13761, 457, 23, 0, 70, "FooterCell",ExpressionUUID->"e60d616f-148c-453b-b213-a12dead34ae8"]
}
]
*)

(* End of internal cache information *)
