(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     31616,        945]
NotebookOptionsPosition[     22002,        746]
NotebookOutlinePosition[     24682,        810]
CellTagsIndexPosition[     24597,        805]
WindowTitle->LeftInvariantDerivatives
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["LIE ANALYSIS SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"InverseOrientationScoreTransform\"\>":>
       Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/InverseOrientationScoreTransform"], \
"\<\"CakeWaveletStack\"\>":>Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/CakeWaveletStack"], \
"\<\"GaborWaveletStack\"\>":>Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/GaborWaveletStack"], \
"\<\"OrientationScoreTransform\"\>":>Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/OrientationScoreTransform"], \
"\<\"OrientationScoreTransform3D\"\>":>Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/OrientationScoreTransform3D"], \
"\<\"LeftInvariantDerivatives3D\"\>":>Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/LeftInvariantDerivatives3D"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->
         False], {"\<\"LieAnalysis/ref/OrientationScoreDerivatives\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["LieAnalysis/ref/OrientationScoreDerivatives"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/LieAnalysis/ref/\
OrientationScoreDerivatives.html"], StandardForm]], "Input", 
              TextClipboardType -> "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$13748], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "LieAnalysis/ref/OrientationScoreDerivatives", ".html"]], 
           None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[TextData[{
 Cell["LeftInvariantDerivatives", "ObjectName"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]]],
 Cell[BoxData[""], "ObjectNameTranslation"]
}], "ObjectNameGrid"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"LeftInvariantDerivatives", "[", 
       StyleBox[
        RowBox[{"ObjPositionOrientationData", ",", " ", 
         RowBox[{"{", 
          RowBox[{
           SubscriptBox["\[Sigma]", "Spatial"], ",", " ", 
           SubscriptBox["\[Sigma]", "Angular"]}], "}"}], ",", " ", 
         "derivativeIndex"}], "TI"], "]"}]], "InlineFormula"],
     "\[LineSeparator]Computes the",
     Cell[BoxData[
      RowBox[{" ", 
       SubscriptBox["A", 
        StyleBox["derivativeIndex", "TI"]]}]], "InlineFormula"],
     " derivative(s) from ",
     StyleBox["ObjPositionOrientationData", "TI"],
     " using Gaussian derivatives at specified scales ",
     Cell[BoxData[
      SubscriptBox["\[Sigma]", "Spatial"]], "TI", "InlineFormula"],
     " and",
     StyleBox[" ", "TI"],
     StyleBox[Cell[BoxData[
      SubscriptBox["\[Sigma]", "Angular"]], "TI", "InlineFormula"], "TI"],
     ". "
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"LeftInvariantDeriva", "[", 
       StyleBox[
        RowBox[{
        "ObjPositionOrientationData", ",", " ", "derivativeIndex", ",", " ", 
         "options"}], "TI"], "]"}]], "InlineFormula"],
     "\[LineSeparator]Computes the ",
     Cell[BoxData[
      SubscriptBox["A", 
       StyleBox["derivativeIndex", "TI"]]], "InlineFormula"],
     " derivative(s) from ",
     StyleBox["ObjPositionOrientationData", "TI"],
     " using a finite difference method which can be specified by using ",
     StyleBox["options", "TI"],
     "."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    TemplateBox[{6},
     "Spacer1"]]],
   "Details"
  }], "NotesFrameText"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1],

Cell["", "SectionHeaderSpacer"],

Cell["\<\
LeftInvariantDerivatives computes the Left Invariant derivatives from an \
orientation score.\
\>", "Notes",
 CellID->1067943069],

Cell[TextData[{
 "Internally the function makes use of the ",
 ButtonBox["GaussianFilter",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/GaussianFilter"],
 " to compute the Gaussian derivatives."
}], "Notes",
 CellID->412672041],

Cell[TextData[{
 "Left-invariant derivatives are defined as ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox[
    SubscriptBox["\[PartialD]", "\[Xi]"], "k"], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox[
    SubscriptBox["\[PartialD]", "\[Eta]"], "k"], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox[
    SubscriptBox["\[PartialD]", "\[Theta]"], "k"], TraditionalForm]]],
 ", with k the order. The spatial derivatives \[Xi] and \[Eta] align such \
that the \[Xi]-direction coincides with the orientation \[Theta]."
}], "Notes",
 CellID->103390044],

Cell["\<\
The symmetry of odd-spatial-derivatives is displayed as -\[Pi], which means \
that the full periodic orientation score is the stored orientation score plus \
its conjugate. \
\>", "Notes",
 CellID->621051649],

Cell["\<\
If the input orientation score is an complex orientation score, than both the \
real and imaginary part of the orientation scores are processed.\
\>", "Notes",
 CellID->63701413],

Cell["\<\
The output of the function is again (just as the input) an Orientation Score\
\>", "Notes",
 CellID->529188703],

Cell[TextData[{
 "The derivative in orientation direction should always be the first \
derivative to be computed. Therefor internally the ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["\[PartialD]", "\[Theta]"], 
    SubscriptBox["\[PartialD]", "\[Xi]"]}], TraditionalForm]]],
 " is rewritten by using the relation ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["\[PartialD]", "\[Theta]"], 
    SubscriptBox["\[PartialD]", "\[Xi]"]}], TraditionalForm]]],
 " = ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["\[PartialD]", "\[Xi]"], 
    RowBox[{
     SubscriptBox["\[PartialD]", "\[Theta]"], 
     RowBox[{"+", 
      SubscriptBox["\[PartialD]", "\[Eta]"]}]}]}], TraditionalForm]]],
 "."
}], "Notes",
 CellID->71722282],

Cell[TextData[{
 "Using ",
 ButtonBox["Normal",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Normal"],
 " on the output of ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["LeftInvariantDerivatives"]],
    "paclet:LieAnalysis/ref/LeftInvariantDerivatives"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 " results in an ",
 ButtonBox["Association",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Association"],
 "."
}], "Notes",
 CellID->536528458],

Cell["\<\
If no scales (\[Sigma]Spatial and \[Sigma]Orientation) are specified, a \
finite difference method is used.\
\>", "Notes",
 CellID->57458175],

Cell["\<\
Options that are supplied when using the Gaussian derivatives implementation \
are ignored as they are only valid in case of the Finite Difference method. \
\>", "Notes",
 CellID->53437451],

Cell["The following options can be specified:", "Notes",
 CellID->264493441],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon"], "\"\<Method\>\"", "\"\<Central\>\"", Cell[
    "specifies scheme used for finite differences", "TableText"]}
  }]], "3ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}},
 GridBoxDividers->{"Rows" -> {{True, True}}}},
 CellID->57070403]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]]],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(10)", "ExampleCount"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->1],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(3)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1],

Cell[TextData[{
 "Computing the First order derivative ",
 Cell[BoxData[
  RowBox[{
   SubscriptBox["A", "2"], "U"}]], "InlineFormula"],
 " using Gaussian derivatives"
}], "ExampleText",
 CellID->389088840],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<LieAnalysis`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->748025858],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ost", " ", "=", " ", 
   RowBox[{"OrientationScoreTransform", "[", 
    RowBox[{"LieAnalysisData", "[", 
     RowBox[{"{", 
      RowBox[{"\"\<image\>\"", ",", "\"\<retina-1\>\""}], "}"}], "]"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"ost", " ", "=", " ", 
  RowBox[{"LeftInvariantDerivatives", "[", 
   RowBox[{"ost", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1"}], "}"}], ",", "2"}], "]"}]}]}], "Input",
 CellLabel->"In[2]:=",
 CellID->17046924],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->542377208],

Cell["\<\
Computing multiple left invariant derivatives at once using Gaussian \
derivatives\
\>", "ExampleText",
 CellID->498587170],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ost", " ", "=", " ", 
   RowBox[{"OrientationScoreTransform", "[", 
    RowBox[{"LieAnalysisData", "[", 
     RowBox[{"{", 
      RowBox[{"\"\<image\>\"", ",", "\"\<retina-2\>\""}], "}"}], "]"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"LeftInvariantDerivatives", "[", 
  RowBox[{"ost", ",", " ", 
   RowBox[{"{", 
    RowBox[{"1", ",", " ", "1"}], "}"}], ",", " ", 
   RowBox[{"{", 
    RowBox[{"1", ",", "11", ",", "23"}], "}"}]}], "]"}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->797281017]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->77640400],

Cell[TextData[{
 "Computing the First order derivative ",
 Cell[BoxData[
  RowBox[{
   SubscriptBox["A", "2"], "U"}]], "InlineFormula"],
 " using a Finite Differences"
}], "ExampleText",
 CellID->285248947],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ost", " ", "=", " ", 
   RowBox[{"OrientationScoreTransform", "[", 
    RowBox[{"LieAnalysisData", "[", 
     RowBox[{"{", 
      RowBox[{"\"\<image\>\"", ",", "\"\<euler-spirals-noise\>\""}], "}"}], 
     "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"ost", " ", "=", " ", 
  RowBox[{"LeftInvariantDerivatives", "[", 
   RowBox[{"ost", ",", "2"}], "]"}]}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->106214031]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "Scope",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(2)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1293636265],

Cell["\<\
The gradient can be computed using the OrientationScoreTensor function which \
uses the LeftInvariantDerivatives internally\
\>", "ExampleText",
 CellID->235883792],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ost", " ", "=", " ", 
   RowBox[{"OrientationScoreTransform", "[", 
    RowBox[{"LieAnalysisData", "[", 
     RowBox[{"{", 
      RowBox[{"\"\<image\>\"", ",", "\"\<retina-1\>\""}], "}"}], "]"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"OrientationScoreTensor", "[", 
  RowBox[{"ost", ",", " ", 
   RowBox[{"{", 
    RowBox[{"1", ",", " ", "1"}], "}"}], ",", " ", "\"\<Gradient\>\""}], 
  "]"}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->598584582],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->745536012],

Cell["The Hessian can be computed in the same way.", "ExampleText",
 CellID->45499497],

Cell[BoxData[
 RowBox[{"OrientationScoreTensor", "[", 
  RowBox[{"ost", ",", " ", 
   RowBox[{"{", 
    RowBox[{"1", ",", " ", "1"}], "}"}], ",", " ", "\"\<Hessian\>\""}], 
  "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->29919926]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Generalizations & Extensions",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1020263627],

Cell["\<\
In case the orientation score is complex valued, the left invariant \
derivatives are computed separate on the real and imaginary part \
\>", "ExampleText",
 CellID->230602946],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ost", " ", "=", " ", 
   RowBox[{"OrientationScoreTransform", "[", 
    RowBox[{
     RowBox[{"LieAnalysisData", "[", 
      RowBox[{"{", 
       RowBox[{"\"\<image\>\"", ",", "\"\<retina-1\>\""}], "}"}], "]"}], ",", 
     
     RowBox[{"\"\<WaveletPreProcess\>\"", "\[Rule]", 
      RowBox[{"(", 
       RowBox[{"#", "&"}], ")"}]}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"LeftInvariantDerivatives", "[", 
  RowBox[{"ost", ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", "1"}], "]"}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->195384688]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Options",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->546689455],

Cell[CellGroupData[{

Cell[TextData[{
 "\"Method\"",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CellID->30156605],

Cell["\<\
In case of the Finite Differences method it is possible to specify the scheme\
\
\>", "ExampleText",
 CellID->169263068],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ost", " ", "=", " ", 
   RowBox[{"OrientationScoreTransform", "[", 
    RowBox[{"LieAnalysisData", "[", 
     RowBox[{"{", 
      RowBox[{"\"\<image\>\"", ",", "\"\<retina-1\>\""}], "}"}], "]"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"LeftInvariantDerivatives", "[", 
  RowBox[{"ost", ",", "1", ",", 
   RowBox[{"\"\<Method\>\"", "\[Rule]", "\"\<Forward\>\""}]}], 
  "]"}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->181161385]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Properties & Relations",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(3)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->2123667759],

Cell["\<\
The ObjPositionOrientationData contains elements which are stored in memory\
\>", "ExampleText",
 CellID->801339526],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ost", " ", "=", " ", 
   RowBox[{"OrientationScoreTransform", "[", 
    RowBox[{"LieAnalysisData", "[", 
     RowBox[{"{", 
      RowBox[{"\"\<image\>\"", ",", "\"\<retina-1\>\""}], "}"}], "]"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"ost", "[", "\"\<Elements\>\"", "]"}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->26945327],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->86570287],

Cell["\<\
The ObjPositionOrientationData contains elements which are computed from the \
elements when you request them\
\>", "ExampleText",
 CellID->55387656],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ost", " ", "=", " ", 
   RowBox[{"OrientationScoreTransform", "[", 
    RowBox[{"LieAnalysisData", "[", 
     RowBox[{"{", 
      RowBox[{"\"\<image\>\"", ",", "\"\<retina-1\>\""}], "}"}], "]"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"ost", "[", "\"\<Properties\>\"", "]"}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->60534572]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->5061993],

Cell["\<\
An important feature to limit storage and computation time is to use the \
symmetry in the orientation axes when possible. Therefor the element Data \
only contains half of the orientation score\
\>", "ExampleText",
 CellID->652888655],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ost", " ", "=", " ", 
   RowBox[{"OrientationScoreTransform", "[", 
    RowBox[{"LieAnalysisData", "[", 
     RowBox[{"{", 
      RowBox[{"\"\<image\>\"", ",", "\"\<retina-1\>\""}], "}"}], "]"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
  "ost", "\[LeftDoubleBracket]", "\"\<Data\>\"", "\[RightDoubleBracket]"}], "//",
   "Dimensions"}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->71194813],

Cell["\<\
To request the full periodic orientation score you can use the property \
FullData\
\>", "ExampleText",
 CellID->120704472],

Cell[BoxData[
 RowBox[{
  RowBox[{"ost", "[", "\"\<FullData\>\"", "]"}], "//", 
  "Dimensions"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->342244655]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "SectionFooterSpacer"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]]],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["InverseOrientationScoreTransform"]],
    "paclet:LieAnalysis/ref/InverseOrientationScoreTransform"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["CakeWaveletStack"]],"paclet:LieAnalysis/ref/CakeWaveletStack"},
   
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["GaborWaveletStack"]],
    "paclet:LieAnalysis/ref/GaborWaveletStack"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreTransform"]],
    "paclet:LieAnalysis/ref/OrientationScoreTransform"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreTransform3D"]],
    "paclet:LieAnalysis/ref/OrientationScoreTransform3D"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["LeftInvariantDerivatives3D"]],
    "paclet:LieAnalysis/ref/LeftInvariantDerivatives3D"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"LeftInvariantDerivatives",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Wolfram Language", ButtonData -> "paclet:guide/WolframRoot", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "ExampleCounter" -> 1, "NeedPlatMsgIn" -> None, "RootCaptions" -> 
  "", "Metadata" -> {
   "built" -> "{2017, 10, 26, 15, 6, 55.9361724}", 
    "history" -> {"0.2", "1.0\t", "", ""}, "context" -> "LieAnalysis`", 
    "keywords" -> {
     "Orientation Score Derivatives", "Orientation Scores", "Derivative", 
      "LieAnalysis", "Cake Wavelets"}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Lie Analysis Symbol", "language" -> "en", "paclet" -> "LieAnalysis", 
    "status" -> "None", "summary" -> 
    "LeftInvariantDerivatives[ObjPositionOrientationData, \\ \
{\\[Sigma]Spatial, \\[Sigma]Angular}, derivativeIndex] Computes the \
AderivativeIndex derivative(s) from ObjPositionOrientationData using Gaussian \
derivatives at specified scales \\[Sigma]Spatial and \\[Sigma]Angular. \
LeftInvariantDeriva[ObjPositionOrientationData, derivativeIndex, \\ options] \
Computes the AderivativeIndex derivative(s) from ObjPositionOrientationData \
using a finite difference method which can be specified by using options.", 
    "synonyms" -> {}, "tabletags" -> {}, "title" -> 
    "LeftInvariantDerivatives", "titlemodifier" -> "", "windowtitle" -> 
    "LeftInvariantDerivatives", "type" -> "Symbol", "uri" -> 
    "LieAnalysis/ref/OrientationScoreDerivatives"}},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[10617, 325, 260, 10, 70, "PrimaryExamplesSection",ExpressionUUID->"4fa26610-7572-49ff-a0e7-4e895d2f3f73",
   CellTags->"PrimaryExamplesSection",
   CellID->1]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 24406, 798}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[596, 21, 3785, 88, 70, "AnchorBarGrid",ExpressionUUID->"2432226e-a776-4b82-b581-b9fbbd7ea66b",
 CellID->1],
Cell[4384, 111, 181, 6, 70, "ObjectNameGrid",ExpressionUUID->"2693ad78-e49f-481d-8478-e7bd0969b1bf"],
Cell[4568, 119, 1753, 49, 70, "Usage",ExpressionUUID->"d8162827-6775-4a24-949e-0d7ea9b6143e",
 CellID->982511436],
Cell[CellGroupData[{
Cell[6346, 172, 621, 19, 70, "NotesSection",ExpressionUUID->"c2f4de64-c144-4394-ac96-4f5d599432dc",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1],
Cell[6970, 193, 31, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"85d4f02e-3a5f-4a9b-bbc2-a2d3e91e2afa"],
Cell[7004, 195, 139, 4, 70, "Notes",ExpressionUUID->"0882cc8b-81e7-428b-beec-c48d2212746f",
 CellID->1067943069],
Cell[7146, 201, 229, 7, 70, "Notes",ExpressionUUID->"78815446-e239-41ff-a509-c8a73ecfcc67",
 CellID->412672041],
Cell[7378, 210, 598, 19, 70, "Notes",ExpressionUUID->"ddf20aed-e90b-40b1-a340-658e84e23ae6",
 CellID->103390044],
Cell[7979, 231, 218, 5, 70, "Notes",ExpressionUUID->"647f629e-305b-4435-a11a-b8f6198b8652",
 CellID->621051649],
Cell[8200, 238, 188, 4, 70, "Notes",ExpressionUUID->"e9495f6c-4a27-49b5-8914-8d433951e2f4",
 CellID->63701413],
Cell[8391, 244, 121, 3, 70, "Notes",ExpressionUUID->"eb92fd31-7ae7-42dc-b705-170a55131c23",
 CellID->529188703],
Cell[8515, 249, 753, 25, 70, "Notes",ExpressionUUID->"3fc7b5e4-8dc3-42dc-9837-9eea33f88ec8",
 CellID->71722282],
Cell[9271, 276, 476, 18, 70, "Notes",ExpressionUUID->"f8d05232-820b-4a45-ad69-a8e14f6c638a",
 CellID->536528458],
Cell[9750, 296, 151, 4, 70, "Notes",ExpressionUUID->"6d4f52ae-ffc4-4e6f-af13-914eb4bb2340",
 CellID->57458175],
Cell[9904, 302, 199, 4, 70, "Notes",ExpressionUUID->"8e1b9ff4-b312-412a-baf0-0ea00d78a910",
 CellID->53437451],
Cell[10106, 308, 76, 1, 70, "Notes",ExpressionUUID->"683e06f5-48cb-49e4-b1c8-0b84ff7f6682",
 CellID->264493441],
Cell[10185, 311, 395, 9, 70, "3ColumnTableMod",ExpressionUUID->"7a46579f-087e-4c38-9548-bb97f6b7bcd3",
 CellID->57070403]
}, Closed]],
Cell[CellGroupData[{
Cell[10617, 325, 260, 10, 70, "PrimaryExamplesSection",ExpressionUUID->"4fa26610-7572-49ff-a0e7-4e895d2f3f73",
 CellTags->"PrimaryExamplesSection",
 CellID->1],
Cell[CellGroupData[{
Cell[10902, 339, 187, 6, 70, "ExampleSection",ExpressionUUID->"bf719a9e-2d0a-45e8-b1a8-f88e8911f53b",
 CellID->1],
Cell[11092, 347, 206, 7, 70, "ExampleText",ExpressionUUID->"961c08cc-b9f0-44a9-a441-10279accbe68",
 CellID->389088840],
Cell[11301, 356, 120, 3, 70, "Input",ExpressionUUID->"339f1512-8714-4f4c-9292-a36edc915f41",
 CellID->748025858],
Cell[11424, 361, 505, 14, 70, "Input",ExpressionUUID->"45843522-5c8c-4e1f-8307-d2720c2d9da9",
 CellID->17046924],
Cell[CellGroupData[{
Cell[11954, 379, 125, 3, 70, "ExampleDelimiter",ExpressionUUID->"37bb234c-dea8-4c16-8ed9-b191269ac68b",
 CellID->542377208],
Cell[12082, 384, 133, 4, 70, "ExampleText",ExpressionUUID->"fb9fed84-c64d-4559-9b28-e116a61dc6cb",
 CellID->498587170],
Cell[12218, 390, 544, 15, 70, "Input",ExpressionUUID->"10fe3bc8-689b-44c0-bb54-edb39f5a4d62",
 CellID->797281017]
}, Open  ]],
Cell[CellGroupData[{
Cell[12799, 410, 124, 3, 70, "ExampleDelimiter",ExpressionUUID->"af65e3d9-a826-4061-9a3e-cd9a1b1c7e8a",
 CellID->77640400],
Cell[12926, 415, 206, 7, 70, "ExampleText",ExpressionUUID->"2b94e308-45e2-436c-b524-cf7a318b4e69",
 CellID->285248947],
Cell[13135, 424, 457, 12, 70, "Input",ExpressionUUID->"7add67c9-8b88-4bdf-b67b-0586022d6d73",
 CellID->106214031]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[13641, 442, 187, 6, 70, "ExampleSection",ExpressionUUID->"13c53bdd-c048-49f2-8096-d4588fbd7d8f",
 CellID->1293636265],
Cell[13831, 450, 174, 4, 70, "ExampleText",ExpressionUUID->"f967bd76-5bed-4eb4-b4d3-b20f6db3b838",
 CellID->235883792],
Cell[14008, 456, 499, 14, 70, "Input",ExpressionUUID->"d407fe6b-1e62-4f73-90de-c6cbfa8a611a",
 CellID->598584582],
Cell[CellGroupData[{
Cell[14532, 474, 125, 3, 70, "ExampleDelimiter",ExpressionUUID->"e2a7f3e1-45d9-4e86-8811-672479933ba3",
 CellID->745536012],
Cell[14660, 479, 86, 1, 70, "ExampleText",ExpressionUUID->"cf743bc0-b560-4689-89ff-ad566eb3f430",
 CellID->45499497],
Cell[14749, 482, 233, 7, 70, "Input",ExpressionUUID->"8252322a-7322-40f5-b65d-02baa0994ef3",
 CellID->29919926]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[15031, 495, 210, 6, 70, "ExampleSection",ExpressionUUID->"be6285b2-2a14-4693-9e6b-1d429f9fbbe6",
 CellID->1020263627],
Cell[15244, 503, 186, 4, 70, "ExampleText",ExpressionUUID->"4489219f-eea8-4b65-bb11-f48fea2d9a3a",
 CellID->230602946],
Cell[15433, 509, 603, 17, 70, "Input",ExpressionUUID->"f1277f05-c2cd-4c8d-a854-10e5e97816b4",
 CellID->195384688]
}, Closed]],
Cell[CellGroupData[{
Cell[16073, 531, 188, 6, 70, "ExampleSection",ExpressionUUID->"0437ebc1-4a22-418e-803d-324a0b6670d5",
 CellID->546689455],
Cell[CellGroupData[{
Cell[16286, 541, 196, 6, 70, "ExampleSubsection",ExpressionUUID->"85f48bc9-8085-44de-9c09-12cd4455d503",
 CellID->30156605],
Cell[16485, 549, 130, 4, 70, "ExampleText",ExpressionUUID->"4f782879-c0c7-492c-ae29-25b2559d2da7",
 CellID->169263068],
Cell[16618, 555, 479, 13, 70, "Input",ExpressionUUID->"28964549-0417-4067-9969-ec96d1dfd19c",
 CellID->181161385]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[17146, 574, 204, 6, 70, "ExampleSection",ExpressionUUID->"e005477e-e24e-4983-bf07-cfebebb2e556",
 CellID->2123667759],
Cell[17353, 582, 126, 3, 70, "ExampleText",ExpressionUUID->"ade61b42-7678-4ef0-92c9-e28450d19215",
 CellID->801339526],
Cell[17482, 587, 377, 10, 70, "Input",ExpressionUUID->"38cdbe7d-d955-4af1-8bde-fc0316149f3c",
 CellID->26945327],
Cell[CellGroupData[{
Cell[17884, 601, 124, 3, 70, "ExampleDelimiter",ExpressionUUID->"d1d8b1ea-37b4-499b-8e8c-e2a2648d81eb",
 CellID->86570287],
Cell[18011, 606, 159, 4, 70, "ExampleText",ExpressionUUID->"4b0d4af5-339d-440d-b68d-530e6fc690b3",
 CellID->55387656],
Cell[18173, 612, 379, 10, 70, "Input",ExpressionUUID->"49b62992-14ad-423e-9c92-42ce50dc28eb",
 CellID->60534572]
}, Open  ]],
Cell[CellGroupData[{
Cell[18589, 627, 123, 3, 70, "ExampleDelimiter",ExpressionUUID->"564ffe72-0e1f-4439-9842-988cc292dbd7",
 CellID->5061993],
Cell[18715, 632, 245, 5, 70, "ExampleText",ExpressionUUID->"3a6e1330-63c1-49a7-aae6-193fe54be95a",
 CellID->652888655],
Cell[18963, 639, 451, 13, 70, "Input",ExpressionUUID->"8a0c3855-fe43-4ad7-bd33-21cd06710dc6",
 CellID->71194813],
Cell[19417, 654, 133, 4, 70, "ExampleText",ExpressionUUID->"9602bcce-7311-4310-90a5-e776180cccb8",
 CellID->120704472],
Cell[19553, 660, 150, 5, 70, "Input",ExpressionUUID->"e25aea96-e3d4-411c-8e5b-33a3acea48a3",
 CellID->342244655]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[19764, 672, 31, 0, 70, "SectionFooterSpacer",ExpressionUUID->"77f5e129-efc5-482d-8d92-6d9790caa14b"],
Cell[19798, 674, 150, 7, 70, "SeeAlsoSection",ExpressionUUID->"bbef6d83-3fac-4bb0-ac44-62f280465e53",
 CellID->1255426704],
Cell[19951, 683, 2009, 58, 70, "SeeAlso",ExpressionUUID->"d2cde7cb-9dac-445d-9897-fca0547dac38",
 CellID->929782353]
}, Open  ]],
Cell[21975, 744, 23, 0, 70, "FooterCell",ExpressionUUID->"7b8684f9-bec4-49d7-8246-0b2484d467e7"]
}
]
*)

(* End of internal cache information *)
