(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     30719,        924]
NotebookOptionsPosition[     21317,        729]
NotebookOutlinePosition[     24032,        795]
CellTagsIndexPosition[     23947,        790]
WindowTitle->LeftInvariantDerivatives3D
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["LIE ANALYSIS SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"OrientationScoreTransform3D\"\>":>
       Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/OrientationScoreTransform3D"], \
"\<\"OrientationScoreDerivatives\"\>":>Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/OrientationScoreDerivatives"], \
"\<\"CakeWaveletStack3D\"\>":>Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/CakeWaveletStack3D"], \
"\<\"OrientationScoreTensor3D\"\>":>Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/OrientationScoreTensor3D"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Related Guides",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"Related Guides", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"LieAnalysis Package\"\>":>
       Documentation`HelpLookup["paclet:LieAnalysis/guide/LieAnalysis"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAbout"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->
         False], {"\<\"LieAnalysis/ref/LeftInvariantDerivatives3D\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["LieAnalysis/ref/LeftInvariantDerivatives3D"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/LieAnalysis/ref/\
LeftInvariantDerivatives3D.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$13103], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "LieAnalysis/ref/LeftInvariantDerivatives3D", ".html"]], 
           None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[TextData[{
 Cell["LeftInvariantDerivatives3D", "ObjectName"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]]],
 Cell[BoxData[""], "ObjectNameTranslation"]
}], "ObjectNameGrid"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"LeftInvariantDerivatives3D", "[", 
       RowBox[{
        StyleBox["ObjPositionOrientationData", "TI"], ",", " ", 
        RowBox[{"{", 
         RowBox[{
          StyleBox["\[Sigma]Spatial", "TI"], ",", " ", 
          StyleBox["\[Sigma]Orientation", "TI"]}], "}"}], ",", " ", 
        StyleBox["derivativeIndex", "TI"]}], "]"}]], "InlineFormula"],
     " \[LineSeparator]Computes the ",
     Cell[BoxData[
      StyleBox[
       SubscriptBox["A", "derivativeIndex"], "TI"]], "InlineFormula"],
     " derivative(s) from ",
     StyleBox["ObjPositionOrientationData", "TI"],
     " using Gaussian derivatives with the specified ",
     StyleBox["\[Sigma]Spatial ", "TI",
      FontSize->10],
     StyleBox["and ",
      FontSize->10],
     StyleBox["\[Sigma]", "TI",
      FontSize->10],
     StyleBox["Orientation", "TI"],
     "."
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"LeftInvariantDerivatives3D", "[", 
       StyleBox[
        RowBox[{
        "ObjOrientationScores3D", ",", " ", "derivativeIndex", ",", " ", 
         "options"}], "TI"], "]"}]], "InlineFormula"],
     "\[LineSeparator]Computes ",
     Cell[BoxData[
      SubscriptBox["A", "derivativeIndex"]]],
     " derivative(s) using a finite differences method which can be specified \
using ",
     StyleBox["options", "TI"],
     "."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    TemplateBox[{6},
     "Spacer1"]]],
   "Details"
  }], "NotesFrameText"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1],

Cell["", "SectionHeaderSpacer"],

Cell["\<\
Computes the left-invariant derivatives from an orientation score using \
either Gaussian derivatives or Finite Differences depending.\
\>", "Notes",
 CellID->1067943069],

Cell["\<\
If the input orientation score is an complex orientation score, than both the \
real and imaginary part of the orientation scores are processed.\
\>", "Notes",
 CellID->503558703],

Cell["\<\
The output of the function is again (just as the input) an Orientation Score\
\>", "Notes",
 CellID->76349160],

Cell["\<\
The input argument derivativeIndex can either be a integer or list of \
integers.\
\>", "Notes",
 CellID->1094427881],

Cell["\<\
The finite difference implementation is also available in the common context.\
\
\>", "Notes",
 CellID->786384164],

Cell[TextData[{
 "Using ",
 ButtonBox["Normal",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Normal"],
 " on the output of ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["LeftInvariantDerivatives3D"]],
    "paclet:LieAnalysis/ref/LeftInvariantDerivatives3D"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 " results in an ",
 ButtonBox["Association",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Association"],
 "."
}], "Notes",
 CellID->29528630],

Cell["\<\
Options that are supplied when using the Gaussian derivatives implementation \
are ignored as they are only valid in case of the Finite Difference method. \
\>", "Notes",
 CellID->557929915],

Cell["", "SectionFooterSpacer"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]]],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(10)", "ExampleCount"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->1],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(3)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1],

Cell[TextData[{
 "Computing the first order derivative ",
 Cell[BoxData[
  RowBox[{
   SubscriptBox["A", "3"], "U"}]], "InlineFormula"],
 " using Gaussian derivatives"
}], "ExampleText",
 CellID->553922391],

Cell[BoxData[{
 RowBox[{"Needs", "[", "\"\<LieAnalysis`\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ost", " ", "=", " ", 
   RowBox[{"OrientationScoreTransform3D", "[", 
    RowBox[{"LieAnalysisData", "[", 
     RowBox[{"{", 
      RowBox[{"\"\<image3d\>\"", ",", "\"\<random-lines-1\>\""}], "}"}], 
     "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"LeftInvariantDerivatives3D", "[", 
  RowBox[{"ost", ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", "3"}], "]"}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->623415468],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->684594186],

Cell["\<\
Computing multiple left invariant derivatives at once using Gaussian \
derivatives.\
\>", "ExampleText",
 CellID->177728253],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ost", " ", "=", " ", 
   RowBox[{"OrientationScoreTransform3D", "[", 
    RowBox[{"LieAnalysisData", "[", 
     RowBox[{"{", 
      RowBox[{"\"\<image3d\>\"", ",", "\"\<random-lines-2\>\""}], "}"}], 
     "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"ost", " ", "=", " ", 
  RowBox[{"LeftInvariantDerivatives3D", "[", 
   RowBox[{"ost", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}]}], "]"}]}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->955066387]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->437263998],

Cell[TextData[{
 "Computing the first order derivative ",
 Cell[BoxData[
  RowBox[{
   SubscriptBox["A", "3"], "U"}]], "InlineFormula"],
 " using Finite Differences"
}], "ExampleText",
 CellID->139428064],

Cell[BoxData[{
 RowBox[{"Needs", "[", "\"\<LieAnalysis`\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ost", " ", "=", " ", 
   RowBox[{"OrientationScoreTransform3D", "[", 
    RowBox[{"LieAnalysisData", "[", 
     RowBox[{"{", 
      RowBox[{"\"\<image3d\>\"", ",", "\"\<random-lines-1\>\""}], "}"}], 
     "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"LeftInvariantDerivatives3D", "[", 
  RowBox[{"ost", ",", "3"}], "]"}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->2446656]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "Scope",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(2)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1293636265],

Cell[TextData[{
 "Computing the Gradient and Hessian can be done with the ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreTensor3D"]],
    "paclet:LieAnalysis/ref/OrientationScoreTensor3D"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 ", which in this case internally uses the ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["LeftInvariantDerivatives3D"]],
    "paclet:LieAnalysis/ref/LeftInvariantDerivatives3D"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 " function"
}], "ExampleText",
 CellID->50560312],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ost", " ", "=", " ", 
   RowBox[{"OrientationScoreTransform3D", "[", 
    RowBox[{"CenterArray", "[", 
     RowBox[{"1", ",", 
      RowBox[{"{", 
       RowBox[{"11", ",", "11", ",", "11"}], "}"}]}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"gradient", " ", "=", " ", 
  RowBox[{"OrientationScoreTensor3D", "[", 
   RowBox[{"ost", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1"}], "}"}], ",", "\"\<gradient\>\""}], 
   "]"}]}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->342000315],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->1042260989],

Cell[TextData[{
 "In order to show the progress of multiple derivatives you can use the \
options from ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["LieAnalysis"]],"paclet:LieAnalysis/ref/LieAnalysis"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"]
}], "ExampleText",
 CellID->256333544],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"LieAnalysis", ",", 
    RowBox[{"\"\<DynamicUpdates\>\"", "\[Rule]", "True"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"OrientationScoreTensor3D", "[", 
  RowBox[{
   RowBox[{"OrientationScoreTransform3D", "[", 
    RowBox[{"CenterArray", "[", 
     RowBox[{"1", ",", 
      RowBox[{"{", 
       RowBox[{"21", ",", "21", ",", "21"}], "}"}]}], "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", "\"\<Hessian\>\""}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"LieAnalysis", ",", 
    RowBox[{"\"\<DynamicUpdates\>\"", "\[Rule]", "False"}]}], "]"}], 
  ";"}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->1600181544]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Generalizations & Extensions",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1020263627],

Cell["\<\
In case the orientation score is complex valued, the left invariant \
derivatives are computed separate on the real and imaginary part \
\>", "ExampleText",
 CellID->109832332],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"LieAnalysis", ",", " ", 
    RowBox[{"\"\<DynamicUpdates\>\"", "\[Rule]", "True"}]}], "]"}], 
  ";"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->575947319],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ost", " ", "=", " ", 
   RowBox[{"OrientationScoreTransform3D", "[", 
    RowBox[{
     RowBox[{"CenterArray", "[", 
      RowBox[{"1", ",", 
       RowBox[{"{", 
        RowBox[{"12", ",", "12", ",", "12"}], "}"}]}], "]"}], ",", 
     RowBox[{"\"\<WaveletPreProcess\>\"", "\[Rule]", 
      RowBox[{"(", 
       RowBox[{"#", "&"}], ")"}]}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"LeftInvariantDerivatives3D", "[", 
  RowBox[{"ost", ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", "1"}], "]"}]}], "Input",
 CellLabel->"In[2]:=",
 CellID->305865652]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Properties & Relations",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(4)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->2123667759],

Cell["\<\
The Obj3DPositionOrientationData contains elements which are stored in memory\
\
\>", "ExampleText",
 CellID->12392954],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ost", " ", "=", " ", 
   RowBox[{"OrientationScoreTransform3D", "[", 
    RowBox[{"LieAnalysisData", "[", 
     RowBox[{"{", 
      RowBox[{"\"\<image3d\>\"", ",", "\"\<random-lines-1\>\""}], "}"}], 
     "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Framed", "/@", 
  RowBox[{"ost", "[", "\"\<Elements\>\"", "]"}]}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->935504856],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->205405167],

Cell["\<\
The ObjPositionOrientationData contains elements which are computed from the \
elements when you request them\
\>", "ExampleText",
 CellID->138993893],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ost", " ", "=", " ", 
   RowBox[{"OrientationScoreTransform3D", "[", 
    RowBox[{"LieAnalysisData", "[", 
     RowBox[{"{", 
      RowBox[{"\"\<image3d\>\"", ",", "\"\<random-lines-2\>\""}], "}"}], 
     "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Framed", "/@", 
  RowBox[{"ost", "[", "\"\<Properties\>\"", "]"}]}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->1402408903]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->431714866],

Cell["\<\
An important feature to limit storage and computation time is to use the \
symmetry in the orientation axes when possible. Therefor the element Data \
only contains half of the orientation score\
\>", "ExampleText",
 CellID->630203],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ost", " ", "=", " ", 
   RowBox[{"OrientationScoreTransform3D", "[", 
    RowBox[{
     RowBox[{"LieAnalysisData", "[", 
      RowBox[{"{", 
       RowBox[{"\"\<image3d\>\"", ",", "\"\<random-lines-1\>\""}], "}"}], 
      "]"}], ",", 
     RowBox[{"\"\<Orientations\>\"", "\[Rule]", "14"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
  "ost", "\[LeftDoubleBracket]", "\"\<Data\>\"", "\[RightDoubleBracket]"}], "//",
   "Dimensions"}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->58693976],

Cell["\<\
To request the full periodic orientation score you can use the property \
FullData\
\>", "ExampleText",
 CellID->418394016],

Cell[BoxData[
 RowBox[{
  RowBox[{"ost", "[", "\"\<FullData\>\"", "]"}], "//", 
  "Dimensions"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->23181795]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->1972182281],

Cell[TextData[{
 "The type of output from ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["LeftInvariantDerivatives3D"]],
    "paclet:LieAnalysis/ref/LeftInvariantDerivatives3D"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 " (Obj3DPositionOrientationData) is the same of from the ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreTransform3D"]],
    "paclet:LieAnalysis/ref/OrientationScoreTransform3D"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 "."
}], "ExampleText",
 CellID->57505322],

Cell[BoxData[
 RowBox[{
  RowBox[{"OrientationScoreTransform3D", "[", 
   RowBox[{"LieAnalysisData", "[", 
    RowBox[{"{", 
     RowBox[{"\"\<image3d\>\"", ",", "\"\<random-lines-1\>\""}], "}"}], "]"}],
    "]"}], "//", "Head"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->467281335]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "SectionFooterSpacer"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]]],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreTransform3D"]],
    "paclet:LieAnalysis/ref/OrientationScoreTransform3D"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreDerivatives"]],
    "paclet:LieAnalysis/ref/OrientationScoreDerivatives"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["CakeWaveletStack3D"]],
    "paclet:LieAnalysis/ref/CakeWaveletStack3D"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreTensor3D"]],
    "paclet:LieAnalysis/ref/OrientationScoreTensor3D"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]]],
 "Related Guides"
}], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell["", "SectionHeaderSpacer"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["LieAnalysis Package"]],"paclet:LieAnalysis/guide/LieAnalysis"},
  "RefLink",
  BaseStyle->"MoreAbout"]], "MoreAbout",
 CellID->1]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"LeftInvariantDerivatives3D",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "LieAnalysis Package", ButtonData -> 
         "paclet:LieAnalysis/guide/LieAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2017, 10, 26, 15, 6, 54.4891708}", 
    "history" -> {"0.2", "1.0", "", ""}, "context" -> "LieAnalysis`", 
    "keywords" -> {
     "Orientation Score Derivatives", "Derivative", "LieAnalysis", 
      "Cake Wavelets", "Left Invariant Derivatives"}, "specialkeywords" -> {},
     "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Lie Analysis Symbol", "language" -> "en", "paclet" -> "LieAnalysis", 
    "status" -> "None", "summary" -> 
    "LeftInvariantDerivatives3D[ObjPositionOrientationData, \\ \
{\\[Sigma]Spatial, \\[Sigma]Orientation}, derivativeIndex] Computes the \
AderivativeIndex derivative(s) from ObjPositionOrientationData using Gaussian \
derivatives with the specified \\[Sigma]Spatial and \\[Sigma]Orientation. \
LeftInvariantDerivatives3D[ObjOrientationScores3D, derivativeIndex, \\ \
options] Computes AderivativeIndex derivative(s) using a finite differences \
method which can be specified using options.", "synonyms" -> {}, 
    "tabletags" -> {}, "title" -> "LeftInvariantDerivatives3D", 
    "titlemodifier" -> "", "windowtitle" -> "LeftInvariantDerivatives3D", 
    "type" -> "Symbol", "uri" -> 
    "LieAnalysis/ref/LeftInvariantDerivatives3D"}},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[8654, 264, 260, 10, 70, "PrimaryExamplesSection",ExpressionUUID->"5e684bc5-6850-4639-8b7a-c98e26780964",
   CellTags->"PrimaryExamplesSection",
   CellID->1]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 23757, 783}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[598, 21, 4078, 99, 70, "AnchorBarGrid",ExpressionUUID->"ca8ed59f-b356-476d-9910-5690b7c65db8",
 CellID->1],
Cell[4679, 122, 183, 6, 70, "ObjectNameGrid",ExpressionUUID->"9580ea31-df14-488d-bc06-1c8db4e4760f"],
Cell[4865, 130, 1598, 47, 70, "Usage",ExpressionUUID->"faa22cc9-f22f-45d9-a2cf-69aebc3c2914",
 CellID->982511436],
Cell[CellGroupData[{
Cell[6488, 181, 621, 19, 70, "NotesSection",ExpressionUUID->"27a3a976-0b33-4e72-b41a-eaa96db32909",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1],
Cell[7112, 202, 31, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"f5b70f50-f379-4c0d-b9bd-d3225fc64dcc"],
Cell[7146, 204, 180, 4, 70, "Notes",ExpressionUUID->"4bc4169f-7b97-4b79-9aca-ad3bd74ec12f",
 CellID->1067943069],
Cell[7329, 210, 189, 4, 70, "Notes",ExpressionUUID->"74f7f160-ef2a-4b9a-a4c0-c139b1d7fa6f",
 CellID->503558703],
Cell[7521, 216, 120, 3, 70, "Notes",ExpressionUUID->"3e770d54-1440-45fa-b9de-6bc760c91568",
 CellID->76349160],
Cell[7644, 221, 127, 4, 70, "Notes",ExpressionUUID->"631aea83-859c-4677-beea-4e330d8fc831",
 CellID->1094427881],
Cell[7774, 227, 124, 4, 70, "Notes",ExpressionUUID->"7223c5f6-215f-4ea2-a6ed-e80c8187ea76",
 CellID->786384164],
Cell[7901, 233, 479, 18, 70, "Notes",ExpressionUUID->"d05a259b-471e-4dca-9b9a-d68845d8150b",
 CellID->29528630],
Cell[8383, 253, 200, 4, 70, "Notes",ExpressionUUID->"cc2cc742-18b0-4fc6-9c16-f9b4c0633338",
 CellID->557929915],
Cell[8586, 259, 31, 0, 70, "SectionFooterSpacer",ExpressionUUID->"aff0c031-1981-4066-8261-be7938dd5d75"]
}, Closed]],
Cell[CellGroupData[{
Cell[8654, 264, 260, 10, 70, "PrimaryExamplesSection",ExpressionUUID->"5e684bc5-6850-4639-8b7a-c98e26780964",
 CellTags->"PrimaryExamplesSection",
 CellID->1],
Cell[CellGroupData[{
Cell[8939, 278, 187, 6, 70, "ExampleSection",ExpressionUUID->"fffd8f45-1898-4242-993a-1b35f3af8795",
 CellID->1],
Cell[9129, 286, 206, 7, 70, "ExampleText",ExpressionUUID->"be0d262a-7cfb-4176-92b4-eaaa8e5e84cb",
 CellID->553922391],
Cell[9338, 295, 559, 14, 70, "Input",ExpressionUUID->"da8517d7-5a7d-4a57-909e-c7f91f5abd00",
 CellID->623415468],
Cell[CellGroupData[{
Cell[9922, 313, 125, 3, 70, "ExampleDelimiter",ExpressionUUID->"bbd4a1e0-543a-434c-a062-eeb6cf50fd20",
 CellID->684594186],
Cell[10050, 318, 134, 4, 70, "ExampleText",ExpressionUUID->"6062874c-09cd-42e5-84fd-eadfc4a8fe58",
 CellID->177728253],
Cell[10187, 324, 570, 16, 70, "Input",ExpressionUUID->"55233b4b-d1a5-4c5a-9423-9d734c1e743f",
 CellID->955066387]
}, Open  ]],
Cell[CellGroupData[{
Cell[10794, 345, 125, 3, 70, "ExampleDelimiter",ExpressionUUID->"fbc6de79-ecec-4c9a-9296-6d8f27d36961",
 CellID->437263998],
Cell[10922, 350, 204, 7, 70, "ExampleText",ExpressionUUID->"e992294c-5752-4604-894a-fa7c4db96a1d",
 CellID->139428064],
Cell[11129, 359, 498, 12, 70, "Input",ExpressionUUID->"21438894-2da9-4d02-bc4a-a23595c47a1f",
 CellID->2446656]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[11676, 377, 187, 6, 70, "ExampleSection",ExpressionUUID->"2e89c1e2-a4c7-4c23-9835-cddfe5b1f2c3",
 CellID->1293636265],
Cell[11866, 385, 583, 17, 70, "ExampleText",ExpressionUUID->"446eb51d-fbaa-4741-b2b1-cc4dfd7e5d0d",
 CellID->50560312],
Cell[12452, 404, 540, 16, 70, "Input",ExpressionUUID->"bbb62de6-572e-46e0-811e-0e3f7c128191",
 CellID->342000315],
Cell[CellGroupData[{
Cell[13017, 424, 126, 3, 70, "ExampleDelimiter",ExpressionUUID->"19af7241-662c-49b2-b9af-928a811a39f1",
 CellID->1042260989],
Cell[13146, 429, 315, 9, 70, "ExampleText",ExpressionUUID->"2185ead4-e604-4331-a20b-d28b71f8eabd",
 CellID->256333544],
Cell[13464, 440, 760, 22, 70, "Input",ExpressionUUID->"79a1705c-5bcd-4ecc-b0fb-d1637a85cc5a",
 CellID->1600181544]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[14273, 468, 210, 6, 70, "ExampleSection",ExpressionUUID->"8b96ae48-13cc-4ee5-b336-7c029b5f2e4c",
 CellID->1020263627],
Cell[14486, 476, 186, 4, 70, "ExampleText",ExpressionUUID->"d5f6f0d6-ce8c-45b9-bc3e-54c83b7a9dc6",
 CellID->109832332],
Cell[14675, 482, 221, 7, 70, "Input",ExpressionUUID->"fdc38bed-a04d-4b44-8a3d-be59abef0b61",
 CellID->575947319],
Cell[14899, 491, 612, 17, 70, "Input",ExpressionUUID->"d61ff162-8af7-40b3-b2a1-1fd4a19ee0af",
 CellID->305865652]
}, Closed]],
Cell[CellGroupData[{
Cell[15548, 513, 204, 6, 70, "ExampleSection",ExpressionUUID->"58d78f87-080e-419c-8afb-80df9f09a685",
 CellID->2123667759],
Cell[15755, 521, 129, 4, 70, "ExampleText",ExpressionUUID->"af25f60b-5453-4810-87fa-2293d3c51ab7",
 CellID->12392954],
Cell[15887, 527, 418, 11, 70, "Input",ExpressionUUID->"3b4b06b2-4a21-4e9c-a015-1805cb7e4ca7",
 CellID->935504856],
Cell[CellGroupData[{
Cell[16330, 542, 125, 3, 70, "ExampleDelimiter",ExpressionUUID->"a7b3c2e3-75f3-4374-a6d6-198aeb12151c",
 CellID->205405167],
Cell[16458, 547, 160, 4, 70, "ExampleText",ExpressionUUID->"00d258ba-8bb5-444f-9e64-d2fd9e0597a9",
 CellID->138993893],
Cell[16621, 553, 421, 11, 70, "Input",ExpressionUUID->"0df9a83b-77b0-478b-8124-2351cfa77294",
 CellID->1402408903]
}, Open  ]],
Cell[CellGroupData[{
Cell[17079, 569, 125, 3, 70, "ExampleDelimiter",ExpressionUUID->"90a76ed9-c6b2-4d4d-9041-e9a47c88b01a",
 CellID->431714866],
Cell[17207, 574, 242, 5, 70, "ExampleText",ExpressionUUID->"b1fedc08-77b6-43d9-88bf-5c528e526cc3",
 CellID->630203],
Cell[17452, 581, 546, 16, 70, "Input",ExpressionUUID->"fe86db05-491a-45eb-90bb-5a203cdfe729",
 CellID->58693976],
Cell[18001, 599, 133, 4, 70, "ExampleText",ExpressionUUID->"23f7071a-d0bb-4c0a-8fc4-b0a9af36def3",
 CellID->418394016],
Cell[18137, 605, 149, 5, 70, "Input",ExpressionUUID->"b0976825-b375-4890-b0a2-041fd34d67f9",
 CellID->23181795]
}, Open  ]],
Cell[CellGroupData[{
Cell[18323, 615, 126, 3, 70, "ExampleDelimiter",ExpressionUUID->"affe3642-f8c4-4679-af88-5f96d8b41a36",
 CellID->1972182281],
Cell[18452, 620, 564, 17, 70, "ExampleText",ExpressionUUID->"5dcf825d-dae8-4733-9a53-70bec383c6b4",
 CellID->57505322],
Cell[19019, 639, 283, 8, 70, "Input",ExpressionUUID->"3c1d361a-90b8-42a0-a22c-10243ff275a3",
 CellID->467281335]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[19363, 654, 31, 0, 70, "SectionFooterSpacer",ExpressionUUID->"38cdc986-0e49-4c10-9535-150e99d5be15"],
Cell[19397, 656, 150, 7, 70, "SeeAlsoSection",ExpressionUUID->"1d4344ad-08d7-4f7a-92e3-66d79832d761",
 CellID->1255426704],
Cell[19550, 665, 1318, 38, 70, "SeeAlso",ExpressionUUID->"90b9322f-4d11-4a14-b772-b5601ccd342b",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[20905, 708, 156, 7, 70, "MoreAboutSection",ExpressionUUID->"b80cbe17-594d-4650-a0dd-e081f0abb0bb",
 CellID->38303248],
Cell[21064, 717, 31, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"141c4f27-ca56-40dd-ba62-71505b176302"],
Cell[21098, 719, 177, 5, 70, "MoreAbout",ExpressionUUID->"33e96a59-dcb9-4fb2-a7b0-0fc31288f070",
 CellID->1]
}, Open  ]],
Cell[21290, 727, 23, 0, 70, "FooterCell",ExpressionUUID->"3a95619d-28be-40f0-a5a0-69eea60bfdc4"]
}
]
*)

(* End of internal cache information *)
