(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     18554,        557]
NotebookOptionsPosition[     12127,        417]
NotebookOutlinePosition[     14496,        478]
CellTagsIndexPosition[     14411,        473]
WindowTitle->LieAnalysisData
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["LIE ANALYSIS SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"OrientationScoreTransform\"\>":>
       Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/OrientationScoreTransform"], \
"\<\"OrientationScoreTransform3D\"\>":>Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/OrientationScoreTransform3D"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"LieAnalysis/ref/LieAnalysisData\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["LieAnalysis/ref/LieAnalysisData"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/LieAnalysis/ref/\
LieAnalysisData.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$14373], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "LieAnalysis/ref/LieAnalysisData", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[TextData[{
 Cell["LieAnalysisData", "ObjectName"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]]],
 Cell[BoxData[""], "ObjectNameTranslation"]
}], "ObjectNameGrid"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"LieAnalysisData", "[", "]"}]], "InlineFormula"],
     " \[LineSeparator]gives a list of libraries containing example data"
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"LieAnalysisData", "[", 
       StyleBox["library", "TI"], "]"}]], "InlineFormula"],
     "\[LineSeparator]gives a list of names of datasets for the specified ",
     StyleBox["library", "TI"]
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"LieAnalysisData", "[", 
       RowBox[{"{", 
        RowBox[{
         StyleBox["library", "TI"], ",", 
         StyleBox["name", "TI"]}], "}"}], "]"}]], "InlineFormula"],
     "\[LineSeparator]gives the example data ",
     StyleBox["name", "TI"],
     " from the specified ",
     StyleBox["library", "TI"]
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, {None}}, "RowsIndexed" -> {}}},
 CellID->982511436],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    TemplateBox[{6},
     "Spacer1"]]],
   "Details"
  }], "NotesFrameText"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1],

Cell["", "SectionHeaderSpacer"],

Cell["The available libraries are:", "Notes",
 CellID->1067943069],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon"], Cell["\"image\"", "TableText"], Cell[
    "sample 2d images", "TableText"]},
   {Cell["      ", "TableRowIcon"], Cell["\"image3d\"", "TableText"], Cell[
    "sample 3d images", "TableText"]}
  }]], "2ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}},
 GridBoxDividers->{"Rows" -> {{True, True, True}}}},
 CellID->114236204],

Cell[TextData[{
 "The function ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["LieAnalysisData"]],"paclet:LieAnalysis/ref/LieAnalysisData"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 " mimics the functionality of the ",
 ButtonBox["ExampleData",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/ExampleData"],
 " function from Mathematica."
}], "Notes",
 CellID->207160460],

Cell[TextData[{
 "The available keys are obtained from ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["http://www.lieanalysis.nl/exampledata/example-data-keys.txt"]],
    "http://www.lieanalysis.nl/exampledata/example-data-keys.txt"},
   "WebLink",
   BaseStyle->{"Notes"}]]],
 ", if no internet connection is available it will try to find it in your \
local folder system."
}], "Notes",
 CellID->7123424],

Cell[TextData[{
 "If no internet connection is available and the dataset is not available and \
the ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["LieAnalysisData"]],"paclet:LieAnalysis/ref/LieAnalysisData"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 " returns",
 StyleBox[" $failed",
  FontWeight->"Bold"],
 "."
}], "Notes",
 CellID->404488202]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]]],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(6)", "ExampleCount"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->1],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(3)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1],

Cell["A standard image for computing Orientation Scores:", "ExampleText",
 CellID->34071436],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Needs", "[", "\"\<LieAnalysis`\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"LieAnalysisData", "[", 
  RowBox[{"{", 
   RowBox[{"\"\<image\>\"", ",", "\"\<retina-1\>\""}], "}"}], "]"}]}], "Input",\

 CellLabel->"In[1]:=",
 CellID->138285791],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->170667222],

Cell["A 3d image for computing Orientation Scores in 3D:", "ExampleText",
 CellID->258132221],

Cell[BoxData[
 RowBox[{"LieAnalysisData", "[", 
  RowBox[{"{", 
   RowBox[{"\"\<image3d\>\"", ",", "\"\<random-lines-1\>\""}], "}"}], 
  "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->53254491]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->930196680],

Cell["Get the available datasets in the image3d library:", "ExampleText",
 CellID->234853218],

Cell[BoxData[
 RowBox[{"LieAnalysisData", "[", "\"\<image3d\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->640611381]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "Scope",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1293636265],

Cell["\<\
The LieAnalysisData function is useful when trying or demonstrating functions\
\
\>", "ExampleText",
 CellID->1328974900],

Cell[BoxData[
 RowBox[{"OrientationScoreTransform", "[", 
  RowBox[{"LieAnalysisData", "[", 
   RowBox[{"{", 
    RowBox[{"\"\<image\>\"", ",", "\"\<eindhoven-map\>\""}], "}"}], "]"}], 
  "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->21297914]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Properties & Relations",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->2123667759],

Cell["\<\
To show a download progress bar you can set the \"UseDynamicUpdates\" option \
from the LieAnalysis symbol to True.\
\>", "ExampleText",
 CellID->229511988],

Cell[BoxData[
 RowBox[{"SetOptions", "[", 
  RowBox[{"LieAnalysis", ",", 
   RowBox[{"\"\<DynamicUpdates\>\"", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1900908432]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Neat Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->589267740],

Cell["To show all available images in a library", "ExampleText",
 CellID->1124002588],

Cell[BoxData[
 RowBox[{"Grid", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Show", "[", 
       RowBox[{
        RowBox[{"LieAnalysisData", "[", 
         RowBox[{"{", 
          RowBox[{"\"\<image\>\"", ",", "#"}], "}"}], "]"}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "100"}]}], "]"}], ",", "#"}], "}"}], 
    "&"}], "/@", 
   RowBox[{"LieAnalysisData", "[", "\"\<image\>\"", "]"}]}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1531954046]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "SectionFooterSpacer"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]]],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreTransform"]],
    "paclet:LieAnalysis/ref/OrientationScoreTransform"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreTransform3D"]],
    "paclet:LieAnalysis/ref/OrientationScoreTransform3D"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"LieAnalysisData",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "LieAnalysis Package", ButtonData -> 
         "paclet:LieAnalysis/guide/LieAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2017, 10, 26, 15, 6, 57.4282244}", 
    "history" -> {"0.4", "", "", ""}, "context" -> "LieAnalysis`", 
    "keywords" -> {
     "Lie Analysis", "Example Data", "Images", "Library", "Data"}, 
    "specialkeywords" -> {}, "tutorialcollectionlinks" -> {}, "index" -> True,
     "label" -> "Lie Analysis Symbol", "language" -> "en", "paclet" -> 
    "LieAnalysis", "status" -> "None", "summary" -> 
    "LieAnalysisData[] gives a list of libraries containing example data \
LieAnalysisData[library] gives a list of names of datasets for the specified \
library LieAnalysisData[{library, name}] gives the example data name from the \
specified library", "synonyms" -> {}, "tabletags" -> {}, "title" -> 
    "LieAnalysisData", "titlemodifier" -> "", "windowtitle" -> 
    "LieAnalysisData", "type" -> "Symbol", "uri" -> 
    "LieAnalysis/ref/LieAnalysisData"}},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[7498, 227, 259, 10, 70, "PrimaryExamplesSection",ExpressionUUID->"6379aca3-4e47-4b56-b06e-c94bf5d1b832",
   CellTags->"PrimaryExamplesSection",
   CellID->1]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 14221, 466}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[587, 21, 3219, 77, 70, "AnchorBarGrid",ExpressionUUID->"20fb7bb0-49ad-461d-a0bf-41563d62054a",
 CellID->1],
Cell[3809, 100, 172, 6, 70, "ObjectNameGrid",ExpressionUUID->"f65c703f-0465-430e-bc16-f24885a98e4f"],
Cell[3984, 108, 1034, 30, 70, "Usage",ExpressionUUID->"be455dc5-26c8-4cb0-a987-5d7161090374",
 CellID->982511436],
Cell[CellGroupData[{
Cell[5043, 142, 621, 19, 70, "NotesSection",ExpressionUUID->"0af1147e-8f42-4f21-8a0d-04dae92f9435",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1],
Cell[5667, 163, 31, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"fbf11e79-1c67-48c8-a8f7-853e48747a9f"],
Cell[5701, 165, 66, 1, 70, "Notes",ExpressionUUID->"35c38416-d528-467b-b92b-2ff2e7172f6d",
 CellID->1067943069],
Cell[5770, 168, 490, 11, 70, "2ColumnTableMod",ExpressionUUID->"1d6953fd-197a-42d4-ad0f-a0b1c3e627fc",
 CellID->114236204],
Cell[6263, 181, 403, 13, 70, "Notes",ExpressionUUID->"bf6c3622-8101-450a-870e-0c3c6f87cada",
 CellID->207160460],
Cell[6669, 196, 411, 11, 70, "Notes",ExpressionUUID->"f5dc57a8-9a1a-486a-8f02-911a29690906",
 CellID->7123424],
Cell[7083, 209, 378, 13, 70, "Notes",ExpressionUUID->"b75a0c4b-3a15-46be-afe1-303d2a085933",
 CellID->404488202]
}, Closed]],
Cell[CellGroupData[{
Cell[7498, 227, 259, 10, 70, "PrimaryExamplesSection",ExpressionUUID->"6379aca3-4e47-4b56-b06e-c94bf5d1b832",
 CellTags->"PrimaryExamplesSection",
 CellID->1],
Cell[CellGroupData[{
Cell[7782, 241, 187, 6, 70, "ExampleSection",ExpressionUUID->"0a0540e8-034e-4283-97dc-58b0deadb096",
 CellID->1],
Cell[7972, 249, 92, 1, 70, "ExampleText",ExpressionUUID->"cfdeb77a-8591-4b57-8be7-5f0c257766bd",
 CellID->34071436],
Cell[8067, 252, 288, 9, 70, "Input",ExpressionUUID->"86bf5470-e6e3-4e6a-898a-6e3e4af71701",
 CellID->138285791],
Cell[CellGroupData[{
Cell[8380, 265, 125, 3, 70, "ExampleDelimiter",ExpressionUUID->"da25a9ba-a9ae-4567-be0f-2d420a296063",
 CellID->170667222],
Cell[8508, 270, 93, 1, 70, "ExampleText",ExpressionUUID->"079e2687-14e3-4965-90a7-6e468301f1e2",
 CellID->258132221],
Cell[8604, 273, 195, 6, 70, "Input",ExpressionUUID->"6578cc73-72e8-4988-bfbb-d49f31841596",
 CellID->53254491]
}, Open  ]],
Cell[CellGroupData[{
Cell[8836, 284, 125, 3, 70, "ExampleDelimiter",ExpressionUUID->"be3345e9-4246-426a-8845-51c1abfcffa1",
 CellID->930196680],
Cell[8964, 289, 93, 1, 70, "ExampleText",ExpressionUUID->"13c33e61-add6-447e-91c2-80ecaca90f15",
 CellID->234853218],
Cell[9060, 292, 125, 3, 70, "Input",ExpressionUUID->"71168c45-af04-4935-9ab2-bcec819fbd95",
 CellID->640611381]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[9234, 301, 187, 6, 70, "ExampleSection",ExpressionUUID->"aabe026b-22c4-45c9-93c1-5e0cd7b0c5fc",
 CellID->1293636265],
Cell[9424, 309, 131, 4, 70, "ExampleText",ExpressionUUID->"feb36fbd-b080-4fd4-b6e8-7e0925d0c58a",
 CellID->1328974900],
Cell[9558, 315, 246, 7, 70, "Input",ExpressionUUID->"a671f2f4-a76d-467d-9cd8-ce2781165a6e",
 CellID->21297914]
}, Closed]],
Cell[CellGroupData[{
Cell[9841, 327, 204, 6, 70, "ExampleSection",ExpressionUUID->"771df591-b517-4921-af2c-dc99532f30d9",
 CellID->2123667759],
Cell[10048, 335, 166, 4, 70, "ExampleText",ExpressionUUID->"0bbbe08a-2ce7-45de-a1f7-b9179166e161",
 CellID->229511988],
Cell[10217, 341, 194, 5, 70, "Input",ExpressionUUID->"4aae5e61-9629-469c-8858-f8341e840dde",
 CellID->1900908432]
}, Closed]],
Cell[CellGroupData[{
Cell[10448, 351, 194, 6, 70, "ExampleSection",ExpressionUUID->"787b4bf6-88c3-4e19-831d-b67f38696c72",
 CellID->589267740],
Cell[10645, 359, 85, 1, 70, "ExampleText",ExpressionUUID->"d40b5559-18b4-41e8-8e74-6549fac8e757",
 CellID->1124002588],
Cell[10733, 362, 484, 15, 70, "Input",ExpressionUUID->"23c3fda2-cd1f-421e-9fe7-4664e8cd5b02",
 CellID->1531954046]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[11266, 383, 31, 0, 70, "SectionFooterSpacer",ExpressionUUID->"213d666c-08e0-479d-bdcc-b27453bcfcfb"],
Cell[11300, 385, 150, 7, 70, "SeeAlsoSection",ExpressionUUID->"54a66500-aa3b-4d3d-b5c3-be930e0d2fdb",
 CellID->1255426704],
Cell[11453, 394, 632, 18, 70, "SeeAlso",ExpressionUUID->"1a65c263-efd0-4530-9b1a-4ee9a922f72e",
 CellID->929782353]
}, Open  ]],
Cell[12100, 415, 23, 0, 70, "FooterCell",ExpressionUUID->"d43964d0-2e7b-4e34-bcac-24f81b23972c"]
}
]
*)

(* End of internal cache information *)
