(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     21184,        611]
NotebookOptionsPosition[     14966,        481]
NotebookOutlinePosition[     17595,        546]
CellTagsIndexPosition[     17510,        541]
WindowTitle->OrientationScoreGaugeFrames
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["LIE ANALYSIS SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Tutorials",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"Tutorials", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"Basic Usage of the package\"\>":>
       Documentation`HelpLookup["paclet:LieAnalysis/tutorial/Basic Usage"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"Tutorials"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"OrientationScoreTensor\"\>":>
       Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/OrientationScoreTensor"], \
"\<\"OrientationScoreTransform\"\>":>Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/OrientationScoreTransform"], \
"\<\"CakeWaveletStack\"\>":>Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/CakeWaveletStack"], "\<\"LieAnalysisData\"\>":>
       Documentation`HelpLookup["paclet:LieAnalysis/ref/LieAnalysisData"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Related Guides",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"Related Guides", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"LieAnalysis Package\"\>":>
       Documentation`HelpLookup["paclet:LieAnalysis/guide/LieAnalysis"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAbout"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->
         False], {"\<\"LieAnalysis/ref/OrientationScoreGaugeFrames\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["LieAnalysis/ref/OrientationScoreGaugeFrames"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/LieAnalysis/ref/\
OrientationScoreGaugeFrames.html"], StandardForm]], "Input", 
              TextClipboardType -> "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$16132], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "LieAnalysis/ref/OrientationScoreGaugeFrames", ".html"]], 
           None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[TextData[{
 Cell["OrientationScoreGaugeFrames", "ObjectName"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]]],
 Cell[BoxData[""], "ObjectNameTranslation"]
}], "ObjectNameGrid"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"OrientationScoreGaugeFrames", "[", 
       RowBox[{
        StyleBox["objTensor", "TI"], ",", " ", 
        StyleBox["options", "TI"]}], "]"}]], "InlineFormula"],
     " \[LineSeparator]returns data-adaptive frame from a ",
     StyleBox["objTensor", "TI"],
     " that is formatted as a hessian"
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"OrientationScoreGaugeFrames", "[", 
       RowBox[{
        StyleBox["ObjPositionOrientationData", "TI"], ",", " ", 
        RowBox[{"{", 
         RowBox[{
          StyleBox[
           SubscriptBox["\[Sigma]", "spatial"], "TI"], ",", " ", 
          StyleBox[
           SubscriptBox["\[Sigma]", "angular"], "TI"]}], "}"}], ",", " ", 
        StyleBox["options", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]Computes the gauge-frame from ",
     StyleBox["ObjPositionOrientationData", "TI"],
     " by first computing the hessian using the ",
     Cell[BoxData[
      StyleBox[
       SubscriptBox["\[Sigma]", "spatial"], "TI"]], "InlineFormula"],
     " and ",
     Cell[BoxData[
      StyleBox[
       SubscriptBox["\[Sigma]", "angular"], "TI"]], "InlineFormula"]
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    TemplateBox[{6},
     "Spacer1"]]],
   "Details"
  }], "NotesFrameText"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1],

Cell["", "SectionHeaderSpacer"],

Cell[TextData[{
 "In case an ",
 StyleBox["ObjPositionOrientationData", "TI"],
 " is supplied than internally the function ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreTensor"]],
    "paclet:LieAnalysis/ref/OrientationScoreTensor"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 " is used to compute the hessian"
}], "Notes",
 CellID->1067943069],

Cell[TextData[{
 "The Gauge frame is an extension of the Left Invariant Frame (which is used \
by ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["LeftInvariantDerivatives"]],
    "paclet:LieAnalysis/ref/LeftInvariantDerivatives"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 "), which is adapted to the data from the Orientation Scores. Therefore the \
Gauge frame is better aligned with the data in the score"
}], "Notes",
 CellID->238522639],

Cell["\<\
The function returns a volume containing a frame at each position (which \
aligns to the score-data). This frame consist of three orthogonal vectors \
which can be used in further processing of the score\
\>", "Notes",
 CellID->120148829],

Cell["\<\
Unlike most functions from the LieAnalysis package this function returns a \
numeric output instead of the commonly used objects\
\>", "Notes",
 CellID->235795275],

Cell["", "SectionFooterSpacer"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]]],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(2)", "ExampleCount"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->1],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(2)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1],

Cell[TextData[{
 "The Gauge frame from a Orientation Score can be computed from an ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreTransform"]],
    "paclet:LieAnalysis/ref/OrientationScoreTransform"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"]
}], "ExampleText",
 CellID->337656677],

Cell[BoxData[{
 RowBox[{"Needs", "[", "\"\<LieAnalysis`\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"os", " ", "=", " ", 
   RowBox[{"OrientationScoreTransform", "[", 
    RowBox[{"LieAnalysisData", "[", 
     RowBox[{"{", 
      RowBox[{"\"\<image\>\"", ",", "\"\<circles\>\""}], "}"}], "]"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"frame", " ", "=", " ", 
   RowBox[{"OrientationScoreGaugeFrames", "[", 
    RowBox[{"os", ",", 
     RowBox[{"{", 
      RowBox[{".1", ",", ".001"}], "}"}]}], "]"}]}], ";"}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->5776980],

Cell["\<\
A vector plot can show the vector that points in the direction of the data. \
The vectors are multiplied by the orientation score to only show the \
important vectors\
\>", "ExampleText",
 CellID->104633281],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{"ListVectorPlot3D", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Re", "@", 
          RowBox[{"os", "[", "\"\<Data\>\"", "]"}]}], ",", 
         RowBox[{"Re", "@", 
          RowBox[{"os", "[", "\"\<Data\>\"", "]"}]}], ",", 
         RowBox[{"Re", "@", 
          RowBox[{"os", "[", "\"\<Data\>\"", "]"}]}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"4", ",", "1", ",", "2", ",", "3"}], "}"}]}], "]"}], "*", 
     RowBox[{"frame", "\[LeftDoubleBracket]", 
      RowBox[{"All", ",", "All", ",", "All", ",", "1"}], 
      "\[RightDoubleBracket]"}]}], ",", 
    RowBox[{"VectorStyle", "\[Rule]", 
     RowBox[{"Arrowheads", "[", "0", "]"}]}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "Medium"}], ",", " ", 
    RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->97889958],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->269989888],

Cell["\<\
An indirect way of computing the Gauge frame is by first computing the Hessian\
\>", "ExampleText",
 CellID->243149959],

Cell[BoxData[{
 RowBox[{
  RowBox[{"os", " ", "=", " ", 
   RowBox[{"OrientationScoreTransform", "[", 
    RowBox[{"LieAnalysisData", "[", 
     RowBox[{"{", 
      RowBox[{"\"\<image\>\"", ",", "\"\<circles\>\""}], "}"}], "]"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"hessian", " ", "=", " ", 
  RowBox[{"OrientationScoreTensor", "[", 
   RowBox[{"os", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", ".15"}], "}"}], ",", "\"\<Hessian\>\""}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"frame", " ", "=", " ", 
   RowBox[{"OrientationScoreGaugeFrames", "[", "hessian", "]"}]}], 
  ";"}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->78167434]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "SectionFooterSpacer"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]]],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreTensor"]],
    "paclet:LieAnalysis/ref/OrientationScoreTensor"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreTransform"]],
    "paclet:LieAnalysis/ref/OrientationScoreTransform"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["CakeWaveletStack"]],"paclet:LieAnalysis/ref/CakeWaveletStack"},
   
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["LieAnalysisData"]],"paclet:LieAnalysis/ref/LieAnalysisData"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]]],
 "Tutorials"
}], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell["", "SectionHeaderSpacer"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["Basic Usage of the package"]],
   "paclet:LieAnalysis/tutorial/Basic Usage"},
  "RefLink",
  BaseStyle->"Tutorials"]], "Tutorials",
 CellID->341631938],

Cell["", "SectionFooterSpacer"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]]],
 "Related Guides"
}], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell["", "SectionHeaderSpacer"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["LieAnalysis Package"]],"paclet:LieAnalysis/guide/LieAnalysis"},
  "RefLink",
  BaseStyle->"MoreAbout"]], "MoreAbout",
 CellID->1]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"OrientationScoreGaugeFrames",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "LieAnalysis Package", ButtonData -> 
         "paclet:LieAnalysis/guide/LieAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2017, 10, 26, 15, 7, 1.5451282}", 
    "history" -> {"0.3", "1.0", "", ""}, "context" -> "LieAnalysis`", 
    "keywords" -> {
     "Data adaptive frame", "Gauge frame", "Cake wavelets", 
      "Orientation Scores", "Orientation Score transform", 
      "Image processing"}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Lie Analysis Symbol", "language" -> "en", "paclet" -> "LieAnalysis", 
    "status" -> "None", "summary" -> 
    "OrientationScoreGaugeFrames[objTensor, options] returns data-adaptive \
frame from a objTensor that is formatted as a hessian \
OrientationScoreGaugeFrames[ObjPositionOrientationData, \\ {\\[Sigma]spatial, \
\\[Sigma]angular}, options] Computes the gauge-frame from \
ObjPositionOrientationData by first computing the hessian using the \
\\[Sigma]spatial and \\[Sigma]angular", "synonyms" -> {}, "tabletags" -> {}, 
    "title" -> "OrientationScoreGaugeFrames", "titlemodifier" -> "", 
    "windowtitle" -> "OrientationScoreGaugeFrames", "type" -> "Symbol", "uri" -> 
    "LieAnalysis/ref/OrientationScoreGaugeFrames"}},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[9001, 260, 259, 10, 70, "PrimaryExamplesSection",ExpressionUUID->"c811a056-b92f-4192-96ed-6826019ff906",
   CellTags->"PrimaryExamplesSection",
   CellID->1]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 17320, 534}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[599, 21, 4748, 117, 70, "AnchorBarGrid",ExpressionUUID->"acb25bc4-8a14-43cc-88dd-df1bcccb3a62",
 CellID->1],
Cell[5350, 140, 184, 6, 70, "ObjectNameGrid",ExpressionUUID->"0d2a3319-8d0b-40fb-aa4d-b580da19316b"],
Cell[5537, 148, 1414, 39, 70, "Usage",ExpressionUUID->"3c679182-2b88-462a-8e66-0c0a5e61390f",
 CellID->982511436],
Cell[CellGroupData[{
Cell[6976, 191, 621, 19, 70, "NotesSection",ExpressionUUID->"b839a176-4a0f-4ad8-8e71-d5d512308c43",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1],
Cell[7600, 212, 31, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"9e768b9f-d67a-4e3d-9acd-53bb904008a0"],
Cell[7634, 214, 393, 12, 70, "Notes",ExpressionUUID->"c2163982-7296-4e52-be5a-f4df71b9cc49",
 CellID->1067943069],
Cell[8030, 228, 473, 12, 70, "Notes",ExpressionUUID->"471ee2d4-5a8e-4bcb-b946-2af748e05043",
 CellID->238522639],
Cell[8506, 242, 248, 5, 70, "Notes",ExpressionUUID->"85cf68a2-87bd-4b17-bbd5-e7447ecf6eca",
 CellID->120148829],
Cell[8757, 249, 173, 4, 70, "Notes",ExpressionUUID->"0df73799-27b9-4f74-a0ce-daa22ce63eb8",
 CellID->235795275],
Cell[8933, 255, 31, 0, 70, "SectionFooterSpacer",ExpressionUUID->"d454f3d8-983d-4bc7-b8f8-93b0e2ba8625"]
}, Closed]],
Cell[CellGroupData[{
Cell[9001, 260, 259, 10, 70, "PrimaryExamplesSection",ExpressionUUID->"c811a056-b92f-4192-96ed-6826019ff906",
 CellTags->"PrimaryExamplesSection",
 CellID->1],
Cell[CellGroupData[{
Cell[9285, 274, 187, 6, 70, "ExampleSection",ExpressionUUID->"c0f778b5-93dc-4b17-8a0c-d5021e573ac2",
 CellID->1],
Cell[9475, 282, 328, 9, 70, "ExampleText",ExpressionUUID->"981e8c8d-9c99-4e41-9bd9-66b92ef81d22",
 CellID->337656677],
Cell[9806, 293, 600, 16, 70, "Input",ExpressionUUID->"c7e36ecc-a933-4d7d-8f6b-e70020d39077",
 CellID->5776980],
Cell[10409, 311, 217, 5, 70, "ExampleText",ExpressionUUID->"da7d57a2-0114-4510-90b6-0fb939037394",
 CellID->104633281],
Cell[10629, 318, 950, 25, 70, "Input",ExpressionUUID->"7f0f1518-6744-41ba-8a08-cca8664e3a5d",
 CellID->97889958],
Cell[CellGroupData[{
Cell[11604, 347, 125, 3, 70, "ExampleDelimiter",ExpressionUUID->"d7ebe0ac-b1bf-4127-9481-2f5e460f2411",
 CellID->269989888],
Cell[11732, 352, 129, 3, 70, "ExampleText",ExpressionUUID->"4b846ac5-aa16-4827-aef0-73d3d30be144",
 CellID->243149959],
Cell[11864, 357, 670, 19, 70, "Input",ExpressionUUID->"d5299b5f-348e-4850-b64a-41ed1c5b6ecf",
 CellID->78167434]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[12595, 383, 31, 0, 70, "SectionFooterSpacer",ExpressionUUID->"c15cc688-a4da-4d6d-9bd8-c47f4de3ebd9"],
Cell[12629, 385, 150, 7, 70, "SeeAlsoSection",ExpressionUUID->"1dbb5123-a426-45a1-acf8-e7ccdce3bc45",
 CellID->1255426704],
Cell[12782, 394, 1276, 37, 70, "SeeAlso",ExpressionUUID->"9d046834-621d-44fe-9118-6438a2c961ca",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[14095, 436, 152, 7, 70, "TutorialsSection",ExpressionUUID->"dec338b8-8eba-4a80-9f83-d27d93978a50",
 CellID->250839057],
Cell[14250, 445, 31, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"7d2cb327-bcc4-443d-9edb-76ebf1635c5c"],
Cell[14284, 447, 199, 6, 70, "Tutorials",ExpressionUUID->"2177f3e9-a368-4323-abd1-6bcc3e5a7609",
 CellID->341631938],
Cell[14486, 455, 31, 0, 70, "SectionFooterSpacer",ExpressionUUID->"a74b97df-d3a5-4924-bce0-61a378d0495d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[14554, 460, 156, 7, 70, "MoreAboutSection",ExpressionUUID->"7b939e8c-0272-45a4-9a26-1018e022290e",
 CellID->38303248],
Cell[14713, 469, 31, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"9134b573-639a-4921-93cb-b19fb30d3fbc"],
Cell[14747, 471, 177, 5, 70, "MoreAbout",ExpressionUUID->"3314b0a5-e694-4643-a360-88fb43b674c3",
 CellID->1]
}, Open  ]],
Cell[14939, 479, 23, 0, 70, "FooterCell",ExpressionUUID->"37a8349a-8048-41bd-b26e-c8c9e49132a5"]
}
]
*)

(* End of internal cache information *)
