(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     15882,        458]
NotebookOptionsPosition[     11183,        355]
NotebookOutlinePosition[     13639,        417]
CellTagsIndexPosition[     13554,        412]
WindowTitle->OrientationScoreGaugeFrames3D
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["LIE ANALYSIS SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"OrientationScoreTransform3D\"\>":>
       Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/OrientationScoreTransform3D"], \
"\<\"OrientationScoreGaugeFrames\"\>":>Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/OrientationScoreGaugeFrames"], \
"\<\"OrientationScoreTensor\"\>":>Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/OrientationScoreTensor"], \
"\<\"LeftInvariantDerivatives3D\"\>":>Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/LeftInvariantDerivatives3D"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Related Guides",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"Related Guides", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"LieAnalysis Package\"\>":>
       Documentation`HelpLookup["paclet:LieAnalysis/guide/LieAnalysis"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAbout"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->
         False], {"\<\"LieAnalysis/ref/OrientationScoreGaugeFrames3D\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["LieAnalysis/ref/OrientationScoreGaugeFrames3D"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/LieAnalysis/ref/\
OrientationScoreGaugeFrames3D.html"], StandardForm]], "Input", 
              TextClipboardType -> "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$15580], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "LieAnalysis/ref/OrientationScoreGaugeFrames3D", ".html"]], 
           None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[TextData[{
 Cell["OrientationScoreGaugeFrames3D", "ObjectName"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]]],
 Cell[BoxData[""], "ObjectNameTranslation"]
}], "ObjectNameGrid"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"OrientationScoreGaugeFrames3D", "[", 
       RowBox[{
        StyleBox["Obj3DPositionOrientationData", "TI"], ",", " ", 
        RowBox[{"{", 
         RowBox[{
          StyleBox[
           SubscriptBox["\[Sigma]", "Spatial"], "TI"], ",", " ", 
          StyleBox[
           SubscriptBox["\[Sigma]", "Angular"], "TI"]}], "}"}]}], "]"}]], 
      "InlineFormula"],
     " \[LineSeparator]Computes the gauge frame from ",
     StyleBox["Obj3DPositionOrientationData", "TI"],
     " using the ",
     Cell[BoxData[
      StyleBox[
       SubscriptBox["\[Sigma]", "Spatial"], "TI"]], "InlineFormula"],
     " and ",
     Cell[BoxData[
      SubscriptBox["\[Sigma]", "Angular"]], "InlineFormula"],
     "."
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"OrientationScoreGaugeFrames3D", "[", 
       RowBox[{
        StyleBox["Obj3DPositionOrientationData", "TI"], ",", " ", 
        RowBox[{"{", 
         RowBox[{
          StyleBox[
           SubscriptBox["\[Sigma]", "Spatial"], "TI"], ",", " ", 
          StyleBox[
           SubscriptBox["\[Sigma]", "Angular"], "TI"]}], "}"}], ",", " ", 
        StyleBox["OptionsPattern", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]XXXX"
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    TemplateBox[{6},
     "Spacer1"]]],
   "Details"
  }], "NotesFrameText"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1],

Cell["", "SectionHeaderSpacer"],

Cell["\<\
Internally, by default, the OrientationScoreGaugeFrame3D computes the Hessian.\
\>", "Notes",
 CellID->1067943069],

Cell["\<\
It is possible to input a ObjTensor (Hessian or structure tensor) like in the \
2D case because. However note that inputting an orientation score uses a \
speed optimized algorithm.\
\>", "Notes",
 CellID->900156077],

Cell["", "SectionFooterSpacer"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]]],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->1],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1],

Cell["Compute the GaugeFrame from an Orientation Score", "ExampleText",
 CellID->492256477],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Needs", "[", "\"\<LieAnalysis`\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"LieAnalysis", ",", 
    RowBox[{"\"\<DynamicUpdates\>\"", "\[Rule]", "True"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ost", " ", "=", " ", 
   RowBox[{"OrientationScoreTransform3D", "[", 
    RowBox[{"ImageTake", "[", 
     RowBox[{
      RowBox[{"LieAnalysisData", "[", 
       RowBox[{"{", 
        RowBox[{"\"\<image3d\>\"", ",", "\"\<random-lines-1\>\""}], "}"}], 
       "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "25"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"12", ",", "35"}], "}"}]}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gaugeFrame", " ", "=", " ", 
   RowBox[{"OrientationScoreGaugeFrames3D", "[", 
    RowBox[{"ost", ",", 
     RowBox[{"{", 
      RowBox[{"1.", ",", "Automatic", ",", "1", ",", ".2"}], "}"}], ",", 
     RowBox[{"\"\<TensorType\>\"", "\[Rule]", "\"\<Hessian\>\""}]}], "]"}]}], 
  ";"}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->360081224]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "SectionFooterSpacer"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]]],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreTransform3D"]],
    "paclet:LieAnalysis/ref/OrientationScoreTransform3D"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreGaugeFrames"]],
    "paclet:LieAnalysis/ref/OrientationScoreGaugeFrames"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreTensor"]],
    "paclet:LieAnalysis/ref/OrientationScoreTensor"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["LeftInvariantDerivatives3D"]],
    "paclet:LieAnalysis/ref/LeftInvariantDerivatives3D"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]]],
 "Related Guides"
}], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell["", "SectionHeaderSpacer"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["LieAnalysis Package"]],"paclet:LieAnalysis/guide/LieAnalysis"},
  "RefLink",
  BaseStyle->"MoreAbout"]], "MoreAbout",
 CellID->1]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"OrientationScoreGaugeFrames3D",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "LieAnalysis Package", ButtonData -> 
         "paclet:LieAnalysis/guide/LieAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2017, 10, 26, 15, 7, 0.2121875}", 
    "history" -> {"0.4", "", "", ""}, "context" -> "LieAnalysis`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Lie Analysis Symbol", "language" -> "en", "paclet" -> "LieAnalysis", 
    "status" -> "None", "summary" -> 
    "OrientationScoreGaugeFrames3D[Obj3DPositionOrientationData, \\ \
{\\[Sigma]Spatial, \\[Sigma]Angular}] Computes the gauge frame from \
Obj3DPositionOrientationData using the \\[Sigma]Spatial and \\[Sigma]Angular. \
OrientationScoreGaugeFrames3D[Obj3DPositionOrientationData, \\ \
{\\[Sigma]Spatial, \\[Sigma]Angular}, OptionsPattern] XXXX", "synonyms" -> {},
     "tabletags" -> {}, "title" -> "OrientationScoreGaugeFrames3D", 
    "titlemodifier" -> "", "windowtitle" -> "OrientationScoreGaugeFrames3D", 
    "type" -> "Symbol", "uri" -> 
    "LieAnalysis/ref/OrientationScoreGaugeFrames3D"}},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[7482, 217, 259, 10, 70, "PrimaryExamplesSection",ExpressionUUID->"d8258ebb-62ef-4904-aa9e-1969716622fe",
   CellTags->"PrimaryExamplesSection",
   CellID->1]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 13364, 405}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[601, 21, 4102, 99, 70, "AnchorBarGrid",ExpressionUUID->"7ecc75c0-bc0e-45d5-beb6-57a77cf126bf",
 CellID->1],
Cell[4706, 122, 186, 6, 70, "ObjectNameGrid",ExpressionUUID->"54b25784-80fc-4fd0-9d61-d05106799ed5"],
Cell[4895, 130, 1480, 43, 70, "Usage",ExpressionUUID->"9659bd07-427a-491c-b99b-76803435294a",
 CellID->982511436],
Cell[CellGroupData[{
Cell[6400, 177, 621, 19, 70, "NotesSection",ExpressionUUID->"84220af1-d336-4d0d-a07e-a529dc8d6227",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1],
Cell[7024, 198, 31, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"3e9e8e9d-6d72-4448-b4a7-2b0bdf1c4d44"],
Cell[7058, 200, 124, 3, 70, "Notes",ExpressionUUID->"575dbadf-102f-4539-ada7-7434310e19e9",
 CellID->1067943069],
Cell[7185, 205, 226, 5, 70, "Notes",ExpressionUUID->"54297985-ca88-4be4-b4b8-6bf649137810",
 CellID->900156077],
Cell[7414, 212, 31, 0, 70, "SectionFooterSpacer",ExpressionUUID->"c6b4ef01-3722-4b7c-8d9f-2bc5b17a702d"]
}, Closed]],
Cell[CellGroupData[{
Cell[7482, 217, 259, 10, 70, "PrimaryExamplesSection",ExpressionUUID->"d8258ebb-62ef-4904-aa9e-1969716622fe",
 CellTags->"PrimaryExamplesSection",
 CellID->1],
Cell[CellGroupData[{
Cell[7766, 231, 187, 6, 70, "ExampleSection",ExpressionUUID->"bd493212-16ea-40e3-b503-9af7e709ff79",
 CellID->1],
Cell[7956, 239, 91, 1, 70, "ExampleText",ExpressionUUID->"838820a6-92d8-42d1-b13a-1b6de7cc5709",
 CellID->492256477],
Cell[8050, 242, 1118, 32, 70, "Input",ExpressionUUID->"0cd773d0-619c-4443-86a5-5928f9fb5641",
 CellID->360081224]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[9217, 280, 31, 0, 70, "SectionFooterSpacer",ExpressionUUID->"a07d24a9-2539-485f-90d4-cf0a80e15484"],
Cell[9251, 282, 150, 7, 70, "SeeAlsoSection",ExpressionUUID->"9b6ed55d-2424-4fb0-b811-d776340e9aa1",
 CellID->1255426704],
Cell[9404, 291, 1330, 38, 70, "SeeAlso",ExpressionUUID->"de68cdcf-c8bd-476d-90be-0dfac9259643",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[10771, 334, 156, 7, 70, "MoreAboutSection",ExpressionUUID->"e4925fe5-be11-49d0-8d56-7f457baf1e7b",
 CellID->38303248],
Cell[10930, 343, 31, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"a6b8858e-3579-45c3-a0d6-719042a70561"],
Cell[10964, 345, 177, 5, 70, "MoreAbout",ExpressionUUID->"85e47d9c-df37-49bb-aa7b-a5a63ccebe0c",
 CellID->1]
}, Open  ]],
Cell[11156, 353, 23, 0, 70, "FooterCell",ExpressionUUID->"f99c4968-d83d-4f04-8457-04a01b6280c5"]
}
]
*)

(* End of internal cache information *)
