(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     21347,        643]
NotebookOptionsPosition[     14814,        505]
NotebookOutlinePosition[     17369,        568]
CellTagsIndexPosition[     17284,        563]
WindowTitle->OrientationScoreTensor
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["LIE ANALYSIS SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"OrientationScoreTensor3D\"\>":>
       Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/OrientationScoreTensor3D"], \
"\<\"OrientationScoreTransform\"\>":>Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/OrientationScoreTransform"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Related Guides",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"Related Guides", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"LieAnalysis Package\"\>":>
       Documentation`HelpLookup["paclet:LieAnalysis/guide/LieAnalysis"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAbout"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->
         False], {"\<\"LieAnalysis/ref/OrientationScoreTensor\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["LieAnalysis/ref/OrientationScoreTensor"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/LieAnalysis/ref/\
OrientationScoreTensor.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$17285], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "LieAnalysis/ref/OrientationScoreTensor", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[TextData[{
 Cell["OrientationScoreTensor", "ObjectName"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]]],
 Cell[BoxData[""], "ObjectNameTranslation"]
}], "ObjectNameGrid"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     "    ",
     Cell[BoxData[
      RowBox[{"OrientationScoreTensor", "[", 
       RowBox[{
        StyleBox["ObjOrientationScores2D", "TI"], ",", " ", 
        RowBox[{"{", 
         RowBox[{
          StyleBox["\[Sigma]Spatial", "TI"], ",", " ", 
          StyleBox["\[Sigma]Angular", "TI"]}], "}"}], ",", " ", 
        StyleBox["derivativeIndex", "TI"], ",", " ", 
        StyleBox["options", "TI"]}], "]"}]], "InlineFormula"],
     " \[LineSeparator]Computes the derivative tensor form ",
     StyleBox["ObjOrientationScores2D.", "TI"]
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"OrientationScoreTensor", "[", 
       RowBox[{
        StyleBox["ObjOrientationScores2D", "TI"], ",", " ", 
        RowBox[{"{", 
         RowBox[{
          StyleBox["\[Sigma]Spatial", "TI"], ",", " ", 
          StyleBox["\[Alpha]Angular", "TI"]}], "}"}], ",", " ", 
        StyleBox["tensorType", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]Computes the derivative tensor form ",
     StyleBox["ObjOrientationScores2D", "TI"],
     " using the ",
     StyleBox["tensorType", "TI"],
     " derivatives",
     StyleBox[".", "TI"],
     " "
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    TemplateBox[{6},
     "Spacer1"]]],
   "Details"
  }], "NotesFrameText"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1],

Cell["", "SectionHeaderSpacer"],

Cell["", "Notes",
 CellID->142755667],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreTensor"]],
    "paclet:LieAnalysis/ref/OrientationScoreTensor"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 " is a wrapper function for ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreDerivatives"]],
    "paclet:LieAnalysis/ref/OrientationScoreDerivatives"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 ", the output from ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreDerivatives"]],
    "paclet:LieAnalysis/ref/OrientationScoreDerivatives"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 " is re-arranged and stored in a ObjTensor object."
}], "Notes",
 CellID->1067943069],

Cell["The Tensor is defined upon the left invariant frame.", "Notes",
 CellID->350225951],

Cell[TextData[{
 "Two predefined tensors can be specified instead of the ",
 StyleBox["derivativeIndex", "TI"],
 ": \"Hessian\" and \"Gradient\"."
}], "Notes",
 CellID->31734466],

Cell["", "SectionFooterSpacer"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]]],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(4)", "ExampleCount"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->1],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(2)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1],

Cell[TextData[{
 "Creating a ",
 Cell[BoxData[
  RowBox[{
   SubscriptBox["A", "3"], "U"}]], "InlineFormula"],
 ", ",
 Cell[BoxData[
  RowBox[{
   SubscriptBox["A", "1"], "U"}]], "InlineFormula"],
 " tensor:"
}], "ExampleText",
 CellID->3901584],

Cell[BoxData[
 RowBox[{
  RowBox[{"Needs", "[", "\"\<LieAnalysis`\>\"", "]"}], ";"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->193055033],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ost", " ", "=", " ", 
   RowBox[{"OrientationScoreTransform", "[", 
    RowBox[{"CenterArray", "[", 
     RowBox[{"1", ",", 
      RowBox[{"{", 
       RowBox[{"11", ",", "11"}], "}"}]}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"tensor", " ", "=", " ", 
  RowBox[{"OrientationScoreTensor", "[", 
   RowBox[{"ost", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"3", ",", "1"}], "}"}]}], "]"}]}]}], "Input",
 CellLabel->"In[2]:=",
 CellID->59050709],

Cell["The tensor labels can be retrieved using the part labels:", \
"ExampleText",
 CellID->183297843],

Cell[BoxData[
 RowBox[{
  RowBox[{
  "tensor", "\[LeftDoubleBracket]", "\"\<Labels\>\"", 
   "\[RightDoubleBracket]"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->172190259],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->310504357],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ost", " ", "=", " ", 
   RowBox[{"OrientationScoreTransform", "[", 
    RowBox[{"CenterArray", "[", 
     RowBox[{"1", ",", 
      RowBox[{"{", 
       RowBox[{"11", ",", "11"}], "}"}]}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"tensor", " ", "=", " ", 
  RowBox[{"OrientationScoreTensor", "[", 
   RowBox[{"ost", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1"}], "}"}], ",", "\"\<Hessian\>\""}], 
   "]"}]}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->284907172]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "Scope",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1293636265],

Cell["Other tensor types include \"StructureTensor\" and \"Gradient\".", \
"Notes",
 CellID->286934500],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ost", " ", "=", " ", 
   RowBox[{"OrientationScoreTransform", "[", 
    RowBox[{"CenterArray", "[", 
     RowBox[{"1", ",", 
      RowBox[{"{", 
       RowBox[{"11", ",", "11"}], "}"}]}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"tensor", " ", "=", " ", 
  RowBox[{"OrientationScoreTensor", "[", 
   RowBox[{"ost", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1"}], "}"}], ",", "\"\<StructureTensor\>\""}], 
   "]"}]}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->264375583],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ost", " ", "=", " ", 
   RowBox[{"OrientationScoreTransform", "[", 
    RowBox[{"CenterArray", "[", 
     RowBox[{"1", ",", 
      RowBox[{"{", 
       RowBox[{"11", ",", "11"}], "}"}]}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"tensor", " ", "=", " ", 
  RowBox[{"OrientationScoreTensor", "[", 
   RowBox[{"ost", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1"}], "}"}], ",", "\"\<Gradient\>\""}], 
   "]"}]}]}], "Input",
 CellLabel->"In[2]:=",
 CellID->145648374]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Properties & Relations",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->2123667759],

Cell[TextData[{
 "The output from ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreTensor"]],
    "paclet:LieAnalysis/ref/OrientationScoreTensor"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 " is similar to the output from ",
 ButtonBox["OrientationScoreDerivative:",
  BaseStyle->"Link",
  ButtonData->"paclet:LieAnalysis/ref/OrientationScoreDerivative"]
}], "ExampleText",
 CellID->121823226],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ost", " ", "=", " ", 
   RowBox[{"OrientationScoreTransform", "[", 
    RowBox[{"CenterArray", "[", 
     RowBox[{"1", ",", 
      RowBox[{"{", 
       RowBox[{"11", ",", "11"}], "}"}]}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tensor", " ", "=", " ", 
   RowBox[{"OrientationScoreTensor", "[", 
    RowBox[{"ost", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", "3", "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"derivatives", " ", "=", " ", 
   RowBox[{"LeftInvariantDerivatives", "[", 
    RowBox[{"ost", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}], ",", "3"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"VerificationTest", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
    "tensor", "\[LeftDoubleBracket]", "\"\<Data\>\"", 
     "\[RightDoubleBracket]"}], "\[LeftDoubleBracket]", 
    RowBox[{"All", ",", "All", ",", "All", ",", "1"}], 
    "\[RightDoubleBracket]"}], "==", 
   RowBox[{
   "derivatives", "\[LeftDoubleBracket]", "\"\<Data\>\"", 
    "\[RightDoubleBracket]"}]}], "]"}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->570084658]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "SectionFooterSpacer"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]]],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreTensor3D"]],
    "paclet:LieAnalysis/ref/OrientationScoreTensor3D"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreTransform"]],
    "paclet:LieAnalysis/ref/OrientationScoreTransform"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]]],
 "Related Guides"
}], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell["", "SectionHeaderSpacer"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["LieAnalysis Package"]],"paclet:LieAnalysis/guide/LieAnalysis"},
  "RefLink",
  BaseStyle->"MoreAbout"]], "MoreAbout",
 CellID->1]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"OrientationScoreTensor",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "LieAnalysis Package", ButtonData -> 
         "paclet:LieAnalysis/guide/LieAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2017, 10, 26, 15, 7, 4.2800559}", 
    "history" -> {"0.3", "", "", ""}, "context" -> "LieAnalysis`", 
    "keywords" -> {
     "Orientation Scores", "LieAnalysis", "Cake Wavelets", "Tensor", 
      "Image Processing"}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Lie Analysis Symbol", "language" -> "en", "paclet" -> "LieAnalysis", 
    "status" -> "None", "summary" -> 
    "OrientationScoreTensor[ObjOrientationScores2D, {\\[Sigma]Spatial, \\ \
\\[Sigma]Angular}, derivativeIndex, options] Computes the derivative tensor \
form ObjOrientationScores2D. OrientationScoreTensor[ObjOrientationScores2D, {\
\\[Sigma]Spatial, \\ \\[Alpha]Angular}, tensorType] Computes the derivative \
tensor form ObjOrientationScores2D using the tensorType derivatives. ", 
    "synonyms" -> {}, "tabletags" -> {}, "title" -> "OrientationScoreTensor", 
    "titlemodifier" -> "", "windowtitle" -> "OrientationScoreTensor", "type" -> 
    "Symbol", "uri" -> "LieAnalysis/ref/OrientationScoreTensor"}},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[7824, 234, 259, 10, 70, "PrimaryExamplesSection",ExpressionUUID->"e5c638f2-c294-404b-956e-a6b31b8a6ed2",
   CellTags->"PrimaryExamplesSection",
   CellID->1]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 17094, 556}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[594, 21, 3806, 94, 70, "AnchorBarGrid",ExpressionUUID->"318965c2-d53c-48fa-bf99-acca60f57496",
 CellID->1],
Cell[4403, 117, 179, 6, 70, "ObjectNameGrid",ExpressionUUID->"805750f6-5827-47d2-9404-07bac4dc5c86"],
Cell[4585, 125, 1398, 39, 70, "Usage",ExpressionUUID->"51efedea-8ac9-4dea-8621-07c8e93f4279",
 CellID->982511436],
Cell[CellGroupData[{
Cell[6008, 168, 621, 19, 70, "NotesSection",ExpressionUUID->"1e535790-c41b-4c2f-93d0-a9a9e38eb967",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1],
Cell[6632, 189, 31, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"bb8ade59-d363-4d64-9b6e-c1e8fe4b6f61"],
Cell[6666, 191, 37, 1, 70, "Notes",ExpressionUUID->"427d0d88-e738-40da-93fc-c2face3a7e94",
 CellID->142755667],
Cell[6706, 194, 774, 23, 70, "Notes",ExpressionUUID->"c99c33ce-5316-4806-943d-e6c112129125",
 CellID->1067943069],
Cell[7483, 219, 89, 1, 70, "Notes",ExpressionUUID->"a9a71b17-6351-4497-8112-9dfa0a2cb61d",
 CellID->350225951],
Cell[7575, 222, 178, 5, 70, "Notes",ExpressionUUID->"a035ad8c-c451-411c-a4dd-4f24126f2c36",
 CellID->31734466],
Cell[7756, 229, 31, 0, 70, "SectionFooterSpacer",ExpressionUUID->"0dbeb8d9-7b73-4e10-9ff3-9aa55a577e89"]
}, Closed]],
Cell[CellGroupData[{
Cell[7824, 234, 259, 10, 70, "PrimaryExamplesSection",ExpressionUUID->"e5c638f2-c294-404b-956e-a6b31b8a6ed2",
 CellTags->"PrimaryExamplesSection",
 CellID->1],
Cell[CellGroupData[{
Cell[8108, 248, 187, 6, 70, "ExampleSection",ExpressionUUID->"515736c5-dd94-468c-ac39-c5d1cc975c83",
 CellID->1],
Cell[8298, 256, 245, 11, 70, "ExampleText",ExpressionUUID->"9460a6b7-9353-498c-b2c1-77269e054d86",
 CellID->3901584],
Cell[8546, 269, 138, 4, 70, "Input",ExpressionUUID->"a0354710-fdcd-4a5a-8ceb-21d2fe18e7f3",
 CellID->193055033],
Cell[8687, 275, 554, 17, 70, "Input",ExpressionUUID->"ee8dcdfc-a9b5-48fe-8794-0ddd48d65c29",
 CellID->59050709],
Cell[9244, 294, 102, 2, 70, "ExampleText",ExpressionUUID->"73980748-176b-4b35-a566-7c01b30a965b",
 CellID->183297843],
Cell[9349, 298, 194, 6, 70, "Input",ExpressionUUID->"b72d6c7b-6070-4c21-8d97-44e8b2dae8fb",
 CellID->172190259],
Cell[CellGroupData[{
Cell[9568, 308, 125, 3, 70, "ExampleDelimiter",ExpressionUUID->"1cb03bf2-a2a2-4506-bf86-17e3c845dfa5",
 CellID->310504357],
Cell[9696, 313, 522, 16, 70, "Input",ExpressionUUID->"3c3979d9-cf65-4a0a-80aa-100d68d70376",
 CellID->284907172]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[10267, 335, 187, 6, 70, "ExampleSection",ExpressionUUID->"eac8e11e-4d90-4d20-8448-a4f819ad94a3",
 CellID->1293636265],
Cell[10457, 343, 103, 2, 70, "Notes",ExpressionUUID->"ceba7871-001e-45e3-b104-38ca0f5caccc",
 CellID->286934500],
Cell[10563, 347, 530, 16, 70, "Input",ExpressionUUID->"c7ab0c34-e6d4-429f-905c-0576bd183056",
 CellID->264375583],
Cell[11096, 365, 523, 16, 70, "Input",ExpressionUUID->"e5c88ebf-dc6c-41c7-906e-50afbd8ae6d8",
 CellID->145648374]
}, Closed]],
Cell[CellGroupData[{
Cell[11656, 386, 204, 6, 70, "ExampleSection",ExpressionUUID->"119e6cfd-dbf1-48cf-9475-9959b668479d",
 CellID->2123667759],
Cell[11863, 394, 440, 13, 70, "ExampleText",ExpressionUUID->"68063572-f71e-4dee-9068-6bf713ff0322",
 CellID->121823226],
Cell[12306, 409, 1197, 35, 70, "Input",ExpressionUUID->"45f60f91-41ed-4acf-8474-b5e4ce4544a4",
 CellID->570084658]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[13552, 450, 31, 0, 70, "SectionFooterSpacer",ExpressionUUID->"e5c05d48-c246-451c-88ef-62007be7c8fd"],
Cell[13586, 452, 150, 7, 70, "SeeAlsoSection",ExpressionUUID->"069a1cc7-3171-433e-ac2f-3a75e56fdf2d",
 CellID->1255426704],
Cell[13739, 461, 626, 18, 70, "SeeAlso",ExpressionUUID->"b5e470fe-62de-4691-9791-350d6002c107",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[14402, 484, 156, 7, 70, "MoreAboutSection",ExpressionUUID->"eb888318-fca3-4996-9da6-c1d3c9ee052b",
 CellID->38303248],
Cell[14561, 493, 31, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"d858347b-a2fe-42e3-8c27-273b559ed9fa"],
Cell[14595, 495, 177, 5, 70, "MoreAbout",ExpressionUUID->"1e1699d0-f019-4189-8d31-a86b1c036865",
 CellID->1]
}, Open  ]],
Cell[14787, 503, 23, 0, 70, "FooterCell",ExpressionUUID->"6726697e-70d0-4f43-9c6a-2fb497a7d4c9"]
}
]
*)

(* End of internal cache information *)
