(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     25046,        745]
NotebookOptionsPosition[     18232,        600]
NotebookOutlinePosition[     20863,        664]
CellTagsIndexPosition[     20778,        659]
WindowTitle->OrientationScoreTensor3D
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["LIE ANALYSIS SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Tutorials",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"Tutorials", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {
       RowBox[{
        RowBox[{"{", "}"}], "\[LeftDoubleBracket]", "1", 
        "\[RightDoubleBracket]"}]:>Documentation`HelpLookup[
        If[
         StringMatchQ[
          Part[{}, 2], "paclet*"], 
         Part[
          Part[{{}, {}}, 1], 2], 
         StringJoin["paclet:", 
          Part[
           Part[{{}, {}}, 1], 2]]]], 
       RowBox[{
        RowBox[{"{", "}"}], "\[LeftDoubleBracket]", "1", 
        "\[RightDoubleBracket]"}]:>Documentation`HelpLookup[
        If[
         StringMatchQ[
          Part[{}, 2], "paclet*"], 
         Part[
          Part[{{}, {}}, 2], 2], 
         StringJoin["paclet:", 
          Part[
           Part[{{}, {}}, 2], 2]]]]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"Tutorials"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"OrientationScoreTransform3D\"\>":>
       Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/OrientationScoreTransform3D"], \
"\<\"OrientationScoreDerivatives3D\"\>":>Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/OrientationScoreDerivatives3D"], \
"\<\"CakeWaveletStack3D\"\>":>Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/CakeWaveletStack3D"], \
"\<\"OrientationScoreTensor\"\>":>Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/OrientationScoreTensor"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->
         False], {"\<\"LieAnalysis/ref/OrientationScoreTensor3D\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["LieAnalysis/ref/OrientationScoreTensor3D"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/LieAnalysis/ref/\
OrientationScoreTensor3D.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$16714], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "LieAnalysis/ref/OrientationScoreTensor3D", ".html"]], None}]}]},
       
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[TextData[{
 Cell["OrientationScoreTensor3D", "ObjectName"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]]],
 Cell[BoxData[""], "ObjectNameTranslation"]
}], "ObjectNameGrid"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"OrientationScoreTensor3D", "[", 
       RowBox[{
        StyleBox["ObjOrientationScores3D", "TI"], ",", 
        RowBox[{"{", 
         StyleBox[
          RowBox[{"\[Sigma]Spatial", ",", " ", "\[Sigma]Angular"}], "TI"], 
         "}"}], ",", " ", 
        RowBox[{"{", 
         RowBox[{
          StyleBox["derivativeIndex", "TI"], "..."}], " ", "}"}], ",", " ", 
        StyleBox["options", "TI"]}], "]"}]], "InlineFormula"],
     " \[LineSeparator]Computes the derivative tensor from the ",
     StyleBox["ObjOrientationScores3D", "TI"],
     " using the specified ",
     StyleBox["\[Sigma]", "TI"],
     "'s."
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"OrientationScoreTensor3D", "[", 
       RowBox[{
        StyleBox["ObjOrientationScores3D", "TI"], ",", " ", 
        RowBox[{"{", 
         RowBox[{
          StyleBox["\[Sigma]Spatial", "TI"], ",", " ", 
          StyleBox["\[Sigma]Angular", "TI"]}], "}"}], ",", " ", 
        StyleBox["tensorType", "TI"]}], " ", "]"}]], "InlineFormula"],
     "\[LineSeparator]Computes the tensorType from the ",
     StyleBox["ObjOrientationScores3D", "TI"],
     " using the specified ",
     StyleBox["\[Sigma]", "TI"],
     "'s."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    TemplateBox[{6},
     "Spacer1"]]],
   "Details"
  }], "NotesFrameText"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1],

Cell["", "SectionHeaderSpacer"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreTensor3D"]],
    "paclet:LieAnalysis/ref/OrientationScoreTensor3D"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 " is a wrapper function for ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreDerivatives3D"]],
    "paclet:LieAnalysis/ref/OrientationScoreDerivatives3D"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 ", the output from ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreDerivatives3D"]],
    "paclet:LieAnalysis/ref/OrientationScoreDerivatives3D"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 " is re-arranged and stored in a ObjTensor object."
}], "Notes",
 CellID->1067943069],

Cell["The following options can be specified:", "Notes",
 CellID->617163],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon"], "\"\<Method\>\"", 
    "\"\<SphericalHarmonics\>\"", Cell[
    "the method used for computing the derivatives", "TableText"]}
  }]], "3ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}},
 GridBoxDividers->{"Rows" -> {{True, True}}}},
 CellID->523517383],

Cell[TextData[{
 "Two predefined ",
 StyleBox["tensorType", "TI"],
 " can be specified: \"Hessian\" and \"Gradient\"."
}], "Notes",
 CellID->110995979]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]]],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(5)", "ExampleCount"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->1],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(2)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1],

Cell["Creating a Hessian Tensor:", "Tutorials",
 CellID->739487953],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Needs", "[", "\"\<LieAnalysis`\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ost", " ", "=", " ", 
   RowBox[{"OrientationScoreTransform3D", "[", 
    RowBox[{"CenterArray", "[", 
     RowBox[{"1", ",", 
      RowBox[{"{", 
       RowBox[{"11", ",", "11", ",", "11"}], "}"}]}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"tensor", " ", "=", " ", 
  RowBox[{"OrientationScoreTensor3D", "[", 
   RowBox[{"ost", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1"}], "}"}], ",", "\"\<Hessian\>\""}], 
   "]"}]}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->696145074],

Cell["To see how the Tensor is stored the Labels can be requested:", \
"ExampleText",
 CellID->299887991],

Cell[BoxData[
 RowBox[{
  RowBox[{
  "tensor", "\[LeftDoubleBracket]", "\"\<Labels\>\"", 
   "\[RightDoubleBracket]"}], " ", "//", "MatrixForm"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->146106244],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->8617099],

Cell["Computing the gradient:", "Tutorials",
 CellID->95830000],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ost", " ", "=", " ", 
   RowBox[{"OrientationScoreTransform3D", "[", 
    RowBox[{"CenterArray", "[", 
     RowBox[{"1", ",", 
      RowBox[{"{", 
       RowBox[{"11", ",", "11", ",", "11"}], "}"}]}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"tensor", " ", "=", " ", 
  RowBox[{"OrientationScoreTensor3D", "[", 
   RowBox[{"ost", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1"}], "}"}], ",", "\"\<Gradient\>\""}], 
   "]"}]}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->64362671],

Cell["\<\
The Hessian has a special matrix output format which can be viewed through \
requesting the labels. \
\>", "ExampleText",
 CellID->1063814635],

Cell[BoxData[
 RowBox[{
  RowBox[{
  "tensor", "\[LeftDoubleBracket]", "\"\<Labels\>\"", 
   "\[RightDoubleBracket]"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->195155]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "Scope",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1293636265],

Cell[TextData[{
 "Because ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreTensor3D"]],
    "paclet:LieAnalysis/ref/OrientationScoreTensor3D"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 " is a wrapper function for ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreDerivatives3D"]],
    "paclet:LieAnalysis/ref/OrientationScoreDerivatives3D"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 ", a list of ObjOrientationScores3D can also be converted to a ObjTensor"
}], "ExampleText",
 CellID->9575785],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Needs", "[", "\"\<LieAnalysis`\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ost", " ", "=", " ", 
   RowBox[{"OrientationScoreTransform3D", "[", 
    RowBox[{"CenterArray", "[", 
     RowBox[{"1", ",", 
      RowBox[{"{", 
       RowBox[{"11", ",", "11", ",", "11"}], "}"}]}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ostDer", " ", "=", " ", 
   RowBox[{"LeftInvariantDerivatives3D", "[", 
    RowBox[{"ost", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"OrientationScoreTensor3D", "[", "ostDer", "]"}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->847201508]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Options",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->99287667],

Cell[CellGroupData[{

Cell[TextData[{
 "\"Method\"",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CellID->189734159],

Cell[TextData[{
 "This is the option from ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreDerivatives3D"]],
    "paclet:LieAnalysis/ref/OrientationScoreDerivatives3D"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 " which specifies the used method for computing the derivatives."
}], "ExampleText",
 CellID->37543831],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ost", " ", "=", " ", 
   RowBox[{"OrientationScoreTransform3D", "[", 
    RowBox[{"CenterArray", "[", 
     RowBox[{"1", ",", 
      RowBox[{"{", 
       RowBox[{"11", ",", "11", ",", "11"}], "}"}]}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"OrientationScoreTensor3D", "[", 
  RowBox[{"ost", ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", "1", "}"}], ",", 
   RowBox[{"\"\<Method\>\"", "\[Rule]", "\"\<FiniteDifferences\>\""}]}], 
  "]"}], "\[IndentingNewLine]"}], "Input",
 CellLabel->"In[1]:=",
 CellID->31967917]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Properties & Relations",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->2123667759],

Cell[TextData[{
 "The output from ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreTensor3D"]],
    "paclet:LieAnalysis/ref/OrientationScoreTensor3D"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 " is similar to the output from ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreDerivatives3D"]],
    "paclet:LieAnalysis/ref/OrientationScoreDerivatives3D"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"]
}], "ExampleText",
 CellID->253884258],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ost", " ", "=", " ", 
   RowBox[{"OrientationScoreTransform3D", "[", 
    RowBox[{"CenterArray", "[", 
     RowBox[{"1", ",", 
      RowBox[{"{", 
       RowBox[{"11", ",", "11", ",", "11"}], "}"}]}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tensor", " ", "=", " ", 
   RowBox[{"OrientationScoreTensor3D", "[", 
    RowBox[{"ost", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", "3", "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"derivatives", " ", "=", " ", 
   RowBox[{"LeftInvariantDerivatives3D", "[", 
    RowBox[{"ost", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}], ",", "3"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"VerificationTest", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
    "tensor", "\[LeftDoubleBracket]", "\"\<Data\>\"", 
     "\[RightDoubleBracket]"}], "\[LeftDoubleBracket]", 
    RowBox[{"All", ",", "All", ",", "All", ",", "All", ",", "1"}], 
    "\[RightDoubleBracket]"}], "==", 
   RowBox[{"derivatives", "[", "\"\<Data\>\"", "]"}]}], "]"}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->496211596]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "SectionFooterSpacer"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]]],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreTransform3D"]],
    "paclet:LieAnalysis/ref/OrientationScoreTransform3D"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreDerivatives3D"]],
    "paclet:LieAnalysis/ref/OrientationScoreDerivatives3D"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["CakeWaveletStack3D"]],
    "paclet:LieAnalysis/ref/CakeWaveletStack3D"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreTensor"]],
    "paclet:LieAnalysis/ref/OrientationScoreTensor"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"OrientationScoreTensor3D",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "LieAnalysis Package", ButtonData -> 
         "paclet:LieAnalysis/guide/LieAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2017, 10, 26, 15, 7, 2.9090896}", 
    "history" -> {"0.3", "", "", ""}, "context" -> "LieAnalysis`", 
    "keywords" -> {
     "Orientation Score Tensor", "Tensor", "Orientation Scores", 
      "LieAnalysis", "Cake Wavelets", "Derivatives"}, "specialkeywords" -> {},
     "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Lie Analysis Symbol", "language" -> "en", "paclet" -> "LieAnalysis", 
    "status" -> "None", "summary" -> 
    "OrientationScoreTensor3D[ObjOrientationScores3D, {\\[Sigma]Spatial, \\ \
\\[Sigma]Angular}, {derivativeIndex ... }, options] Computes the derivative \
tensor from the ObjOrientationScores3D using the specified \\[Sigma]'s. \
OrientationScoreTensor3D[ObjOrientationScores3D, {\\[Sigma]Spatial, \\ \
\\[Sigma]Angular}, tensorType ] Computes the tensorType from the \
ObjOrientationScores3D using the specified \\[Sigma]'s.", "synonyms" -> {}, 
    "tabletags" -> {}, "title" -> "OrientationScoreTensor3D", "titlemodifier" -> 
    "", "windowtitle" -> "OrientationScoreTensor3D", "type" -> "Symbol", 
    "uri" -> "LieAnalysis/ref/OrientationScoreTensor3D"}},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[9041, 269, 259, 10, 70, "PrimaryExamplesSection",ExpressionUUID->"1163c76d-2e6f-4bbb-bc85-f21598b03067",
   CellTags->"PrimaryExamplesSection",
   CellID->1]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 20588, 652}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[596, 21, 4633, 120, 70, "AnchorBarGrid",ExpressionUUID->"38168c82-b075-4a83-bb01-c36dc91d1abe",
 CellID->1],
Cell[5232, 143, 181, 6, 70, "ObjectNameGrid",ExpressionUUID->"6f93188b-1caf-4ad9-808c-bfde2fd0d9d0"],
Cell[5416, 151, 1473, 41, 70, "Usage",ExpressionUUID->"b5bc5683-5fab-4bbe-bba0-31020408f45a",
 CellID->982511436],
Cell[CellGroupData[{
Cell[6914, 196, 621, 19, 70, "NotesSection",ExpressionUUID->"17203d72-6642-4462-a939-5531e4a2d63f",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1],
Cell[7538, 217, 31, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"bdbcd1e2-9b5b-43d9-9810-7bbb5950c075"],
Cell[7572, 219, 786, 23, 70, "Notes",ExpressionUUID->"7f1405b6-ae87-4162-80ff-3c17f5be7e5d",
 CellID->1067943069],
Cell[8361, 244, 73, 1, 70, "Notes",ExpressionUUID->"4e1ec31f-2190-4f9b-87ee-bcd91626c00e",
 CellID->617163],
Cell[8437, 247, 413, 10, 70, "3ColumnTableMod",ExpressionUUID->"32c2df78-3b18-4053-921d-33d4fd5867e5",
 CellID->523517383],
Cell[8853, 259, 151, 5, 70, "Notes",ExpressionUUID->"d703c47a-9c07-4a24-89bf-0c0ac38e1ff3",
 CellID->110995979]
}, Closed]],
Cell[CellGroupData[{
Cell[9041, 269, 259, 10, 70, "PrimaryExamplesSection",ExpressionUUID->"1163c76d-2e6f-4bbb-bc85-f21598b03067",
 CellTags->"PrimaryExamplesSection",
 CellID->1],
Cell[CellGroupData[{
Cell[9325, 283, 187, 6, 70, "ExampleSection",ExpressionUUID->"30253e8c-a83a-4161-8671-2bf639e9950f",
 CellID->1],
Cell[9515, 291, 67, 1, 70, "Tutorials",ExpressionUUID->"1e5d20ae-9fa7-4cf4-8ef0-52e16039781f",
 CellID->739487953],
Cell[9585, 294, 636, 19, 70, "Input",ExpressionUUID->"85f9041c-a9af-42c6-9453-ad96ed06d573",
 CellID->696145074],
Cell[10224, 315, 105, 2, 70, "ExampleText",ExpressionUUID->"cf78adfa-67cd-4788-a54a-30677db2cb34",
 CellID->299887991],
Cell[10332, 319, 199, 6, 70, "Input",ExpressionUUID->"d0f89661-239e-4244-861f-4a13d152f67b",
 CellID->146106244],
Cell[CellGroupData[{
Cell[10556, 329, 123, 3, 70, "ExampleDelimiter",ExpressionUUID->"9ae7654d-64f3-4bb7-9df8-35feea4c8c76",
 CellID->8617099],
Cell[10682, 334, 63, 1, 70, "Tutorials",ExpressionUUID->"38ae2aed-0ef4-4183-ac57-85214d952455",
 CellID->95830000],
Cell[10748, 337, 537, 16, 70, "Input",ExpressionUUID->"088466d6-d1ac-4ada-9ccb-29db0ab7a63b",
 CellID->64362671],
Cell[11288, 355, 152, 4, 70, "ExampleText",ExpressionUUID->"186758da-5c36-4397-837e-000d5531bb69",
 CellID->1063814635],
Cell[11443, 361, 191, 6, 70, "Input",ExpressionUUID->"f9c686dd-bab3-4d81-b7d5-fd89c42f6e78",
 CellID->195155]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[11683, 373, 187, 6, 70, "ExampleSection",ExpressionUUID->"04c12465-a9a8-4427-8234-5a92c32f06e0",
 CellID->1293636265],
Cell[11873, 381, 588, 17, 70, "ExampleText",ExpressionUUID->"f115625c-772b-474a-9f81-9ce82c729b0d",
 CellID->9575785],
Cell[12464, 400, 791, 23, 70, "Input",ExpressionUUID->"0b779c98-0535-4c1c-83e8-e3b830442d1c",
 CellID->847201508]
}, Closed]],
Cell[CellGroupData[{
Cell[13292, 428, 187, 6, 70, "ExampleSection",ExpressionUUID->"bff27bdb-4279-4f44-9ca7-423711320925",
 CellID->99287667],
Cell[CellGroupData[{
Cell[13504, 438, 197, 6, 70, "ExampleSubsection",ExpressionUUID->"ef3eaa53-2c2b-4879-ae68-40e9b6222e4d",
 CellID->189734159],
Cell[13704, 446, 362, 10, 70, "ExampleText",ExpressionUUID->"26248d26-af3e-4d7c-aeb0-3d6891ee3f29",
 CellID->37543831],
Cell[14069, 458, 604, 17, 70, "Input",ExpressionUUID->"28358340-16ca-4d23-b6a3-675a78393cc3",
 CellID->31967917]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[14722, 481, 204, 6, 70, "ExampleSection",ExpressionUUID->"4e3d067f-045a-42c7-b96e-72a6bdf8d467",
 CellID->2123667759],
Cell[14929, 489, 526, 16, 70, "ExampleText",ExpressionUUID->"917fd0cb-0fa0-4937-a56e-e68f35d043b6",
 CellID->253884258],
Cell[15458, 507, 1178, 33, 70, "Input",ExpressionUUID->"c034bc42-bcf2-4303-83a1-eee6e57cdcb8",
 CellID->496211596]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[16685, 546, 31, 0, 70, "SectionFooterSpacer",ExpressionUUID->"87a9437f-0073-4aa1-a0dc-5dda54db9f66"],
Cell[16719, 548, 150, 7, 70, "SeeAlsoSection",ExpressionUUID->"3881048b-c473-42c0-a125-86149489d5c5",
 CellID->1255426704],
Cell[16872, 557, 1318, 38, 70, "SeeAlso",ExpressionUUID->"689970b6-d4e9-4d79-b36f-85a458fc36a7",
 CellID->929782353]
}, Open  ]],
Cell[18205, 598, 23, 0, 70, "FooterCell",ExpressionUUID->"f5c3f71b-67bd-4eb4-ae3e-8248bf132c41"]
}
]
*)

(* End of internal cache information *)
