(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    193619,       3936]
NotebookOptionsPosition[    178625,       3634]
NotebookOutlinePosition[    181177,       3697]
CellTagsIndexPosition[    181090,       3692]
WindowTitle->OrientationScoreTransform
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["LIE ANALYSIS SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"CakeWaveletStack\"\>":>
       Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/CakeWaveletStack"], \
"\<\"GaborWaveletStack\"\>":>Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/GaborWaveletStack"], \
"\<\"InverseOrientationScoreTransform\"\>":>Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/InverseOrientationScoreTransform"], \
"\<\"OrientationScoreDerivatives\"\>":>Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/OrientationScoreDerivatives"], \
"\<\"OrientationScoreTransform3D\"\>":>Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/OrientationScoreTransform3D"], \
"\<\"OrientationScoreTensor\"\>":>Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/OrientationScoreTensor"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Related Guides",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"Related Guides", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"LieAnalysis Package\"\>":>
       Documentation`HelpLookup["paclet:LieAnalysis/guide/LieAnalysis"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAbout"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->
         False], {"\<\"LieAnalysis/ref/OrientationScoreTransform\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["LieAnalysis/ref/OrientationScoreTransform"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/LieAnalysis/ref/\
OrientationScoreTransform.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$18684], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "LieAnalysis/ref/OrientationScoreTransform", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[TextData[{
 Cell["OrientationScoreTransform", "ObjectName"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]]],
 Cell[BoxData[""], "ObjectNameTranslation"]
}], "ObjectNameGrid"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"OrientationScoreTransform", "[", 
       RowBox[{
        StyleBox["data", "TI"], ",", " ", 
        StyleBox["ObjOrientationWavelet", "TI"]}], "]"}]], "InlineFormula"],
     " \[LineSeparator]constructs an Orientation Score from ",
     StyleBox["data", "TI"],
     " using the supplied ObjOrientationWavelet"
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"OrientationScoreTransform", "[", 
       RowBox[{
        StyleBox["data", "TI"], ",", " ", 
        StyleBox["options", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]constructs an Orientation Score from ",
     StyleBox["data", "TI"],
     " using wavelets constructed with the parameters supplied in ",
     StyleBox["options", "TI"]
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    TemplateBox[{6},
     "Spacer1"]]],
   "Details"
  }], "NotesFrameText"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1],

Cell["", "SectionHeaderSpacer"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreTransform"]],
    "paclet:LieAnalysis/ref/OrientationScoreTransform"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 " internally uses the function ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["CakeWaveletStack"]],"paclet:LieAnalysis/ref/CakeWaveletStack"},
   
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 " or ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["GaborWaveletStack"]],
    "paclet:LieAnalysis/ref/GaborWaveletStack"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 " if no ObjOrientationWavelet is supplied."
}], "Notes",
 CellID->1067943069],

Cell["The following options can be provided:", "Notes",
 CellID->356980404],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon"], "\"\<WaveletSize\>\"", "21", Cell[
    "the size of the wavelet", "TableText"]},
   {Cell["      ", "TableRowIcon"], "\"\<Type\>\"", "\"\<Cake\>\"", Cell[
    "type of wavelet", "TableText"]},
   {Cell["      ", "TableRowIcon"], "\"\<Orientations\>\"", "12", Cell[
    "number of orientations", "TableText"]}
  }]], "3ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, {None}}, "RowsIndexed" -> {}},
 GridBoxDividers->{"Rows" -> {{True, True, True, True}}}},
 CellID->142437943],

Cell["The following types of wavelets can be used:", "Notes",
 CellID->148936],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon"], Cell["\"Cake\"", "TableText"], Cell[
    "Cake Wavelets", "TableText"]},
   {Cell["      ", "TableRowIcon"], Cell["\"Gabor\"", "TableText"], Cell[
    "Orientation Sensitive Gabor Wavelets", "TableText"]},
   {Cell["      ", "TableRowIcon"], Cell["\"MultiScaleCake\"", "TableText"], 
    Cell["Cake Wavelets and Scales", "TableText"]}
  }]], "2ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, {None}}, "RowsIndexed" -> {}},
 GridBoxDividers->{"Rows" -> {{True, True, True, True}}}},
 CellID->25275162],

Cell[TextData[{
 "The Orientation Score is constructed according to: ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SubscriptBox["U", "f"], "(", 
     RowBox[{
      StyleBox["x",
       FontWeight->"Bold"], 
      StyleBox[",",
       FontWeight->"Plain"], 
      StyleBox["\[Theta]",
       FontWeight->"Plain"]}], 
     StyleBox[")",
      FontWeight->"Plain"]}], 
    StyleBox[" ",
     FontWeight->"Plain"], 
    StyleBox[":=",
     FontWeight->"Plain"], 
    RowBox[{
     RowBox[{
      SubscriptBox[
       StyleBox["\[ScriptCapitalW]",
        FontWeight->"Plain"], "\[Psi]"], "f"}], " ", "=", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         OverscriptBox[
          OverscriptBox["\[Psi]", "_"], "^"], "\[Star]", "f"}], ")"}], 
       RowBox[{"(", 
        StyleBox["x",
         FontWeight->"Bold"], ")"}]}], " ", "=", " ", 
      RowBox[{
       SubscriptBox["\[Integral]", 
        SuperscriptBox["\[DoubleStruckCapitalR]", "2"]], " ", 
       RowBox[{
        OverscriptBox[
         RowBox[{"\[Psi]", " ", 
          RowBox[{
           SuperscriptBox[
            SubscriptBox[
             StyleBox["R",
              FontWeight->"Bold"], "\[Theta]"], 
            RowBox[{"-", "1"}]], "(", 
           RowBox[{
            StyleBox["y",
             FontWeight->"Bold"], "-", 
            StyleBox["x",
             FontWeight->"Bold"]}], ")"}]}], "_"], " ", 
        RowBox[{"f", "(", 
         StyleBox["y",
          FontWeight->"Bold"], ")"}], 
        StyleBox[
         RowBox[{"d", 
          StyleBox["y",
           FontWeight->"Bold"]}]]}]}]}]}]}], TraditionalForm]]],
 ", where \[Psi] is the anisotropic kernel oriented along the x-axis which we \
identify with \[Theta] = 0, and where ",
 Cell[BoxData[
  FormBox[
   SubscriptBox[
    StyleBox["\[ScriptCapitalW]",
     FontWeight->"Plain"], "\[Psi]"], TraditionalForm]]],
 " denotes the transformation between image f and orientation score ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["U", "f"], TraditionalForm]]],
 "."
}], "Notes",
 CellID->108414689],

Cell[TextData[{
 "All options from both ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["CakeWaveletStack"]],"paclet:LieAnalysis/ref/CakeWaveletStack"},
   
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 ", ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["GaborWaveletStack"]],
    "paclet:LieAnalysis/ref/GaborWaveletStack"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 " and ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MultiScaleCakeWaveletStack"]],
    "paclet:LieAnalysis/ref/MultiScaleCakeWaveletStack"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 " can also be provided. Obviously only the options that are valid for this \
\"Type\" are used."
}], "Notes",
 CellID->444647279],

Cell[TextData[{
 "The default output is an ",
 StyleBox["ObjPositionOrientationData",
  FontSlant->"Italic"],
 ". In case a multi scale cake wavelet, constructed using \
MultiScaleCakeWaveletStack, is used the output is an ",
 StyleBox["ObjOrientationScores2D",
  FontSlant->"Italic"],
 "."
}], "Notes",
 CellID->82891502],

Cell[TextData[{
 "By Applying the ",
 ButtonBox["Normal",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Normal"],
 " function to any output object returns an ",
 ButtonBox["Association",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Association"],
 " from all elements of that object."
}], "Notes",
 CellID->47359656],

Cell["\<\
If possible, the function OrientationScoreTransform makes use of symmetry at \
the orientation axes to save memory and computation time. \
\>", "Notes",
 CellID->164699435],

Cell["\<\
When an odd number of orientations or the wavelets are directional symmetry \
can not be used. \
\>", "Notes",
 CellID->1336083746],

Cell[TextData[{
 "Internally the data is saved as ",
 ButtonBox["Image",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Image"],
 " to limit the precision to Real32 values."
}], "Notes",
 CellID->693341366],

Cell["", "SectionFooterSpacer"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]]],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(19)", "ExampleCount"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->1],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(4)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1],

Cell["Construct an Orientation Score from an image", "ExampleText",
 CellID->101006888],

Cell[BoxData[{
 RowBox[{"Needs", "[", "\"\<LieAnalysis`\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"ost", " ", "=", " ", 
  RowBox[{"OrientationScoreTransform", "[", 
   RowBox[{"LieAnalysisData", "[", 
    RowBox[{"{", 
     RowBox[{"\"\<image\>\"", ",", "\"\<retina-1\>\""}], "}"}], "]"}], 
   "]"}]}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->195857478],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->14553154],

Cell[TextData[{
 "Construct an Orientation Score using precomputed ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["GaborWaveletStack"]],
    "paclet:LieAnalysis/ref/GaborWaveletStack"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"]
}], "ExampleText",
 CellID->191669434],

Cell[BoxData[{
 RowBox[{
  RowBox[{"gws", " ", "=", " ", 
   RowBox[{"GaborWaveletStack", "[", 
    RowBox[{"12", ",", "3", ",", "Automatic", ",", 
     RowBox[{"\"\<Directional\>\"", "\[Rule]", "False"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"OrientationScoreTransform", "[", 
  RowBox[{
   RowBox[{"LieAnalysisData", "[", 
    RowBox[{"{", 
     RowBox[{"\"\<image\>\"", ",", "\"\<retina-2\>\""}], "}"}], "]"}], ",", 
   " ", "gws"}], "]"}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->219987100]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->426355476],

Cell[TextData[{
 "Construct an Orientation Score using precomputed ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MultiScaleCakeWaveletStack"]],
    "paclet:LieAnalysis/ref/MultiScaleCakeWaveletStack"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"]
}], "ExampleText",
 CellID->102848757],

Cell[BoxData[{
 RowBox[{
  RowBox[{"mscws", " ", "=", " ", 
   RowBox[{"MultiScaleCakeWaveletStack", "[", 
    RowBox[{"12", ",", "75", ",", 
     RowBox[{"{", 
      RowBox[{"0.1", ",", " ", "0.7", ",", "2"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"ost", " ", "=", " ", 
  RowBox[{"OrientationScoreTransform", "[", 
   RowBox[{
    RowBox[{"LieAnalysisData", "[", 
     RowBox[{"{", 
      RowBox[{"\"\<image\>\"", ",", "\"\<turtle\>\""}], "}"}], "]"}], ",", 
    "mscws"}], "]"}]}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->670791194]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->330736115],

Cell[TextData[{
 "The ",
 StyleBox["ObjPositionOrientationData",
  FontSlant->"Italic"],
 " and ",
 StyleBox["ObjScaleOrientationScores2D",
  FontSlant->"Italic"],
 " contain properties and elements. For example if we would like to see the \
used wavelets, we can get them by using the element wavelets."
}], "ExampleText",
 CellID->400588844],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ost", " ", "=", " ", 
   RowBox[{"OrientationScoreTransform", "[", 
    RowBox[{"LieAnalysisData", "[", 
     RowBox[{"{", 
      RowBox[{"\"\<image\>\"", ",", "\"\<turtle\>\""}], "}"}], "]"}], "]"}]}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{"ost", "\[LeftDoubleBracket]", "\"\<Wavelets\>\"", 
  "\[RightDoubleBracket]"}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->134955728]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "Scope",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(3)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1293636265],

Cell[TextData[{
 "To control the shape of the used CakeWaveletStack the parameters can be \
supplied using the options of ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreTransform"]],
    "paclet:LieAnalysis/ref/OrientationScoreTransform"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 ". Note that the options used depend on the option \"Type\" in which you \
specify the wavelet type."
}], "ExampleText",
 CellID->398623276],

Cell[BoxData[
 RowBox[{"OrientationScoreTransform", "[", 
  RowBox[{
   RowBox[{"LieAnalysisData", "[", 
    RowBox[{"{", 
     RowBox[{"\"\<image\>\"", ",", "\"\<turtle\>\""}], "}"}], "]"}], ",", 
   RowBox[{"\"\<Orientations\>\"", "\[Rule]", "36"}], ",", 
   RowBox[{"\"\<OverlapFactor\>\"", "\[Rule]", "3"}], ",", 
   RowBox[{"\"\<DcStandardDeviation\>\"", "\[Rule]", "10"}]}], "]"}]], "Input",\

 CellLabel->"In[1]:=",
 CellID->356571065],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->287574405],

Cell[TextData[{
 "The ",
 StyleBox["data", "TI"],
 " argument can be supplied in different representations"
}], "ExampleText",
 CellID->53070424],

Cell[BoxData[
 RowBox[{"OrientationScoreTransform", "/@", 
  RowBox[{"{", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"LieAnalysisData", "[", 
     RowBox[{"{", 
      RowBox[{"\"\<image\>\"", ",", "\"\<turtle\>\""}], "}"}], "]"}], ",", 
    RowBox[{"ImageData", "[", 
     RowBox[{"LieAnalysisData", "[", 
      RowBox[{"{", 
       RowBox[{"\"\<image\>\"", ",", "\"\<turtle\>\""}], "}"}], "]"}], "]"}], 
    ",", 
    RowBox[{"Graphics", "[", 
     RowBox[{"Circle", "[", "]"}], "]"}]}], "\[IndentingNewLine]", 
   "}"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->15117535]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->27374621],

Cell[TextData[{
 "In case an even number of orientations is used, only half of the \
orientations are saved in the ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["ObjOrientationScores2D"]],
    "paclet:LieAnalysis/ref/ObjOrientationScores2D"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 ". By making use of symmetry data storage is thereby minimized. However the \
full range can be requested by the key FullData."
}], "ExampleText",
 CellID->279156392],

Cell[BoxData[{
 RowBox[{"Needs", "[", "\"\<LieAnalysis`\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ost", " ", "=", " ", 
   RowBox[{"OrientationScoreTransform", "[", 
    RowBox[{
     RowBox[{"LieAnalysisData", "[", 
      RowBox[{"{", 
       RowBox[{"\"\<image\>\"", ",", "\"\<turtle\>\""}], "}"}], "]"}], ",", 
     " ", 
     RowBox[{"\"\<Orientations\>\"", "\[Rule]", "12"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ost", "[", "\"\<Data\>\"", "]"}], "//", 
  "Dimensions"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ost", "[", "\"\<FullData\>\"", "]"}], "//", 
  "Dimensions"}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->217215471]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Generalizations & Extensions",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(2)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1020263627],

Cell["\<\
The data within the Orientation Score object can be set by using the \
functions Affix. Internally the Data term is stored as an image.\
\>", "ExampleText",
 CellID->213524762],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ost", " ", "=", " ", 
   RowBox[{"OrientationScoreTransform", "[", 
    RowBox[{
     RowBox[{"LieAnalysisData", "[", 
      RowBox[{"{", 
       RowBox[{"\"\<image\>\"", ",", "\"\<turtle\>\""}], "}"}], "]"}], ",", 
     " ", 
     RowBox[{"\"\<Orientations\>\"", "\[Rule]", "12"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"ost2", " ", "=", " ", 
  RowBox[{"Affix", "[", 
   RowBox[{"ost", ",", 
    RowBox[{"\"\<Data\>\"", "\[Rule]", 
     RowBox[{"CenterArray", "[", 
      RowBox[{"1", ",", 
       RowBox[{"{", 
        RowBox[{"11", ",", "11", ",", "6"}], "}"}]}], "]"}]}]}], 
   "]"}]}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->869382195],

Cell["\<\
Or using AffixTo will produce the same results but assigning the new part \
directly to the object.\
\>", "ExampleText",
 CellID->20550242],

Cell[BoxData[
 RowBox[{"AffixTo", "[", 
  RowBox[{"ost", ",", 
   RowBox[{"\"\<Data\>\"", "\[Rule]", 
    RowBox[{"CenterArray", "[", 
     RowBox[{"1", ",", 
      RowBox[{"{", 
       RowBox[{"11", ",", "11", ",", "6"}], "}"}]}], "]"}]}]}], 
  "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->6507531],

Cell["\<\
Be careful though, as this can lead to unexpected results when using this \
result in other functions, as the elements may not be coherent. \
\>", "ExampleText",
 CellID->221584252],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->124325148],

Cell[TextData[{
 "For experimenting it can be useful to create an Orientation Score object \
without using the ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreTransform"]],
    "paclet:LieAnalysis/ref/OrientationScoreTransform"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 ". "
}], "ExampleText",
 CellID->820748767],

Cell[BoxData[
 RowBox[{"ObjPositionOrientationData", "[", 
  RowBox[{"{", 
   RowBox[{"\"\<Data\>\"", "\[Rule]", 
    RowBox[{"CenterArray", "[", 
     RowBox[{"1", ",", 
      RowBox[{"{", 
       RowBox[{"101", ",", "101", ",", "6"}], "}"}]}], "]"}]}], "}"}], 
  "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1236462],

Cell[TextData[{
 "It is very likely that other functions (e.g. ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["LeftInvariantDerivatives"]],
    "paclet:LieAnalysis/ref/LeftInvariantDerivatives"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 " or ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["InverseOrientationScoreTransform"]],
    "paclet:LieAnalysis/ref/InverseOrientationScoreTransform"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 ") might not work if you have not provided all parts or when parts are not \
coherent."
}], "ExampleText",
 CellID->215533415]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Options",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(4)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->2061341341],

Cell[CellGroupData[{

Cell[TextData[{
 "Orientations",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CellID->1757724783],

Cell["\<\
To control the number of orientations used the option Orientations can be set\
\
\>", "ExampleText",
 CellID->401848163],

Cell[BoxData[
 RowBox[{"ostObj", " ", "=", " ", 
  RowBox[{
   RowBox[{
    RowBox[{"OrientationScoreTransform", "[", 
     RowBox[{
      RowBox[{"LieAnalysisData", "[", 
       RowBox[{"{", 
        RowBox[{"\"\<image\>\"", ",", "\"\<turtle\>\""}], "}"}], "]"}], ",", 
      RowBox[{"\"\<Orientations\>\"", "\[Rule]", "#"}]}], "]"}], "&"}], "/@", 
   
   RowBox[{"{", 
    RowBox[{"6", ",", "12"}], "}"}]}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->306930788]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "WaveletSize",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(2)", "ExampleCount"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CellID->1295379749],

Cell["\<\
To control the size of the wavelet, which does not influence the shape of the \
wavelet, the option WaveletSize can be set.\
\>", "ExampleText",
 CellID->165609880],

Cell[BoxData[
 RowBox[{"ostObj", " ", "=", " ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"OrientationScoreTransform", "[", 
      RowBox[{
       RowBox[{"LieAnalysisData", "[", 
        RowBox[{"{", 
         RowBox[{"\"\<image\>\"", ",", "\"\<turtle\>\""}], "}"}], "]"}], ",", 
       
       RowBox[{"\"\<WaveletSize\>\"", "\[Rule]", "#"}]}], "]"}], 
     "\[LeftDoubleBracket]", "\"\<Wavelets\>\"", "\[RightDoubleBracket]"}], 
    "&"}], "/@", 
   RowBox[{"{", 
    RowBox[{"31", ",", "51"}], "}"}]}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->13033581],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->810334137],

Cell["The WaveletSize does not influence the shape of the kernel", \
"ExampleText",
 CellID->187743862],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"W31", ",", "W51"}], "}"}], " ", "=", " ", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"OrientationScoreTransform", "[", 
        RowBox[{
         RowBox[{"LieAnalysisData", "[", 
          RowBox[{"{", 
           RowBox[{"\"\<image\>\"", ",", "\"\<turtle\>\""}], "}"}], "]"}], 
         ",", 
         RowBox[{"\"\<WaveletSize\>\"", "\[Rule]", "#"}]}], "]"}], 
       "\[LeftDoubleBracket]", "\"\<Wavelets\>\"", "\[RightDoubleBracket]"}], 
      "\[LeftDoubleBracket]", "\"\<Data\>\"", "\[RightDoubleBracket]"}], 
     "&"}], "/@", 
    RowBox[{"{", 
     RowBox[{"31", ",", "51"}], "}"}]}]}], ";"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->143795367],

Cell[BoxData[
 RowBox[{"ListLinePlot", "[", 
  RowBox[{
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Re", "@", 
      RowBox[{"W31", "\[LeftDoubleBracket]", 
       RowBox[{"3", ",", 
        RowBox[{
         RowBox[{"16", "-", "10"}], ";;", 
         RowBox[{"16", "+", "10"}]}], ",", "16"}], 
       "\[RightDoubleBracket]"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"Re", "@", 
      RowBox[{"W51", "\[LeftDoubleBracket]", 
       RowBox[{"3", ",", 
        RowBox[{
         RowBox[{"26", "-", "10"}], ";;", 
         RowBox[{"26", "+", "10"}]}], ",", "26"}], 
       "\[RightDoubleBracket]"}]}]}], "\[IndentingNewLine]", "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", " ", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Dashing", "[", "\[Infinity]", "]"}], ",", 
      RowBox[{"Dashing", "[", "0.1", "]"}]}], "}"}]}], ",", " ", 
   RowBox[{"AxesLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<Position\>\"", ",", "\"\<Response\>\""}], "}"}]}], ",", " ", 
   RowBox[{"PlotLegends", "\[Rule]", 
    RowBox[{"Placed", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\"\<W31\>\"", ",", "\"\<W51\>\""}], "}"}], ",", "Above"}], 
     "]"}]}], ",", 
   RowBox[{"ImageSize", "\[Rule]", "Full"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->10633767]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Type",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CellID->30421503],

Cell["\<\
To create an Orientation Score, different wavelets can be used. \
\>", "ExampleText",
 CellID->30340898],

Cell[BoxData[{
 RowBox[{"Needs", "[", "\"\<LieAnalysis`\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"ostObj", " ", "=", " ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"OrientationScoreTransform", "[", 
      RowBox[{
       RowBox[{"LieAnalysisData", "[", 
        RowBox[{"{", 
         RowBox[{"\"\<image\>\"", ",", "\"\<turtle\>\""}], "}"}], "]"}], ",", 
       
       RowBox[{"\"\<Type\>\"", "\[Rule]", "#"}], ",", 
       RowBox[{"\"\<WaveletSize\>\"", "\[Rule]", "53"}]}], "]"}], 
     "\[LeftDoubleBracket]", "\"\<Wavelets\>\"", "\[RightDoubleBracket]"}], 
    "&"}], "/@", 
   RowBox[{"{", 
    RowBox[{
    "\"\<Gabor\>\"", ",", "\"\<Cake\>\"", ",", "\"\<MultiScaleCake\>\""}], 
    "}"}]}]}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->63704636],

Cell[BoxData[""], "Input",
 CellLabel->"In[2]:=",
 CellID->456127706]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Applications",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->258228157],

Cell["Retinal vessel enhancement by Basic Power Law Stretching.", \
"ExampleText",
 CellID->328876646],

Cell[BoxData[
 RowBox[{
  RowBox[{"ostObj", " ", "=", " ", 
   RowBox[{"OrientationScoreTransform", "[", 
    RowBox[{
     GraphicsBox[
      TagBox[RasterBox[CompressedData["
1:eJzkvQ2rNNlxrSl7JGFjiStsYWEbNx4jYYsWamHRrZGxjY3H9DvnFFVkJZlk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        "], {{0, 300}, {433, 0}}, {0, 255},
        ColorFunction->RGBColor],
       BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
       Selectable->False],
      DefaultBaseStyle->"ImageGraphics",
      ImageSize->{38.9296875, Automatic},
      ImageSizeRaw->{433, 300},
      PlotRange->{{0, 433}, {0, 300}}], ",", 
     RowBox[{"\"\<Orientations\>\"", "\[Rule]", "12"}], ",", 
     RowBox[{"\"\<DcStandardDeviation\>\"", "\[Rule]", "50"}], ",", 
     RowBox[{"\"\<InflectionPoint\>\"", "\[Rule]", 
      RowBox[{"(", 
       RowBox[{"100", "/", "300"}], ")"}]}], ",", 
     RowBox[{"\"\<WaveletSize\>\"", "\[Rule]", "301"}], ",", 
     RowBox[{"\"\<OverlapFactor\>\"", "\[Rule]", "2"}]}], "]"}]}], 
  ";"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1991243039],

Cell[BoxData[{
 RowBox[{
  RowBox[{"osn", " ", "=", " ", 
   RowBox[{"Total", "[", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"Abs", "[", 
       RowBox[{"ostObj", "[", "\"\<FullData\>\"", "]"}], "]"}], "2"], ",", 
     "3"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"osp", " ", "=", " ", 
   RowBox[{
    RowBox[{"Sign", "[", 
     RowBox[{"Re", "[", 
      RowBox[{"ostObj", "[", "\"\<FullData\>\"", "]"}], "]"}], "]"}], 
    SuperscriptBox[
     RowBox[{"Abs", "[", 
      RowBox[{"Re", "[", 
       RowBox[{"ostObj", "[", "\"\<FullData\>\"", "]"}], "]"}], "]"}], 
     "1.5"]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"osp", " ", "=", " ", 
   RowBox[{"osp", " ", "*", " ", 
    RowBox[{"osn", " ", "/", " ", 
     RowBox[{"Total", "[", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"Abs", "[", "osp", "]"}], "2"], ",", "3"}], "]"}]}]}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"ostObj2", " ", "=", " ", 
   RowBox[{"Affix", "[", 
    RowBox[{"ostObj", ",", " ", 
     RowBox[{"{", 
      RowBox[{"\"\<Data\>\"", "\[Rule]", "osp"}], "}"}]}], "]"}]}], 
  ";"}]}], "Input",
 CellLabel->"In[2]:=",
 CellID->1380700992],

Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{"mask", "=", 
    RowBox[{"Erosion", "[", 
     RowBox[{
      RowBox[{"Image", "[", 
       RowBox[{"UnitStep", "[", 
        RowBox[{
         RowBox[{"ostObj", "[", 
          RowBox[{"[", "\"\<InputData\>\"", "]"}], "]"}], "-", "0.1"}], "]"}],
        "]"}], ",", "20"}], "]"}]}], ";"}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1965295417],

Cell[BoxData[
 RowBox[{"GraphicsGrid", "[", 
  RowBox[{
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
      "\"\<Reconstructed Original\>\"", ",", " ", "\[IndentingNewLine]", 
       "\"\<Reconstructed Enhanced\>\"", ",", " ", "\[IndentingNewLine]", 
       "\"\<Reconstructed without DcComponent\>\""}], "\[IndentingNewLine]", 
      "}"}], ",", 
     RowBox[{"ImageAdjust", "/@", 
      RowBox[{"{", "\n", "\t", 
       RowBox[{
        RowBox[{"ImageMultiply", "[", "\[IndentingNewLine]", 
         RowBox[{"mask", ",", 
          RowBox[{"InverseOrientationScoreTransform", "[", "ostObj", "]"}]}], 
         "]"}], ",", " ", 
        RowBox[{"ImageMultiply", "[", 
         RowBox[{"mask", ",", 
          RowBox[{"InverseOrientationScoreTransform", "[", "ostObj2", "]"}]}],
          "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"ImageMultiply", "[", 
         RowBox[{"mask", ",", 
          RowBox[{"InverseOrientationScoreTransform", "[", 
           RowBox[{"ostObj2", ",", " ", 
            RowBox[{"\"\<UseDcComponent\>\"", "\[Rule]", "False"}]}], "]"}]}],
          "]"}]}], "\n", "\t", "}"}]}]}], "}"}], ",", 
   RowBox[{"ImageSize", "\[Rule]", "Full"}]}], "\n", "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->218061733]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Properties & Relations",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(2)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->2123667759],

Cell["\<\
It is recommended that you inspect the wavelets that are used for creating \
the Orientation Scores.\
\>", "ExampleText",
 CellID->1722521652],

Cell[BoxData[{
 RowBox[{
  RowBox[{"image", " ", "=", " ", 
   RowBox[{"LieAnalysisData", "[", 
    RowBox[{"{", 
     RowBox[{"\"\<image\>\"", ",", "\"\<retina-1\>\""}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"ost", "=", " ", 
  RowBox[{"OrientationScoreTransform", "[", "image", "]"}]}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->1599618030],

Cell["The used wavelets are stored in the property \"Wavelets\":", \
"ExampleText",
 CellID->1864505823],

Cell[BoxData[
 RowBox[{"ost", "\[LeftDoubleBracket]", "\"\<Wavelets\>\"", 
  "\[RightDoubleBracket]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->821502270],

Cell["You can inspect the Fourier spectrum that is used by:", "ExampleText",
 CellID->1308175037],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ost", "[", 
     RowBox[{"[", "\"\<Wavelets\>\"", "]"}], "]"}], "[", 
    RowBox[{"[", "\"\<FourierCake\>\"", "]"}], "]"}], "//", "Total"}], "//", 
  "Image"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1071971010],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->64756599],

Cell[TextData[{
 "The output of OrientationScoreTransform is either an ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["ObjOrientationScores2D"]],
    "paclet:LieAnalysis/ref/ObjOrientationScores2D"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 " or ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["ObjScaleOrientationScores2D"]],
    "paclet:LieAnalysis/ref/ObjScaleOrientationScores2D"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 ", both contain elements and properties which can be used in further \
processing. The available elements are:"
}], "ExampleText",
 CellID->254022623],

Cell[BoxData[
 RowBox[{"Framed", "/@", 
  RowBox[{
   RowBox[{"ObjPositionOrientationData", "[", "]"}], "[", "\"\<Elements\>\"", 
   "]"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->65305442],

Cell["And the available properties are:", "ExampleText",
 CellID->19619596],

Cell[BoxData[
 RowBox[{"Framed", "/@", 
  RowBox[{
   RowBox[{"ObjPositionOrientationData", "[", "]"}], "[", 
   "\"\<Properties\>\"", "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->23384864]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Interactive Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1653164318],

Cell["Compute Orientation Scores from your web-cam:", "ExampleText",
 CellID->103985122],

Cell[BoxData[
 RowBox[{"Dynamic", "@", 
  RowBox[{"ImageAdjust", "@", 
   RowBox[{"Image", "[", 
    RowBox[{
     RowBox[{"OrientationScoreTransform", "[", 
      RowBox[{"CurrentImage", "[", "]"}], "]"}], "\[LeftDoubleBracket]", 
     "\"\<Data\>\"", "\[RightDoubleBracket]"}], "]"}]}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->198884096]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Neat Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(2)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->589267740],

Cell["Compute the Orientation Score transform from a plot:", "ExampleText",
 CellID->340393919],

Cell[BoxData[
 RowBox[{"OrientationScoreTransform", "[", 
  RowBox[{"Plot", "[", 
   RowBox[{
    RowBox[{"Evaluate", "[", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"BesselJ", "[", 
        RowBox[{"n", ",", "x"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"n", ",", "4"}], "}"}]}], "]"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "0", ",", "10"}], "}"}], ",", 
    RowBox[{"Filling", "\[Rule]", "None"}], ",", 
    RowBox[{"Axes", "\[Rule]", "None"}]}], "]"}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->60367349],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->333687921],

Cell["Analyze roads on orientations and scales:", "ExampleText",
 CellID->753769811],

Cell[BoxData[
 RowBox[{"OrientationScoreTransform", "[", 
  RowBox[{
   RowBox[{"LieAnalysisData", "[", 
    RowBox[{"{", 
     RowBox[{"\"\<image\>\"", ",", "\"\<eindhoven-map\>\""}], "}"}], "]"}], 
   ",", 
   RowBox[{"\"\<Type\>\"", "\[Rule]", "\"\<MultiScaleCake\>\""}]}], 
  "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->338339470]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "SectionFooterSpacer"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]]],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["CakeWaveletStack"]],"paclet:LieAnalysis/ref/CakeWaveletStack"},
   
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["GaborWaveletStack"]],
    "paclet:LieAnalysis/ref/GaborWaveletStack"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["InverseOrientationScoreTransform"]],
    "paclet:LieAnalysis/ref/InverseOrientationScoreTransform"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreDerivatives"]],
    "paclet:LieAnalysis/ref/OrientationScoreDerivatives"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreTransform3D"]],
    "paclet:LieAnalysis/ref/OrientationScoreTransform3D"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreTensor"]],
    "paclet:LieAnalysis/ref/OrientationScoreTensor"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]]],
 "Related Guides"
}], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell["", "SectionHeaderSpacer"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["LieAnalysis Package"]],"paclet:LieAnalysis/guide/LieAnalysis"},
  "RefLink",
  BaseStyle->"MoreAbout"]], "MoreAbout",
 CellID->1]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"OrientationScoreTransform",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "LieAnalysis Package", ButtonData -> 
         "paclet:LieAnalysis/guide/LieAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2017, 10, 26, 15, 7, 7.3662333}", 
    "history" -> {"0.2", "1.0", "", ""}, "context" -> "LieAnalysis`", 
    "keywords" -> {
     "Orientation Score", "Cake Wavelets", "Gabor Wavelets", "LieAnalysis", 
      "Multi Scale", "Image Processing", "Orientation Sensitive Wavelets"}, 
    "specialkeywords" -> {}, "tutorialcollectionlinks" -> {}, "index" -> True,
     "label" -> "Lie Analysis Symbol", "language" -> "en", "paclet" -> 
    "LieAnalysis", "status" -> "None", "summary" -> 
    "OrientationScoreTransform[data, ObjOrientationWavelet] constructs an \
Orientation Score from data using the supplied ObjOrientationWavelet \
OrientationScoreTransform[data, options] constructs an Orientation Score from \
data using wavelets constructed with the parameters supplied in options", 
    "synonyms" -> {}, "tabletags" -> {}, "title" -> 
    "OrientationScoreTransform", "titlemodifier" -> "", "windowtitle" -> 
    "OrientationScoreTransform", "type" -> "Symbol", "uri" -> 
    "LieAnalysis/ref/OrientationScoreTransform"}},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[13026, 399, 260, 10, 70, "PrimaryExamplesSection",ExpressionUUID->"e6752d14-83a6-43aa-beeb-11a7fc3bbe28",
   CellTags->"PrimaryExamplesSection",
   CellID->1]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 180899, 3685}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[597, 21, 4302, 102, 70, "AnchorBarGrid",ExpressionUUID->"05602953-803f-4d42-81e3-cf5b099fd17e",
 CellID->1],
Cell[4902, 125, 182, 6, 70, "ObjectNameGrid",ExpressionUUID->"5026d048-1c85-4ac2-9a8d-e87eab6ec2de"],
Cell[5087, 133, 994, 27, 70, "Usage",ExpressionUUID->"2a12c70f-1990-417f-bd55-dd196b0c401e",
 CellID->982511436],
Cell[CellGroupData[{
Cell[6106, 164, 621, 19, 70, "NotesSection",ExpressionUUID->"43cdae27-23b9-4eb0-93f2-07d9bfd9ccd3",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1],
Cell[6730, 185, 31, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"74673da4-f16b-40ea-8893-7ea6f36f1f93"],
Cell[6764, 187, 718, 23, 70, "Notes",ExpressionUUID->"4c692e6b-8dd4-4d31-a3ec-b512a04ba0c1",
 CellID->1067943069],
Cell[7485, 212, 75, 1, 70, "Notes",ExpressionUUID->"57f5a0da-f3a8-473c-a62f-d7a8d492a698",
 CellID->356980404],
Cell[7563, 215, 620, 13, 70, "3ColumnTableMod",ExpressionUUID->"53d95984-0fa4-4932-91b7-5fdcdf0eec69",
 CellID->142437943],
Cell[8186, 230, 78, 1, 70, "Notes",ExpressionUUID->"0d245255-c989-409e-bd79-dd1c2618821f",
 CellID->148936],
Cell[8267, 233, 645, 13, 70, "2ColumnTableMod",ExpressionUUID->"309bbfa8-381e-4eb5-8b07-fd2b441313b8",
 CellID->25275162],
Cell[8915, 248, 2080, 71, 70, "Notes",ExpressionUUID->"5fd91795-9360-4bc2-b510-1fa28243652f",
 CellID->108414689],
Cell[10998, 321, 772, 25, 70, "Notes",ExpressionUUID->"3c1aa37f-7973-4e61-9d3c-0a6cb6639dfa",
 CellID->444647279],
Cell[11773, 348, 322, 10, 70, "Notes",ExpressionUUID->"4bbbab7e-a5ad-4560-bc11-c385e84ab76e",
 CellID->82891502],
Cell[12098, 360, 319, 11, 70, "Notes",ExpressionUUID->"a3aa1be9-34f9-49d2-bce9-03b2f104b732",
 CellID->47359656],
Cell[12420, 373, 182, 4, 70, "Notes",ExpressionUUID->"130d1ece-9c93-482b-9352-16a8bd6d3779",
 CellID->164699435],
Cell[12605, 379, 141, 4, 70, "Notes",ExpressionUUID->"eb5c4b24-4b15-4961-aa8c-5fec6589b9d0",
 CellID->1336083746],
Cell[12749, 385, 206, 7, 70, "Notes",ExpressionUUID->"4609e135-d60f-426e-a67b-3644eea23a62",
 CellID->693341366],
Cell[12958, 394, 31, 0, 70, "SectionFooterSpacer",ExpressionUUID->"d16916f6-3b7f-4696-9304-e3ede855489f"]
}, Closed]],
Cell[CellGroupData[{
Cell[13026, 399, 260, 10, 70, "PrimaryExamplesSection",ExpressionUUID->"e6752d14-83a6-43aa-beeb-11a7fc3bbe28",
 CellTags->"PrimaryExamplesSection",
 CellID->1],
Cell[CellGroupData[{
Cell[13311, 413, 187, 6, 70, "ExampleSection",ExpressionUUID->"be89b41d-0486-4e15-b264-1e8588b216f0",
 CellID->1],
Cell[13501, 421, 87, 1, 70, "ExampleText",ExpressionUUID->"b6c9b780-b91c-452a-8cd5-dd3855650b03",
 CellID->101006888],
Cell[13591, 424, 361, 9, 70, "Input",ExpressionUUID->"b4c07812-46c6-4c93-8afb-8cee2388980a",
 CellID->195857478],
Cell[CellGroupData[{
Cell[13977, 437, 124, 3, 70, "ExampleDelimiter",ExpressionUUID->"db01a1e0-580f-4bf2-9486-172d5ed2056a",
 CellID->14553154],
Cell[14104, 442, 296, 9, 70, "ExampleText",ExpressionUUID->"53011961-6325-4b4e-a798-4f2b8a4f7175",
 CellID->191669434],
Cell[14403, 453, 514, 14, 70, "Input",ExpressionUUID->"7f6ebdf8-4e82-42b0-9802-0bc8263c566f",
 CellID->219987100]
}, Open  ]],
Cell[CellGroupData[{
Cell[14954, 472, 125, 3, 70, "ExampleDelimiter",ExpressionUUID->"806afec2-22d7-4f9e-8180-2bb3f50f216b",
 CellID->426355476],
Cell[15082, 477, 314, 9, 70, "ExampleText",ExpressionUUID->"9858bbb9-176c-4202-a15d-54e2e63a1ed8",
 CellID->102848757],
Cell[15399, 488, 561, 16, 70, "Input",ExpressionUUID->"5babe382-339c-426a-bd5e-6405c9646be3",
 CellID->670791194]
}, Open  ]],
Cell[CellGroupData[{
Cell[15997, 509, 125, 3, 70, "ExampleDelimiter",ExpressionUUID->"d5da7743-b483-4a6b-a61c-30045aa49f52",
 CellID->330736115],
Cell[16125, 514, 343, 10, 70, "ExampleText",ExpressionUUID->"3753005f-d67d-41d6-bc7d-9adb3d68a437",
 CellID->400588844],
Cell[16471, 526, 416, 11, 70, "Input",ExpressionUUID->"e46342b1-f563-4089-8239-9f711cbff2c5",
 CellID->134955728]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[16936, 543, 187, 6, 70, "ExampleSection",ExpressionUUID->"51ecc1f9-ba11-4782-a6d3-a5e33c8c2040",
 CellID->1293636265],
Cell[17126, 551, 471, 12, 70, "ExampleText",ExpressionUUID->"9abee7c0-791e-48e0-ad8b-d7ae2cd1842d",
 CellID->398623276],
Cell[17600, 565, 442, 11, 70, "Input",ExpressionUUID->"e400f16f-e0d8-4a0b-8c6b-131e43dd8419",
 CellID->356571065],
Cell[CellGroupData[{
Cell[18067, 580, 125, 3, 70, "ExampleDelimiter",ExpressionUUID->"dc0ebed9-f145-46cc-8c88-83e5c48623e7",
 CellID->287574405],
Cell[18195, 585, 145, 5, 70, "ExampleText",ExpressionUUID->"ae80e9d9-2e2d-4b52-9dcc-99dec4ec12ba",
 CellID->53070424],
Cell[18343, 592, 581, 16, 70, "Input",ExpressionUUID->"e136c594-0f59-42f8-91c0-d7558d9c8f86",
 CellID->15117535]
}, Open  ]],
Cell[CellGroupData[{
Cell[18961, 613, 124, 3, 70, "ExampleDelimiter",ExpressionUUID->"f70f5972-b51e-42f5-a707-0d14e900e37b",
 CellID->27374621],
Cell[19088, 618, 484, 12, 70, "ExampleText",ExpressionUUID->"fb2aa1b3-61d4-4b2e-8b4a-c97991daf65f",
 CellID->279156392],
Cell[19575, 632, 683, 19, 70, "Input",ExpressionUUID->"a767734f-451b-427d-b015-832f149b7801",
 CellID->217215471]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[20307, 657, 210, 6, 70, "ExampleSection",ExpressionUUID->"01ed9ea1-95e8-4a4d-a13d-dc45f6ecf894",
 CellID->1020263627],
Cell[20520, 665, 186, 4, 70, "ExampleText",ExpressionUUID->"1f1b81b8-c57b-4b10-99a7-9a8d6aa60ab0",
 CellID->213524762],
Cell[20709, 671, 697, 21, 70, "Input",ExpressionUUID->"191e8b48-6bbe-4906-b1ef-3918d0144c7b",
 CellID->869382195],
Cell[21409, 694, 149, 4, 70, "ExampleText",ExpressionUUID->"b285404d-810b-4001-8169-086977a869ea",
 CellID->20550242],
Cell[21561, 700, 303, 10, 70, "Input",ExpressionUUID->"0995117e-b76b-4ef4-af30-d8285cba20a4",
 CellID->6507531],
Cell[21867, 712, 191, 4, 70, "ExampleText",ExpressionUUID->"dea071b6-a1a4-46f4-9203-7cc4b2170784",
 CellID->221584252],
Cell[CellGroupData[{
Cell[22083, 720, 125, 3, 70, "ExampleDelimiter",ExpressionUUID->"570cae9a-1b4b-41e9-af88-1d35d05db53b",
 CellID->124325148],
Cell[22211, 725, 363, 11, 70, "ExampleText",ExpressionUUID->"2f2d438b-8610-444d-b84f-3097385927a9",
 CellID->820748767],
Cell[22577, 738, 322, 10, 70, "Input",ExpressionUUID->"776c3637-30f8-485c-b7ca-4f8cd46d42c4",
 CellID->1236462],
Cell[22902, 750, 624, 18, 70, "ExampleText",ExpressionUUID->"3acb5126-069a-4741-a075-bb13401666a5",
 CellID->215533415]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[23575, 774, 189, 6, 70, "ExampleSection",ExpressionUUID->"9fe51382-c020-4f39-b7a5-0c80b3e0dd46",
 CellID->2061341341],
Cell[CellGroupData[{
Cell[23789, 784, 200, 6, 70, "ExampleSubsection",ExpressionUUID->"7d5bcb83-92d4-44b9-9562-dcc8f817fea0",
 CellID->1757724783],
Cell[23992, 792, 130, 4, 70, "ExampleText",ExpressionUUID->"d6d22d48-ab7d-4492-b332-ebb0d77e2533",
 CellID->401848163],
Cell[24125, 798, 464, 14, 70, "Input",ExpressionUUID->"5abf0e4b-7b16-48e4-9a45-77f7d20b7b22",
 CellID->306930788]
}, Closed]],
Cell[CellGroupData[{
Cell[24626, 817, 199, 6, 70, "ExampleSubsection",ExpressionUUID->"2b63b49d-8c08-41e7-8832-aa17e14c4484",
 CellID->1295379749],
Cell[24828, 825, 174, 4, 70, "ExampleText",ExpressionUUID->"38c94b25-2af4-40bf-a0a9-184ab9868ef9",
 CellID->165609880],
Cell[25005, 831, 568, 17, 70, "Input",ExpressionUUID->"08f97eac-d543-481e-9d5e-ff1d218885a4",
 CellID->13033581],
Cell[CellGroupData[{
Cell[25598, 852, 125, 3, 70, "ExampleDelimiter",ExpressionUUID->"ab509d37-f60d-479e-bc28-c03796322386",
 CellID->810334137],
Cell[25726, 857, 103, 2, 70, "ExampleText",ExpressionUUID->"fc60ffbc-a5f5-4b32-91f8-d2aeca5d0186",
 CellID->187743862],
Cell[25832, 861, 746, 22, 70, "Input",ExpressionUUID->"0c75b87a-f330-4c34-a3f4-71598ace033d",
 CellID->143795367],
Cell[26581, 885, 1348, 36, 70, "Input",ExpressionUUID->"43e811d6-f6fb-4d88-b41f-275e0de4cada",
 CellID->10633767]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[27978, 927, 190, 6, 70, "ExampleSubsection",ExpressionUUID->"7447aca8-1476-48bd-b57b-0165f1264d57",
 CellID->30421503],
Cell[28171, 935, 114, 3, 70, "ExampleText",ExpressionUUID->"f1655183-2bb6-43da-bbbd-a2e93e52a13d",
 CellID->30340898],
Cell[28288, 940, 766, 21, 70, "Input",ExpressionUUID->"98299391-c719-43c5-9e21-53b8195b1668",
 CellID->63704636],
Cell[29057, 963, 69, 2, 70, "Input",ExpressionUUID->"7cdccb7f-d3aa-4845-bc9b-a4e10dea305a",
 CellID->456127706]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[29175, 971, 193, 6, 70, "ExampleSection",ExpressionUUID->"ab7ceea1-36ee-45d5-9a92-9c089afeccbe",
 CellID->258228157],
Cell[29371, 979, 102, 2, 70, "ExampleText",ExpressionUUID->"ba38b198-d10d-4b54-8d52-c3d386cb666c",
 CellID->328876646],
Cell[29476, 983, 138771, 2284, 70, "Input",ExpressionUUID->"4b402d72-3bfa-45e3-bd59-8187789fd990",
 CellID->1991243039],
Cell[168250, 3269, 1133, 37, 70, "Input",ExpressionUUID->"1e2901f3-ce9f-4a3f-9bf1-494c531debc7",
 CellID->1380700992],
Cell[169386, 3308, 399, 13, 70, "Input",ExpressionUUID->"64c70a86-617c-40ad-8cbd-3df5bf68f8e1",
 CellID->1965295417],
Cell[169788, 3323, 1306, 30, 70, "Input",ExpressionUUID->"ec0b12b2-fea7-4267-a7ce-8f92b88d1381",
 CellID->218061733]
}, Closed]],
Cell[CellGroupData[{
Cell[171131, 3358, 204, 6, 70, "ExampleSection",ExpressionUUID->"03d9cf0f-24b0-4a09-9a00-c8352f80013b",
 CellID->2123667759],
Cell[171338, 3366, 152, 4, 70, "ExampleText",ExpressionUUID->"486c6baf-9770-48b3-a0ad-7c1428338389",
 CellID->1722521652],
Cell[171493, 3372, 364, 10, 70, "Input",ExpressionUUID->"28ea07f6-5682-4d32-9a7d-5e89316f3802",
 CellID->1599618030],
Cell[171860, 3384, 104, 2, 70, "ExampleText",ExpressionUUID->"63facbe3-9ed5-4a6f-be34-042d2d020f84",
 CellID->1864505823],
Cell[171967, 3388, 156, 4, 70, "Input",ExpressionUUID->"e990c80b-df9b-4718-8837-e713ae7600c1",
 CellID->821502270],
Cell[172126, 3394, 97, 1, 70, "ExampleText",ExpressionUUID->"28b94c9a-8d1c-4ac2-a72f-43548ee93c96",
 CellID->1308175037],
Cell[172226, 3397, 274, 9, 70, "Input",ExpressionUUID->"f7853883-d9c4-470f-bdb0-4bc30789e3f0",
 CellID->1071971010],
Cell[CellGroupData[{
Cell[172525, 3410, 124, 3, 70, "ExampleDelimiter",ExpressionUUID->"a8ff269d-be4f-4b22-a25a-05088725772a",
 CellID->64756599],
Cell[172652, 3415, 642, 18, 70, "ExampleText",ExpressionUUID->"f031d3fd-7f1a-415c-9d83-f5dc4458c87e",
 CellID->254022623],
Cell[173297, 3435, 193, 6, 70, "Input",ExpressionUUID->"640c2bed-e5c8-4b45-8290-63217b75c7aa",
 CellID->65305442],
Cell[173493, 3443, 75, 1, 70, "ExampleText",ExpressionUUID->"3b6ca7ed-817b-4795-8d15-4ab3ef90939e",
 CellID->19619596],
Cell[173571, 3446, 195, 6, 70, "Input",ExpressionUUID->"8e0c56e7-e712-4e16-b432-8dd92763da85",
 CellID->23384864]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[173815, 3458, 202, 6, 70, "ExampleSection",ExpressionUUID->"493d3e21-afea-462b-8c00-5c64d035d71b",
 CellID->1653164318],
Cell[174020, 3466, 88, 1, 70, "ExampleText",ExpressionUUID->"dc5f272d-784c-4177-a9dc-5b252e759049",
 CellID->103985122],
Cell[174111, 3469, 343, 9, 70, "Input",ExpressionUUID->"0c00cb14-997d-4ac1-be35-75ead3a7cbd2",
 CellID->198884096]
}, Closed]],
Cell[CellGroupData[{
Cell[174491, 3483, 194, 6, 70, "ExampleSection",ExpressionUUID->"c63601fc-b94b-462f-8d99-979edab90c7b",
 CellID->589267740],
Cell[174688, 3491, 95, 1, 70, "ExampleText",ExpressionUUID->"24e552a4-39d0-4771-97b4-5b8d29e5b5a0",
 CellID->340393919],
Cell[174786, 3494, 558, 16, 70, "Input",ExpressionUUID->"69d3bb36-e6df-4206-bae4-f32c7b7b458d",
 CellID->60367349],
Cell[CellGroupData[{
Cell[175369, 3514, 125, 3, 70, "ExampleDelimiter",ExpressionUUID->"c9c2bb72-e360-43b3-bd26-e6e88d495eae",
 CellID->333687921],
Cell[175497, 3519, 84, 1, 70, "ExampleText",ExpressionUUID->"5e533aca-f242-4199-af4d-4f8c27abf673",
 CellID->753769811],
Cell[175584, 3522, 339, 10, 70, "Input",ExpressionUUID->"6dfb22b9-dd1c-485e-9717-e5c50efd57ac",
 CellID->338339470]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[175984, 3539, 31, 0, 70, "SectionFooterSpacer",ExpressionUUID->"fec82e4f-f8b2-44f8-a2be-d1e1334c2936"],
Cell[176018, 3541, 150, 7, 70, "SeeAlsoSection",ExpressionUUID->"347ae748-e3d3-4473-9e9e-d993dc6d1948",
 CellID->1255426704],
Cell[176171, 3550, 2005, 58, 70, "SeeAlso",ExpressionUUID->"082ece68-9f14-4254-bae8-25cfda6736c3",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[178213, 3613, 156, 7, 70, "MoreAboutSection",ExpressionUUID->"61307889-1553-40b8-8c10-2e00ef047276",
 CellID->38303248],
Cell[178372, 3622, 31, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"d4ec2d1e-0215-4d5a-b37e-b6a5c9f136de"],
Cell[178406, 3624, 177, 5, 70, "MoreAbout",ExpressionUUID->"40be8be7-9ff0-483b-957c-148b803623b7",
 CellID->1]
}, Open  ]],
Cell[178598, 3632, 23, 0, 70, "FooterCell",ExpressionUUID->"99340956-c5ce-4c63-b7a9-883976f73cab"]
}
]
*)

(* End of internal cache information *)
