(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     31388,        960]
NotebookOptionsPosition[     21827,        762]
NotebookOutlinePosition[     24339,        825]
CellTagsIndexPosition[     24254,        820]
WindowTitle->OrientationScoreTransform3D
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["LIE ANALYSIS SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"CakeWaveletStack3D\"\>":>
       Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/CakeWaveletStack3D"], \
"\<\"InverseOrientationScoreTransform3D\"\>":>Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/InverseOrientationScoreTransform3D"], \
"\<\"OrientationScoreDerivatives3D\"\>":>Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/OrientationScoreDerivatives3D"], \
"\<\"OrientationScoreTransform\"\>":>Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/OrientationScoreTransform"], \
"\<\"OrientationScoreTensor3D\"\>":>Documentation`HelpLookup[
       "paclet:LieAnalysis/ref/OrientationScoreTensor3D"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Related Guides",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"Related Guides", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"LieAnalysis Package\"\>":>
       Documentation`HelpLookup["paclet:LieAnalysis/guide/LieAnalysis"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAbout"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->
         False], {"\<\"LieAnalysis/ref/OrientationScoreTransform3D\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["LieAnalysis/ref/OrientationScoreTransform3D"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/LieAnalysis/ref/\
OrientationScoreTransform3D.html"], StandardForm]], "Input", 
              TextClipboardType -> "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$17903], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "LieAnalysis/ref/OrientationScoreTransform3D", ".html"]], 
           None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[TextData[{
 Cell["OrientationScoreTransform3D", "ObjectName"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]]],
 Cell[BoxData[""], "ObjectNameTranslation"]
}], "ObjectNameGrid"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"OrientationScoreTransform3D", "[", 
       RowBox[{
        StyleBox["data", "TI"], ",", " ", 
        StyleBox["ObjOrientationWavelet3D", "TI"]}], "]"}]], "InlineFormula"],
     
     " \[LineSeparator]Constructs an Orientation Score from ",
     StyleBox["data", "TI"],
     " using the ",
     StyleBox["ObjOrientationWavelet3D", "TI"]
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"OrientationScoreTransform3D", "[", 
       RowBox[{
        StyleBox["data", "TI"], ",", " ", 
        StyleBox["options", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]Constructs an Orientation Score from ",
     StyleBox["data", "TI"],
     " using wavelets constructed with the parameters specified in ",
     StyleBox["options", "TI"]
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    TemplateBox[{6},
     "Spacer1"]]],
   "Details"
  }], "NotesFrameText"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1],

Cell["", "SectionHeaderSpacer"],

Cell[TextData[{
 "OrientationScoreTransform3D computes the Orientation Score from a 3D volume \
as: ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["\[ScriptCapitalW]", "\[Psi]"], "[", "f", "]"}], 
   TraditionalForm]]],
 "(",
 StyleBox["x",
  FontWeight->"Bold"],
 ",",
 StyleBox["n",
  FontWeight->"Bold"],
 ") = ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["\[Integral]", 
     SuperscriptBox["\[DoubleStruckCapitalR]", "3"]], 
    RowBox[{
     OverscriptBox[
      RowBox[{
       SubscriptBox["\[Psi]", "n"], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"x", "'"}], "-", "x"}], ")"}]}], "_"], 
     RowBox[{"f", "(", 
      RowBox[{"x", "'"}], ")"}], 
     RowBox[{"dx", "'"}]}]}], TraditionalForm]]],
 ", in which ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[ScriptCapitalW]", "n"], TraditionalForm]]],
 " is an oriented wavelet."
}], "Notes",
 CellID->1067943069],

Cell["The following options can be specified:", "Notes",
 CellID->47016729],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon"], "\"\<Orientations\>\"", "12", Cell[
    "The number of Orientations", "TableText"]},
   {Cell["      ", "TableRowIcon"], "\"\<WaveletSize\>\"", "11", Cell[
    "The size of the wavelets", "TableText"]}
  }]], "3ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}},
 GridBoxDividers->{"Rows" -> {{True, True, True}}}},
 CellID->35277334],

Cell[TextData[{
 "The options from ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["CakeWaveletStack"]],"paclet:LieAnalysis/ref/CakeWaveletStack"},
   
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 " can also be used."
}], "Notes",
 CellID->298173734],

Cell[TextData[{
 "The ",
 ButtonBox["Normal",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Normal"],
 " function can be used on the output of ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreTransform3D"]],
    "paclet:LieAnalysis/ref/OrientationScoreTransform3D"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 " to create an ",
 ButtonBox["Association",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Association"],
 " from the object."
}], "Notes",
 CellID->104129402],

Cell["", "SectionFooterSpacer"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]]],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(10)", "ExampleCount"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->1],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(3)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1],

Cell["\<\
Computing an Orientation Score from a volume with the default wavelets.\
\>", "ExampleText",
 CellID->508016974],

Cell[BoxData[""], "Input",
 CellLabel->"In[1]:=",
 CellID->324556253],

Cell[BoxData[{
 RowBox[{"Needs", "[", "\"\<LieAnalysis`\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"ost", " ", "=", " ", 
  RowBox[{"OrientationScoreTransform3D", "[", 
   RowBox[{"LieAnalysisData", "[", 
    RowBox[{"{", 
     RowBox[{"\"\<image3d\>\"", ",", "\"\<random-lines-1\>\""}], "}"}], "]"}],
    "]"}]}]}], "Input",
 CellLabel->"In[2]:=",
 CellID->249669444],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->210645645],

Cell[TextData[{
 "Computing an Orientation Score from a volume using precomputed ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["CakeWaveletStack3D"]],
    "paclet:LieAnalysis/ref/CakeWaveletStack3D"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 "."
}], "ExampleText",
 CellID->403506772],

Cell[BoxData[{
 RowBox[{
  RowBox[{"wavelets", " ", "=", " ", 
   RowBox[{"CakeWaveletStack3D", "[", 
    RowBox[{"12", ",", "11"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"OrientationScoreTransform3D", "[", 
  RowBox[{
   RowBox[{"LieAnalysisData", "[", 
    RowBox[{"{", 
     RowBox[{"\"\<image3d\>\"", ",", "\"\<random-lines-2\>\""}], "}"}], "]"}],
    ",", "wavelets"}], "]"}]}], "Input",
 CellLabel->"In[1]:=",
 CellID->241241100]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->553123071],

Cell[TextData[{
 "Computing an Orientation Score from a volume using the options to specify \
the used wavelets (see the options from ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["CakeWaveletStack3D"]],
    "paclet:LieAnalysis/ref/CakeWaveletStack3D"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 ")."
}], "ExampleText",
 CellID->568766503],

Cell[BoxData[
 RowBox[{"ost3d", " ", "=", " ", 
  RowBox[{"OrientationScoreTransform3D", "[", 
   RowBox[{
    RowBox[{"LieAnalysisData", "[", 
     RowBox[{"{", 
      RowBox[{"\"\<image3d\>\"", ",", "\"\<random-lines-2\>\""}], "}"}], 
     "]"}], ",", 
    RowBox[{"\"\<DcStandardDeviation\>\"", "\[Rule]", "1"}]}], 
   "]"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->107832432],

Cell["\<\
The created wavelets can be extracted using the Wavelets part.\
\>", "ExampleText",
 CellID->640392538],

Cell[BoxData[
 RowBox[{"ost3d", "\[LeftDoubleBracket]", "\"\<Wavelets\>\"", 
  "\[RightDoubleBracket]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->400613827]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "Generalizations & Extensions",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(2)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1020263627],

Cell["\<\
The data within the ObjOrientationScores3D can be set by using Affix.\
\>", "ExampleText",
 CellID->143725879],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<LieAnalysis`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->342984904],

Cell[BoxData[
 RowBox[{"ost", " ", "=", " ", 
  RowBox[{"Affix", "[", 
   RowBox[{
    RowBox[{"OrientationScoreTransform3D", "[", 
     RowBox[{"LieAnalysisData", "[", 
      RowBox[{"{", 
       RowBox[{"\"\<image3d\>\"", ",", "\"\<random-lines-2\>\""}], "}"}], 
      "]"}], "]"}], ",", 
    RowBox[{"\"\<Data\>\"", "\[Rule]", 
     RowBox[{"CenterArray", "[", 
      RowBox[{"1", ",", 
       RowBox[{"{", 
        RowBox[{"11", ",", "11", ",", "11", ",", "6"}], "}"}]}], "]"}]}]}], 
   "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->479070467],

Cell["\<\
Or use the function AffixTo to assign the new part directly to the object.\
\>", "ExampleText",
 CellID->7965394],

Cell[BoxData[
 RowBox[{"AffixTo", "[", 
  RowBox[{"ost", ",", 
   RowBox[{"\"\<Data\>\"", "\[Rule]", 
    RowBox[{"CenterArray", "[", 
     RowBox[{"1", ",", 
      RowBox[{"{", 
       RowBox[{"11", ",", "11", ",", "11", ",", "6"}], "}"}]}], "]"}]}]}], 
  "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->17679427],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->77349941],

Cell[TextData[{
 "For experimenting it can be useful to create an Orientation Score object \
without using the ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreTransform3D"]],
    "paclet:LieAnalysis/ref/OrientationScoreTransform3D"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 "."
}], "ExampleText",
 CellID->585930063],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<LieAnalysis`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->115480882],

Cell[BoxData[
 RowBox[{"obj", " ", "=", " ", 
  RowBox[{"Obj3DPositionOrientationData", "[", 
   RowBox[{"\"\<Data\>\"", "\[Rule]", 
    RowBox[{"RandomReal", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"11", ",", "11", ",", "11", ",", "6"}], "}"}]}], "]"}]}], 
   "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->98282198],

Cell[TextData[{
 "Note that it is possible that other functions (e.g. ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreDerivatives3D"]],
    "paclet:LieAnalysis/ref/OrientationScoreDerivatives3D"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 " or ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["InverseOrientationScoreTransform3D"]],
    "paclet:LieAnalysis/ref/InverseOrientationScoreTransform3D"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 ") might not work if you have not provided all parts (or when parts are not \
coherent)."
}], "ExampleText",
 CellID->739384714]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Options",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(4)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->2061341341],

Cell[TextData[{
 "See the options from ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["CakeWaveletStack3D"]],
    "paclet:LieAnalysis/ref/CakeWaveletStack3D"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 " also."
}], "ExampleText",
 CellID->13490587],

Cell[CellGroupData[{

Cell[TextData[{
 "Orientations",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(2)", "ExampleCount"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CellID->1757724783],

Cell["\<\
Controls the number of orientations that are used to construct the \
Orientation Score. \
\>", "ExampleText",
 CellID->679926720],

Cell[BoxData[""], "Input",
 CellLabel->"In[1]:=",
 CellID->47291011],

Cell[BoxData[
 RowBox[{"OrientationScoreTransform3D", "[", 
  RowBox[{
   RowBox[{"LieAnalysisData", "[", 
    RowBox[{"{", 
     RowBox[{"\"\<image3d\>\"", ",", "\"\<circles\>\""}], "}"}], "]"}], ",", 
   RowBox[{"\"\<Orientations\>\"", "\[Rule]", "10"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->365722377],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell["\t", "ExampleDelimiter"],
  $Line = 0; Null]], "ExampleDelimiter",
 CellID->24496474],

Cell["\<\
But can also be a list of vectors containing the orientations.\
\>", "ExampleText",
 CellID->152387320],

Cell[BoxData[
 RowBox[{"OrientationScoreTransform3D", "[", 
  RowBox[{
   RowBox[{"LieAnalysisData", "[", 
    RowBox[{"{", 
     RowBox[{"\"\<image3d\>\"", ",", "\"\<circles\>\""}], "}"}], "]"}], ",", 
   RowBox[{"\"\<Orientations\>\"", "->", 
    RowBox[{"Normalize", "/@", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1.", ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1."}], ",", "0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1.", ",", "1.", ",", "1."}], "}"}]}], "}"}]}]}]}], 
  "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->353935305]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "WaveletSize",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CellID->1295379749],

Cell["\<\
Can be used to control the size of the wavelet, but does not change the shape \
of the wavelet.\
\>", "ExampleText",
 CellID->89943063],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"OrientationScoreTransform3D", "[", 
     RowBox[{
      RowBox[{"LieAnalysisData", "[", 
       RowBox[{"{", 
        RowBox[{"\"\<image3d\>\"", ",", "\"\<circles\>\""}], "}"}], "]"}], 
      ",", 
      RowBox[{"\"\<WaveletSize\>\"", "\[Rule]", "#"}]}], "]"}], 
    "\[LeftDoubleBracket]", "\"\<Wavelets\>\"", "\[RightDoubleBracket]"}], 
   "&"}], "/@", 
  RowBox[{"{", 
   RowBox[{"9", ",", "11"}], "}"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->480663797]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Neat Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->589267740],

Cell[BoxData[
 RowBox[{"ost", " ", "=", " ", 
  RowBox[{"OrientationScoreTransform3D", "[", 
   RowBox[{"ImageTake", "[", 
    RowBox[{
     RowBox[{"LieAnalysisData", "[", 
      RowBox[{"{", 
       RowBox[{"\"\<image3d\>\"", ",", "\"\<random-lines-1\>\""}], "}"}], 
      "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "30"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"15", ",", "35"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "25"}], "}"}]}], "]"}], "]"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->148776256],

Cell[BoxData[
 RowBox[{"GlyphPlot", "[", "ost", "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->499417795]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "SectionFooterSpacer"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]]],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["CakeWaveletStack3D"]],
    "paclet:LieAnalysis/ref/CakeWaveletStack3D"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["InverseOrientationScoreTransform3D"]],
    "paclet:LieAnalysis/ref/InverseOrientationScoreTransform3D"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreDerivatives3D"]],
    "paclet:LieAnalysis/ref/OrientationScoreDerivatives3D"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreTransform"]],
    "paclet:LieAnalysis/ref/OrientationScoreTransform"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OrientationScoreTensor3D"]],
    "paclet:LieAnalysis/ref/OrientationScoreTensor3D"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]]],
 "Related Guides"
}], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell["", "SectionHeaderSpacer"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["LieAnalysis Package"]],"paclet:LieAnalysis/guide/LieAnalysis"},
  "RefLink",
  BaseStyle->"MoreAbout"]], "MoreAbout",
 CellID->1]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"OrientationScoreTransform3D",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "LieAnalysis Package", ButtonData -> 
         "paclet:LieAnalysis/guide/LieAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2017, 10, 26, 15, 7, 5.6630443}", 
    "history" -> {"0.2", "", "", ""}, "context" -> "LieAnalysis`", 
    "keywords" -> {
     "Orientation Scores", "Cake Wavelets", "Gabor Wavelets", "LieAnalysis", 
      "OrientationScoreTransform"}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Lie Analysis Symbol", "language" -> "en", "paclet" -> "LieAnalysis", 
    "status" -> "None", "summary" -> 
    "OrientationScoreTransform3D[data, ObjOrientationWavelet3D] Constructs an \
Orientation Score from data using the ObjOrientationWavelet3D \
OrientationScoreTransform3D[data, options] Constructs an Orientation Score \
from data using wavelets constructed with the parameters specified in \
options", "synonyms" -> {}, "tabletags" -> {}, "title" -> 
    "OrientationScoreTransform3D", "titlemodifier" -> "", "windowtitle" -> 
    "OrientationScoreTransform3D", "type" -> "Symbol", "uri" -> 
    "LieAnalysis/ref/OrientationScoreTransform3D"}},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[9082, 279, 260, 10, 70, "PrimaryExamplesSection",ExpressionUUID->"9fb16586-c59d-40d7-93a0-f5af4f5dcd89",
   CellTags->"PrimaryExamplesSection",
   CellID->1]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 24064, 813}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[599, 21, 4225, 101, 70, "AnchorBarGrid",ExpressionUUID->"885810ac-a0c7-4efb-9716-b6450c85e8b4",
 CellID->1],
Cell[4827, 124, 184, 6, 70, "ObjectNameGrid",ExpressionUUID->"16c28477-8280-4990-9720-07a83ee12aa4"],
Cell[5014, 132, 1025, 29, 70, "Usage",ExpressionUUID->"c9f74479-4eba-41e1-8522-be5caad7efcf",
 CellID->982511436],
Cell[CellGroupData[{
Cell[6064, 165, 621, 19, 70, "NotesSection",ExpressionUUID->"d21bf3e9-681c-478a-92cb-22abdc21f474",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1],
Cell[6688, 186, 31, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"e8751472-7b37-4d51-afcb-7881f55cfe03"],
Cell[6722, 188, 908, 36, 70, "Notes",ExpressionUUID->"8b1f5552-652f-48ab-a11b-82c006f27400",
 CellID->1067943069],
Cell[7633, 226, 75, 1, 70, "Notes",ExpressionUUID->"0a4d9f4a-be1a-4abf-8188-61e4a91a841d",
 CellID->47016729],
Cell[7711, 229, 500, 11, 70, "3ColumnTableMod",ExpressionUUID->"b3ca84c7-d805-4c82-8410-c020b69a8dbc",
 CellID->35277334],
Cell[8214, 242, 278, 10, 70, "Notes",ExpressionUUID->"0085ec65-b279-4fde-ae71-e0cadf5fa480",
 CellID->298173734],
Cell[8495, 254, 516, 18, 70, "Notes",ExpressionUUID->"11d952d7-dbc7-4504-8d20-7e6be8f6ba21",
 CellID->104129402],
Cell[9014, 274, 31, 0, 70, "SectionFooterSpacer",ExpressionUUID->"33f5a5d0-0f16-416e-bfe1-8f3948da0413"]
}, Closed]],
Cell[CellGroupData[{
Cell[9082, 279, 260, 10, 70, "PrimaryExamplesSection",ExpressionUUID->"9fb16586-c59d-40d7-93a0-f5af4f5dcd89",
 CellTags->"PrimaryExamplesSection",
 CellID->1],
Cell[CellGroupData[{
Cell[9367, 293, 187, 6, 70, "ExampleSection",ExpressionUUID->"fe948798-4536-4f8d-a187-d1033176a364",
 CellID->1],
Cell[9557, 301, 122, 3, 70, "ExampleText",ExpressionUUID->"a22dcb7a-2cca-4467-9326-35dca77f86ae",
 CellID->508016974],
Cell[9682, 306, 69, 2, 70, "Input",ExpressionUUID->"b0ca7b3a-9709-4b6f-a07a-b45b927474cd",
 CellID->324556253],
Cell[9754, 310, 371, 9, 70, "Input",ExpressionUUID->"c6019ea5-0be4-4645-8eac-070ea8ab8002",
 CellID->249669444],
Cell[CellGroupData[{
Cell[10150, 323, 125, 3, 70, "ExampleDelimiter",ExpressionUUID->"0744722a-c6d2-4b47-a4c6-eff1568a28c3",
 CellID->210645645],
Cell[10278, 328, 318, 10, 70, "ExampleText",ExpressionUUID->"8d949bc6-10ec-4aa5-ae5e-747c02b50886",
 CellID->403506772],
Cell[10599, 340, 446, 12, 70, "Input",ExpressionUUID->"f96c40f9-d42e-4c56-ab4c-3d3720baea06",
 CellID->241241100]
}, Open  ]],
Cell[CellGroupData[{
Cell[11082, 357, 125, 3, 70, "ExampleDelimiter",ExpressionUUID->"eef63a05-da48-41d4-bbea-693b05bf475e",
 CellID->553123071],
Cell[11210, 362, 372, 11, 70, "ExampleText",ExpressionUUID->"12835ba7-3791-464a-a6ac-f5716460f92e",
 CellID->568766503],
Cell[11585, 375, 383, 11, 70, "Input",ExpressionUUID->"54bb765d-2825-4763-b104-fb9919d77fe3",
 CellID->107832432],
Cell[11971, 388, 113, 3, 70, "ExampleText",ExpressionUUID->"2a970503-dfd5-4ab6-91dd-de4814b553ef",
 CellID->640392538],
Cell[12087, 393, 158, 4, 70, "Input",ExpressionUUID->"7d75e7a1-b14d-4303-b09c-c60af70b064f",
 CellID->400613827]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[12294, 403, 210, 6, 70, "ExampleSection",ExpressionUUID->"5171e590-8235-4eb2-a421-5fec668a8035",
 CellID->1020263627],
Cell[12507, 411, 120, 3, 70, "ExampleText",ExpressionUUID->"3b20f693-b049-49ae-9c85-fc5f2b6dee24",
 CellID->143725879],
Cell[12630, 416, 120, 3, 70, "Input",ExpressionUUID->"b53106ea-e2ea-4670-840d-1aa3d5093e2d",
 CellID->342984904],
Cell[12753, 421, 552, 16, 70, "Input",ExpressionUUID->"d9fa2cf4-a0b3-4cc2-8024-65cd32394564",
 CellID->479070467],
Cell[13308, 439, 123, 3, 70, "ExampleText",ExpressionUUID->"cbd1d07c-e070-4fe5-9a79-6978f0613e2d",
 CellID->7965394],
Cell[13434, 444, 315, 10, 70, "Input",ExpressionUUID->"c8f5df5a-3e2b-4ff5-8269-0c45ddd82cfd",
 CellID->17679427],
Cell[CellGroupData[{
Cell[13774, 458, 124, 3, 70, "ExampleDelimiter",ExpressionUUID->"771d1cec-7ed6-4490-9f63-efc7bd5386dc",
 CellID->77349941],
Cell[13901, 463, 366, 11, 70, "ExampleText",ExpressionUUID->"e42fe9df-1c73-4b48-b29c-0f397f27550c",
 CellID->585930063],
Cell[14270, 476, 120, 3, 70, "Input",ExpressionUUID->"a0a8127a-f2dd-488f-b85e-b89a2cf48f3e",
 CellID->115480882],
Cell[14393, 481, 401, 12, 70, "Input",ExpressionUUID->"db0605b0-13e0-408d-bef9-45f600bb0d52",
 CellID->98282198],
Cell[14797, 495, 647, 18, 70, "ExampleText",ExpressionUUID->"74bbbf79-6b13-488a-bbea-3261cc5a47fd",
 CellID->739384714]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[15493, 519, 189, 6, 70, "ExampleSection",ExpressionUUID->"79c178bf-cc57-4e87-9dfc-bf1e6286f100",
 CellID->2061341341],
Cell[15685, 527, 280, 10, 70, "ExampleText",ExpressionUUID->"fa788266-10b9-4862-88cd-89b6e431f37a",
 CellID->13490587],
Cell[CellGroupData[{
Cell[15990, 541, 200, 6, 70, "ExampleSubsection",ExpressionUUID->"60180176-261c-411d-829a-727c86c59148",
 CellID->1757724783],
Cell[16193, 549, 139, 4, 70, "ExampleText",ExpressionUUID->"52b55b8f-d734-408c-8ec0-25123f29aae9",
 CellID->679926720],
Cell[16335, 555, 68, 2, 70, "Input",ExpressionUUID->"4ce4a08e-7fbe-40bd-8e02-3b0e8101176d",
 CellID->47291011],
Cell[16406, 559, 318, 8, 70, "Input",ExpressionUUID->"353a7942-a981-474f-b960-71858016d321",
 CellID->365722377],
Cell[CellGroupData[{
Cell[16749, 571, 124, 3, 70, "ExampleDelimiter",ExpressionUUID->"50d881d1-1bd0-4e78-a6c5-b63fb7f9c622",
 CellID->24496474],
Cell[16876, 576, 113, 3, 70, "ExampleText",ExpressionUUID->"f9ea6daa-81bb-4ff9-a707-ba47f992aaf2",
 CellID->152387320],
Cell[16992, 581, 643, 19, 70, "Input",ExpressionUUID->"a2496669-f713-4ad8-b210-85158e7f8b35",
 CellID->353935305]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[17684, 606, 199, 6, 70, "ExampleSubsection",ExpressionUUID->"c50ccd28-7a53-4d99-99f1-dc2316dae13d",
 CellID->1295379749],
Cell[17886, 614, 145, 4, 70, "ExampleText",ExpressionUUID->"dcba3920-eee0-4a41-b728-bf6ee298e3e4",
 CellID->89943063],
Cell[18034, 620, 522, 16, 70, "Input",ExpressionUUID->"6c4c6193-ca88-4c0a-bc72-266af1c4869e",
 CellID->480663797]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[18605, 642, 194, 6, 70, "ExampleSection",ExpressionUUID->"a673429f-7183-40c3-8faa-c083376ff72e",
 CellID->589267740],
Cell[18802, 650, 545, 16, 70, "Input",ExpressionUUID->"072288f5-dd7d-427f-97c5-6baaffb7a348",
 CellID->148776256],
Cell[19350, 668, 107, 3, 70, "Input",ExpressionUUID->"b6d68994-2c90-4ad0-8d74-5fffab727ae0",
 CellID->499417795]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[19506, 677, 31, 0, 70, "SectionFooterSpacer",ExpressionUUID->"3ae23a81-96c7-4d50-acc3-486100b0382a"],
Cell[19540, 679, 150, 7, 70, "SeeAlsoSection",ExpressionUUID->"c966920f-b742-4c13-8d90-2a646cb794c7",
 CellID->1255426704],
Cell[19693, 688, 1685, 48, 70, "SeeAlso",ExpressionUUID->"3b31f0b8-078a-4eb5-ad24-e8a52a42cf0f",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[21415, 741, 156, 7, 70, "MoreAboutSection",ExpressionUUID->"9601f97c-b7f1-4303-b9aa-e17d2a061867",
 CellID->38303248],
Cell[21574, 750, 31, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"00b46ef6-0253-4ec9-863f-c19385eac678"],
Cell[21608, 752, 177, 5, 70, "MoreAbout",ExpressionUUID->"66db69be-199b-4ff7-8252-3b6f9ccba5da",
 CellID->1]
}, Open  ]],
Cell[21800, 760, 23, 0, 70, "FooterCell",ExpressionUUID->"c5c80bd4-4e76-4b17-853b-be6c72f032c9"]
}
]
*)

(* End of internal cache information *)
