(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 10.4' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     16943,        467]
NotebookOptionsPosition[     12016,        363]
NotebookOutlinePosition[     15642,        440]
CellTagsIndexPosition[     15599,        437]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Literature", "Subchapter",
 CellChangeTimes->{{3.6751559543967915`*^9, 
  3.675155958947902*^9}},ExpressionUUID->"82ce9b8d-b67c-4d11-b354-\
bb718ca7bf2f"],

Cell[TextData[{
 StyleBox["[1]\tTitle: ",
  FontWeight->"Bold",
  FontSlant->"Plain"],
 StyleBox["A New Retinal Vessel Tracking Method Based on Orientation Scores",
  FontSlant->"Plain"],
 StyleBox["\n\tAuthors: ",
  FontWeight->"Bold",
  FontSlant->"Plain"],
 StyleBox["E.J. Bekkers, R. Duits, B.M. ter Haar Romeny and T. Berendschot\n  \
\t ",
  FontSlant->"Plain"],
 StyleBox["Short Description: ",
  FontWeight->"Bold",
  FontSlant->"Plain"],
 StyleBox[" Multi-orientation analysis on retinal images using the Euclidean \
motion group SE(2).\n\t ",
  FontSlant->"Plain"],
 StyleBox["Related Functions:",
  FontWeight->"Bold",
  FontSlant->"Plain"],
 StyleBox[" OrientationScoreTransform2D, CakeWaveletStack ",
  FontSlant->"Plain"]
}], "Text",
 CellChangeTimes->{{3.6751559620840473`*^9, 3.675156023722192*^9}, {
  3.6751560702572117`*^9, 3.675156077857457*^9}, {3.675156114640844*^9, 
  3.6751561280160756`*^9}, {3.6751561897666936`*^9, 3.6751562638215265`*^9}, {
  3.6751562988867283`*^9, 3.6751565146647787`*^9}, {3.6751575637658453`*^9, 
  3.6751575797730722`*^9}, {3.675159912006327*^9, 
  3.6751599157509003`*^9}},ExpressionUUID->"aa307448-2ee6-43fd-a619-\
48aadf19d4c3"],

Cell[TextData[{
 StyleBox["[2]\tTitle: ",
  FontWeight->"Bold",
  FontSlant->"Plain"],
 StyleBox["Image Analysis and Reconstruction using a Wavelet Transform \
Constructed from a Reducible Representation of the Euclidean Motion Group",
  FontSlant->"Plain"],
 StyleBox["\n\tAuthors: ",
  FontWeight->"Bold",
  FontSlant->"Plain"],
 StyleBox["R. Duits, M. Felsberg, G. GranLund and B.M. ter Haar Romeny\n  \t ",
  FontSlant->"Plain"],
 StyleBox["Short Description: ",
  FontWeight->"Bold",
  FontSlant->"Plain"],
 StyleBox[" Construction and reconstruction of the Euclidean motion groups \
SE(2) and SE(3).\n\t ",
  FontSlant->"Plain"],
 StyleBox["Related Functions:",
  FontWeight->"Bold",
  FontSlant->"Plain"],
 StyleBox[" OrientationScoreTransform2D, OrientationScoreTransform3D, \
CakeWaveletStack2D, CakeWaveletStack3D",
  FontSlant->"Plain"]
}], "Text",
 CellChangeTimes->{{3.6751565850418015`*^9, 3.675156618903389*^9}, {
  3.6751574891018353`*^9, 3.6751575589254875`*^9}, {3.6751576399409065`*^9, 
  3.6751576887398987`*^9}, {3.675157793841934*^9, 3.675157866759858*^9}, {
  3.675159904102868*^9, 
  3.675159907198992*^9}},ExpressionUUID->"1a6e28fd-3de4-4df0-9d16-\
4e06a5853ffc"],

Cell[TextData[{
 StyleBox["[3]\tTitle: ",
  FontWeight->"Bold",
  FontSlant->"Plain"],
 StyleBox["Invertible Orientation Scores of 3D Images",
  FontSlant->"Plain"],
 StyleBox["\n\tAuthors: ",
  FontWeight->"Bold",
  FontSlant->"Plain"],
 StyleBox["M.H.J. Janssen, R. Duits and M. Breeuwer\n  \t ",
  FontSlant->"Plain"],
 StyleBox["Short Description: ",
  FontWeight->"Bold",
  FontSlant->"Plain"],
 StyleBox[" Construction and reconstruction of the Euclidean motion group \
SE(3). Containing some practical examples.\n\t ",
  FontSlant->"Plain"],
 StyleBox["Related Functions:",
  FontWeight->"Bold",
  FontSlant->"Plain"],
 StyleBox[" OrientationScoreTransform3D, CakeWaveletStack3D",
  FontSlant->"Plain"]
}], "Text",
 CellChangeTimes->{{3.675156624975619*^9, 3.675156629992113*^9}, {
  3.6751578927863197`*^9, 3.6751579038297305`*^9}, {3.67515794558781*^9, 
  3.6751580231297913`*^9}, {3.6751597890481987`*^9, 3.6751597980814466`*^9}, {
  3.6751599006554966`*^9, 
  3.6751599010467453`*^9}},ExpressionUUID->"2b5aa30d-bf3d-4fbe-833d-\
a116af279fb1"],

Cell[TextData[{
 StyleBox["[4]\tTitle: ",
  FontWeight->"Bold",
  FontSlant->"Plain"],
 StyleBox["Invertible Orientation Scores as an Application of Generalized \
Wavelet Theory",
  FontSlant->"Plain"],
 StyleBox["\n\tAuthors: ",
  FontWeight->"Bold",
  FontSlant->"Plain"],
 StyleBox["R. Duits, M. Duits, M. van Almsick, B.M. ter Haar Romeny\n  \t ",
  FontSlant->"Plain"],
 StyleBox["Short Description: ",
  FontWeight->"Bold",
  FontSlant->"Plain"],
 StyleBox["Construction and reconstruction of the Euclidean motion group \
SE(2). \n\t ",
  FontSlant->"Plain"],
 StyleBox["Related Functions:",
  FontWeight->"Bold",
  FontSlant->"Plain"],
 StyleBox[" CakeWaveletStack, OrientationScoreTransform2D",
  FontSlant->"Plain"]
}], "Text",
 CellChangeTimes->{{3.675158035905344*^9, 3.6751580514657865`*^9}, {
  3.6751583034286127`*^9, 3.6751583607908354`*^9}, {3.6751595107723265`*^9, 
  3.6751595737241817`*^9}},ExpressionUUID->"48ee3742-9268-4cfc-8415-\
eb99deb4880c"],

Cell[TextData[{
 StyleBox["[5]\tTitle: ",
  FontWeight->"Bold",
  FontSlant->"Plain"],
 StyleBox["Left-invariant Evolutions of Wavelet Transforms on the Similitude \
Group",
  FontSlant->"Plain"],
 StyleBox["\n\tAuthors: ",
  FontWeight->"Bold",
  FontSlant->"Plain"],
 StyleBox["U. Sharma, R. Duits\n  \t ",
  FontSlant->"Plain"],
 StyleBox["Short Description: ",
  FontWeight->"Bold",
  FontSlant->"Plain"],
 StyleBox[" Construction and reconstruction of the similtude group SIM(2), \
also containing scale.\n\t ",
  FontSlant->"Plain"],
 StyleBox["Related Functions:",
  FontWeight->"Bold",
  FontSlant->"Plain"],
 StyleBox[" to be implemented in future releases",
  FontSlant->"Plain"]
}], "Text",
 CellChangeTimes->{{3.67515805788811*^9, 3.675158062879444*^9}, {
  3.675159746234359*^9, 3.6751597642889214`*^9}, {3.6751598927590294`*^9, 
  3.675159896230421*^9}, {3.6751599746455555`*^9, 3.6751599771172476`*^9}, {
  3.675160030755266*^9, 
  3.675160112210499*^9}},ExpressionUUID->"4005f6a9-622e-4c80-86ba-\
91c9a78b3b48"],

Cell[TextData[{
 StyleBox["[6]\tTitle: ",
  FontWeight->"Bold",
  FontSlant->"Plain"],
 StyleBox["T.B.A (PhD thesis, 2016)",
  FontSlant->"Plain"],
 StyleBox["\n\tAuthors: ",
  FontWeight->"Bold",
  FontSlant->"Plain"],
 StyleBox["E.J. Bekkers\n  \t ",
  FontSlant->"Plain"],
 StyleBox["Short Description: ",
  FontWeight->"Bold",
  FontSlant->"Plain"],
 StyleBox["PhD Thesis, Orientation Scores SE(2), Lie Group Theory and \
applications of the SE(2) on retinal images.\n\t ",
  FontSlant->"Plain"],
 StyleBox["Related Functions:",
  FontWeight->"Bold",
  FontSlant->"Plain"],
 StyleBox[" GaborWaveletStack2D, CakeWaveletStack2D, \
OrientationScoreTransform2D",
  FontSlant->"Plain"]
}], "Text",
 CellChangeTimes->{
  3.675159652587118*^9, {3.675160169328928*^9, 3.6751603277582607`*^9}, {
   3.6751621853710866`*^9, 
   3.6751621913562493`*^9}},ExpressionUUID->"5452aee8-20db-4eb5-afab-\
b0d751f849dd"],

Cell[TextData[{
 StyleBox["[7]\tTitle: ",
  FontWeight->"Bold",
  FontSlant->"Plain"],
 StyleBox["Enhancement of Crossing Elongated Structures in Images",
  FontSlant->"Plain"],
 StyleBox["\n\tAuthors: ",
  FontWeight->"Bold",
  FontSlant->"Plain"],
 StyleBox["E.M. Franken\n  \t ",
  FontSlant->"Plain"],
 StyleBox["Short Description: ",
  FontWeight->"Bold",
  FontSlant->"Plain"],
 StyleBox["PhD Thesis, Construction and reconstruction of SE(2). \n\t ",
  FontSlant->"Plain"],
 StyleBox["Related Functions:",
  FontWeight->"Bold",
  FontSlant->"Plain"],
 StyleBox[" GaborWaveletStack2D, CakeWaveletStack2D, \
OrientationScoreTransform2D",
  FontSlant->"Plain"]
}], "Text",
 CellChangeTimes->{{3.675160334141657*^9, 3.675160337029662*^9}, {
  3.6751614527898645`*^9, 3.6751614834932528`*^9}, {3.675161623418707*^9, 
  3.6751616434266453`*^9}, {3.675161677514407*^9, 3.6751616799781055`*^9}, {
  3.67516180993655*^9, 
  3.675161855000965*^9}},ExpressionUUID->"0c6cb691-77ae-45b8-9f8b-\
c7d0ecbefc00"],

Cell[TextData[{
 StyleBox["[8]\tTitle: ",
  FontWeight->"Bold",
  FontSlant->"Plain"],
 StyleBox["Left-Invariant Parabolic Evolutions on SE(2) and Contour \
Enhancement via Invertible Orientation Scores, Part I",
  FontSlant->"Plain"],
 StyleBox["\n\tAuthors: ",
  FontWeight->"Bold",
  FontSlant->"Plain"],
 StyleBox["R. Duits and E.M. Franken\n  \t ",
  FontSlant->"Plain"],
 StyleBox["Short Description: ",
  FontWeight->"Bold",
  FontSlant->"Plain"],
 StyleBox["Invertible orientation score theory and connection to SE(2) \
Fourier transform.\n\t ",
  FontSlant->"Plain"],
 StyleBox["Related Functions:",
  FontWeight->"Bold",
  FontSlant->"Plain"],
 StyleBox[" OrientationScoreTransform2D, CakeWaveletStack",
  FontSlant->"Plain"]
}], "Text",
 CellChangeTimes->{{3.6751618699363594`*^9, 3.675161885423134*^9}, {
  3.6751619305855927`*^9, 
  3.6751620651083736`*^9}},ExpressionUUID->"abcac081-a000-4d82-bc67-\
18632f622af0"],

Cell[TextData[{
 StyleBox["[9]\tTitle: ",
  FontWeight->"Bold",
  FontSlant->"Plain"],
 StyleBox["Context Models of Lines and Contours",
  FontSlant->"Plain"],
 StyleBox["\n\tAuthors: ",
  FontWeight->"Bold",
  FontSlant->"Plain"],
 StyleBox["M. van Almsick\n  \t ",
  FontSlant->"Plain"],
 StyleBox["Short Description: ",
  FontWeight->"Bold",
  FontSlant->"Plain"],
 StyleBox["Wavelets in harmonic oscillator basis.",
  FontSlant->"Plain"]
}], "Text",
 CellChangeTimes->{{3.6751620955084763`*^9, 3.6751621312043424`*^9}, {
  3.6751622590544043`*^9, 3.6751622719704027`*^9}, {3.6751623759288282`*^9, 
  3.675162390577016*^9}},ExpressionUUID->"a259903f-67f6-4da0-b105-\
138c0d092ef0"],

Cell[TextData[{
 StyleBox["[10]\tTitle: ",
  FontWeight->"Bold",
  FontSlant->"Plain"],
 StyleBox["Perceptual Organization in Image Analysis",
  FontSlant->"Plain"],
 StyleBox["\n\tAuthors: ",
  FontWeight->"Bold",
  FontSlant->"Plain"],
 StyleBox["R. Duits\n  \t ",
  FontSlant->"Plain"],
 StyleBox["Short Description: ",
  FontWeight->"Bold",
  FontSlant->"Plain"],
 StyleBox["Invertible orientation score theory.",
  FontSlant->"Plain"]
}], "Text",
 CellChangeTimes->{{3.6751620974228096`*^9, 3.6751621052122345`*^9}, {
  3.675162137851985*^9, 3.6751621454272857`*^9}, {3.6751625132744837`*^9, 
  3.675162539238584*^9}},ExpressionUUID->"acae7e66-1b6a-4b83-aee0-\
af827e67b481"],

Cell[TextData[{
 StyleBox["[11]\tTitle: ",
  FontWeight->"Bold",
  FontSlant->"Plain"],
 StyleBox["temp",
  FontSlant->"Plain"],
 StyleBox["\n\tAuthors: ",
  FontWeight->"Bold",
  FontSlant->"Plain"],
 StyleBox["temp\n  \t ",
  FontSlant->"Plain"],
 StyleBox["Short Description: ",
  FontWeight->"Bold",
  FontSlant->"Plain"],
 StyleBox["temp\n\t ",
  FontSlant->"Plain"],
 StyleBox["Related Functions:",
  FontWeight->"Bold",
  FontSlant->"Plain"],
 StyleBox[" temp",
  FontSlant->"Plain"]
}], "Text",
 CellChangeTimes->{{3.6751620998765326`*^9, 3.675162108261388*^9}, {
  3.6751621501335564`*^9, 
  3.6751621580190773`*^9}},ExpressionUUID->"cf836d7b-31ad-4443-9142-\
80e693cade9e"],

Cell[TextData[StyleBox["[11]\tKalitzin wavelets in harmonic oscillator basis.",
 FontWeight->"Bold",
 FontSlant->"Plain"]], "Text",
 CellChangeTimes->{
  3.6751563023651285`*^9, {3.6751564757376623`*^9, 3.6751564786747103`*^9}, 
   3.675158027296629*^9, 3.675160324917288*^9, 3.675161872400062*^9, {
   3.675162087917214*^9, 3.675162088620679*^9}, {3.6751623997043867`*^9, 
   3.675162402599449*^9}, {3.6751625696867857`*^9, 3.6751625709016237`*^9}, 
   3.675162612884886*^9, {3.6751628237897844`*^9, 
   3.675162826146444*^9}},ExpressionUUID->"16f921c6-c73f-4b2f-b6b8-\
162977a27ec2"],

Cell[TextData[StyleBox["(NB.  In preparation: fully analytic description cake \
wavelets in generalizedc Zernike basis based on inverse Fourier transform \
rather than inverse DFT)  ",
 FontWeight->"Bold",
 FontSlant->"Plain"]], "Text",
 CellChangeTimes->{
  3.6751628285161047`*^9},ExpressionUUID->"0ba00bc7-0aad-4e4a-8b3f-\
6c9e41a44b00"]
}, Open  ]]
},
WindowSize->{944, 1101},
WindowMargins->{{Automatic, -1920}, {Automatic, 0}},
InputAliases->{"intt" -> RowBox[{"\[Integral]", 
     RowBox[{"\[SelectionPlaceholder]", 
       RowBox[{"\[DifferentialD]", "\[Placeholder]"}]}]}], "dintt" -> RowBox[{
     SubsuperscriptBox[
     "\[Integral]", "\[SelectionPlaceholder]", "\[Placeholder]"], 
     RowBox[{"\[Placeholder]", 
       RowBox[{"\[DifferentialD]", "\[Placeholder]"}]}]}], "sumt" -> RowBox[{
     UnderoverscriptBox["\[Sum]", 
      RowBox[{"\[SelectionPlaceholder]", "=", "\[Placeholder]"}], 
      "\[Placeholder]"], "\[Placeholder]"}], "prodt" -> RowBox[{
     UnderoverscriptBox["\[Product]", 
      RowBox[{"\[SelectionPlaceholder]", "=", "\[Placeholder]"}], 
      "\[Placeholder]"], "\[Placeholder]"}], "dt" -> RowBox[{
     SubscriptBox["\[PartialD]", "\[Placeholder]"], " ", 
     "\[SelectionPlaceholder]"}], "ia" -> 
  TemplateBox[{"\[SelectionPlaceholder]"}, "Inactive"], "cbrt" -> 
  RadicalBox[
   "\[SelectionPlaceholder]", "3", SurdForm -> True, MultilineFunction -> 
    None], "surd" -> 
  RadicalBox[
   "\[SelectionPlaceholder]", "\[Placeholder]", SurdForm -> True, 
    MultilineFunction -> None], "ket" -> 
  TemplateBox[{"\[SelectionPlaceholder]"}, "Ket"], "bra" -> 
  TemplateBox[{"\[SelectionPlaceholder]"}, "Bra"], "braket" -> 
  TemplateBox[{"\[SelectionPlaceholder]", "\[Placeholder]"}, "BraKet"], 
  "delay" -> TemplateBox[{"\[SelectionPlaceholder]"}, "SystemsModelDelay"], 
  "grad" -> RowBox[{
     SubscriptBox["\[Del]", "\[SelectionPlaceholder]"], "\[Placeholder]"}], 
  "del." -> RowBox[{
     SubscriptBox["\[Del]", "\[SelectionPlaceholder]"], ".", 
     "\[Placeholder]"}], "delx" -> RowBox[{
     SubscriptBox["\[Del]", "\[SelectionPlaceholder]"], "\[Cross]", 
     "\[Placeholder]"}], "del2" -> RowBox[{
     SubsuperscriptBox["\[Del]", "\[SelectionPlaceholder]", 2], 
     "\[Placeholder]"}], "notation" -> RowBox[{"Notation", "[", 
     RowBox[{
       TemplateBox[{"\[SelectionPlaceholder]"}, "NotationTemplateTag"], " ", 
       "\[DoubleLongLeftRightArrow]", " ", 
       TemplateBox[{"\[Placeholder]"}, "NotationTemplateTag"]}], "]"}], 
  "notation>" -> RowBox[{"Notation", "[", 
     RowBox[{
       TemplateBox[{"\[SelectionPlaceholder]"}, "NotationTemplateTag"], " ", 
       "\[DoubleLongRightArrow]", " ", 
       TemplateBox[{"\[Placeholder]"}, "NotationTemplateTag"]}], "]"}], 
  "notation<" -> RowBox[{"Notation", "[", 
     RowBox[{
       TemplateBox[{"\[SelectionPlaceholder]"}, "NotationTemplateTag"], " ", 
       "\[DoubleLongLeftArrow]", " ", 
       TemplateBox[{"\[Placeholder]"}, "NotationTemplateTag"]}], "]"}], 
  "symb" -> RowBox[{"Symbolize", "[", 
     TemplateBox[{"\[SelectionPlaceholder]"}, "NotationTemplateTag"], "]"}], 
  "infixnotation" -> RowBox[{"InfixNotation", "[", 
     RowBox[{
       TemplateBox[{"\[SelectionPlaceholder]"}, "NotationTemplateTag"], ",", 
       "\[Placeholder]"}], "]"}], "addia" -> RowBox[{"AddInputAlias", "[", 
     RowBox[{"\"\[SelectionPlaceholder]\"", "\[Rule]", 
       TemplateBox[{"\[Placeholder]"}, "NotationTemplateTag"]}], "]"}], 
  "pattwraper" -> 
  TemplateBox[{"\[SelectionPlaceholder]"}, "NotationPatternTag"], 
  "madeboxeswraper" -> 
  TemplateBox[{"\[SelectionPlaceholder]"}, "NotationMadeBoxesTag"], "=<" -> 
  OverscriptBox["=", "\:02c2"], ":=<" -> OverscriptBox[":=", "\:02c2"]},
FrontEndVersion->"11.1 for Microsoft Windows (64-bit) (April 18, 2017)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 160, 3, 67, "Subchapter", "ExpressionUUID" -> \
"82ce9b8d-b67c-4d11-b354-bb718ca7bf2f"],
Cell[743, 27, 1181, 30, 87, "Text", "ExpressionUUID" -> \
"aa307448-2ee6-43fd-a619-48aadf19d4c3"],
Cell[1927, 59, 1188, 30, 125, "Text", "ExpressionUUID" -> \
"1a6e28fd-3de4-4df0-9d16-4e06a5853ffc"],
Cell[3118, 91, 1053, 28, 106, "Text", "ExpressionUUID" -> \
"2b5aa30d-bf3d-4fbe-833d-a116af279fb1"],
Cell[4174, 121, 967, 27, 87, "Text", "ExpressionUUID" -> \
"48ee3742-9268-4cfc-8415-eb99deb4880c"],
Cell[5144, 150, 1027, 29, 87, "Text", "ExpressionUUID" -> \
"4005f6a9-622e-4c80-86ba-91c9a78b3b48"],
Cell[6174, 181, 904, 28, 106, "Text", "ExpressionUUID" -> \
"5452aee8-20db-4eb5-afab-b0d751f849dd"],
Cell[7081, 211, 1001, 28, 87, "Text", "ExpressionUUID" -> \
"0c6cb691-77ae-45b8-9f8b-c7d0ecbefc00"],
Cell[8085, 241, 928, 27, 87, "Text", "ExpressionUUID" -> \
"abcac081-a000-4d82-bc67-18632f622af0"],
Cell[9016, 270, 684, 20, 68, "Text", "ExpressionUUID" -> \
"a259903f-67f6-4da0-b105-138c0d092ef0"],
Cell[9703, 292, 680, 20, 68, "Text", "ExpressionUUID" -> \
"acae7e66-1b6a-4b83-aee0-af827e67b481"],
Cell[10386, 314, 683, 25, 87, "Text", "ExpressionUUID" -> \
"cf836d7b-31ad-4443-9142-80e693cade9e"],
Cell[11072, 341, 585, 10, 30, "Text", "ExpressionUUID" -> \
"16f921c6-c73f-4b2f-b6b8-162977a27ec2"],
Cell[11660, 353, 340, 7, 49, "Text", "ExpressionUUID" -> \
"0ba00bc7-0aad-4e4a-8b3f-6c9e41a44b00"]
}, Open  ]]
}
]
*)

